Attribute VB_Name = "modPEInfo"
'' File Information Module for PSlHardCodedString.bas
'' (c) 2019-2019 by wanfu (Last modified on 2019.12.14)

'#Uses "modCommon.bas"

Option Explicit

'Android
Private Enum Android_RES_TYPE
    'RES_NULL_TYPE               = &H0000
    RES_STRING_POOL_TYPE        = &H0001
    RES_TABLE_TYPE              = &H0002
    RES_XML_TYPE                = &H0003
    'Chunk types In RES_XML_TYPE
    'RES_XML_FIRST_CHUNK_TYPE    = &H0100
    'RES_XML_START_NAMESPACE_TYPE= &H0100
    'RES_XML_END_NAMESPACE_TYPE  = &H0101
    'RES_XML_START_ELEMENT_TYPE  = &H0102
    'RES_XML_END_ELEMENT_TYPE    = &H0103
    'RES_XML_CDATA_TYPE          = &H0104
    'RES_XML_LAST_CHUNK_TYPE     = &H017F
    'This contains a uint32_t Array mapping strings In the String
    'pool back To resource identifiers.  It Is Optional.
    'RES_XML_RESOURCE_MAP_TYPE   = &H0180
    'Chunk types In RES_TABLE_TYPE
    'RES_TABLE_PACKAGE_TYPE      = &H0200
    'RES_TABLE_TYPE_TYPE         = &H0201
    'RES_TABLE_TYPE_SPEC_TYPE    = &H0202
    'RES_TABLE_LIBRARY_TYPE      = &H0203
End Enum

Private Type ResChunk_header
	RES_TYPE		As Integer	'Type identifier for this chunk
	headerSize		As Integer	'Size of the chunk header (in bytes)
	size			As Long		'Total size of this chunk (in bytes)
End Type

Private Type ResTable_header
	ResChunkHeader As ResChunk_header
	packageCount	As Long		'The number of ResTable_package structures
End Type

Private Type ResStringPool_header
	ResChunkHeader As ResChunk_header
	stringCount		As Long		'Number of strings in this pool
	styleCount		As Long		'Number of style span arrays in the pool
	flags			As Long		'flags
	stringsStart	As Long		'Index from header of the string data
	stylesStart		As Long		'Index from header of the style data
End Type

Private ResChunkHeader		As ResChunk_header
Private ResTableHeader 		As ResTable_header
Private ResStringPoolHeader	As ResStringPool_header


'ȡ Android ļļݽṹϢ
Public Function GetAndroidHeaders(ByVal strFilePath As String,File As FILE_PROPERTIE,ByVal Mode As Long, _
				Optional ByVal Offset As Long = -1,Optional ByVal HeaderID As Integer = -1) As Boolean
	Dim i As Long,FN As FILE_IMAGE
	On Error GoTo ExitFunction
	File.FileSize = FileLen(strFilePath)
	'ļ
	Mode = LoadFile(strFilePath,FN,0,0,0,Mode)
	If Mode < -1 Then Exit Function
	'ȡļͷ
	GetAndroidHeaders = GetAndroidHeader(FN,File,Mode,Offset,HeaderID)
	If GetAndroidHeaders = False Then GoTo ExitFunction
	ExitFunction:
	'رļ
	On Error Resume Next
	UnLoadFile(FN,0,Mode)
End Function


'ȡ Android ļݽṹϢ
Private Function GetAndroidHeader(FN As FILE_IMAGE,File As FILE_PROPERTIE,ByVal Mode As Long, _
				Optional ByVal Offset As Long = -1,Optional ByVal HeaderID As Integer = -1) As Boolean
	Dim i As Long
	Dim tmpResChunkHeader		As ResChunk_header
	Dim tmpResTableHeader 		As ResTable_header
	Dim tmpResStringPoolHeader	As ResStringPool_header
	ReDim File.Header(0)						'As HEADER_PROPERTIE
	ReDim File.Header(0).SecList(1)				'As SECTION_PROPERTIE
	ReDim File.Header(0).SecList(0).SubSecList(0)	'As SUB_SECTION_PROPERTIE
	ReDim File.Header(0).SecList(1).SubSecList(0)	'As SUB_SECTION_PROPERTIE
	ReDim File.Header(0).DataDirectory(0)			'As SUB_SECTION_PROPERTIE
	ReDim File.Header(0).CLRList(0)				'As SUB_SECTION_PROPERTIE
	ReDim File.Header(0).StreamList(0)			'As SUB_SECTION_PROPERTIE
	i = Offset
	If i = -1 Then i = File.FileType
	On Error GoTo ExitFunction
	File.MaxHeaderID = 0
	File.LangType = 0
	With File.Header(0)
		'ʼ
		.Magic = ""
		.FileAlign = 0
		.SecAlign = 0
		.ImageBase = 0
		.DataDirs = 0
		.MinSecID = 0
		.MaxSecID = 0
		.MaxSecIndex = 1
		.USStreamID = -1
		.NumberOfSub = 0
		.NetStreams = 0

		Select Case GetInteger(FN,i,Mode)
		'Case RES_NULL_TYPE          	'= &H0000
		'	.Magic = "Android_RES_NULL_TYPE"
    	Case RES_STRING_POOL_TYPE        '= &H0001
    		.Magic = "Android_RES_STRING_POOL_TYPE"
    		'ȡ ResStringPoolHeader ṹ
			'GetTypeValue(FN,i,tmpResStringPoolHeader,Mode)
			Select Case Mode
			Case Is < 0
				Get #FN.hFile, i + 1, tmpResStringPoolHeader
			Case 0
				CopyMemory tmpResStringPoolHeader, FN.ImageByte(i), Len(tmpResStringPoolHeader)
			Case Else
				MoveMemory tmpResStringPoolHeader, FN.MappedAddress + i, Len(tmpResStringPoolHeader)
			End Select
			If tmpResStringPoolHeader.ResChunkHeader.RES_TYPE <> RES_STRING_POOL_TYPE Then GoTo ExitFunction
			If tmpResStringPoolHeader.StringCount = 0 Then GoTo ExitFunction

			'¼εַ
			.SecList(0).sName = .Magic
			.SecList(0).lPointerToRawData = File.FileType
			.SecList(0).lSizeOfRawData = tmpResStringPoolHeader.ResChunkHeader.Size
			.SecList(0).lVirtualAddress = .SecList(0).lPointerToRawData
			.SecList(0).lVirtualSize = .SecList(0).lSizeOfRawData

			'¼ DataDirectory ַΪִִַõַ
			'ȡ tmpResStringPoolHeader ṹ
			.DataDirectory(0).lPointerToRawData = File.FileType + tmpResStringPoolHeader.stringsStart
			.DataDirectory(0).lSizeOfRawData = tmpResStringPoolHeader.ResChunkHeader.Size - tmpResStringPoolHeader.stringsStart
			.DataDirectory(0).lVirtualAddress = File.FileType + Len(tmpResStringPoolHeader)
			.DataDirectory(0).lVirtualSize = tmpResStringPoolHeader.stringsStart - Len(tmpResStringPoolHeader)
    	Case RES_TABLE_TYPE              '= &H0002
    		.Magic = "Android_RES_TABLE_TYPE"
    		'ȡ tmpResTableHeader ṹ
			'GetTypeValue(FN,i,tmpResTableHeader,Mode)
			Select Case Mode
			Case Is < 0
				Get #FN.hFile, i + 1, tmpResTableHeader
			Case 0
				CopyMemory tmpResTableHeader, FN.ImageByte(i), Len(tmpResTableHeader)
			Case Else
				MoveMemory tmpResTableHeader, FN.MappedAddress + i, Len(tmpResTableHeader)
			End Select
			If tmpResTableHeader.packageCount = 0 Then GoTo ExitFunction

			'ȡ ResStringPoolHeader ṹ
			i = i + Len(tmpResTableHeader)
			'GetTypeValue(FN,i,tmpResStringPoolHeader,Mode)
			Select Case Mode
			Case Is < 0
				Get #FN.hFile, i + 1, tmpResStringPoolHeader
			Case 0
				CopyMemory tmpResStringPoolHeader, FN.ImageByte(i), Len(tmpResStringPoolHeader)
			Case Else
				MoveMemory tmpResStringPoolHeader, FN.MappedAddress + i, Len(tmpResStringPoolHeader)
			End Select
			If tmpResStringPoolHeader.ResChunkHeader.RES_TYPE <> RES_STRING_POOL_TYPE Then GoTo ExitFunction
			If tmpResStringPoolHeader.StringCount = 0 Then GoTo ExitFunction

			'¼εַ
			.SecList(0).sName = .Magic
			.SecList(0).lPointerToRawData = File.FileType
			.SecList(0).lSizeOfRawData = tmpResTableHeader.ResChunkHeader.Size
			.SecList(0).lVirtualAddress = .SecList(0).lPointerToRawData
			.SecList(0).lVirtualSize = .SecList(0).lSizeOfRawData

			'¼ DataDirectory ַΪִִַõַ
			'ȡ tmpResStringPoolHeader ṹ
			.DataDirectory(0).lPointerToRawData = File.FileType + Len(tmpResTableHeader) + tmpResStringPoolHeader.stringsStart
			.DataDirectory(0).lSizeOfRawData = tmpResStringPoolHeader.ResChunkHeader.Size - tmpResStringPoolHeader.stringsStart
			.DataDirectory(0).lVirtualAddress = File.FileType + Len(tmpResTableHeader) + Len(tmpResStringPoolHeader)
			.DataDirectory(0).lVirtualSize = tmpResStringPoolHeader.stringsStart - Len(tmpResStringPoolHeader)
    	Case RES_XML_TYPE                '= &H0003
    		.Magic = "Android_RES_XML_TYPE"
    		'ȡ tmpResChunkHeader ṹ
			'GetTypeValue(FN,i,tmpResChunkHeader,Mode)
			Select Case Mode
			Case Is < 0
				Get #FN.hFile, i + 1, tmpResChunkHeader
			Case 0
				CopyMemory tmpResChunkHeader, FN.ImageByte(i), Len(tmpResChunkHeader)
			Case Else
				MoveMemory tmpResChunkHeader, FN.MappedAddress + i, Len(tmpResChunkHeader)
			End Select

			'ȡ ResStringPoolHeader ṹ
			i = i + Len(tmpResChunkHeader)
			'GetTypeValue(FN,i,tmpResStringPoolHeader,Mode)
			Select Case Mode
			Case Is < 0
				Get #FN.hFile, i + 1, tmpResStringPoolHeader
			Case 0
				CopyMemory tmpResStringPoolHeader, FN.ImageByte(i), Len(tmpResStringPoolHeader)
			Case Else
				MoveMemory tmpResStringPoolHeader, FN.MappedAddress + i, Len(tmpResStringPoolHeader)
			End Select
			If tmpResStringPoolHeader.ResChunkHeader.RES_TYPE <> RES_STRING_POOL_TYPE Then GoTo ExitFunction
			If tmpResStringPoolHeader.StringCount = 0 Then GoTo ExitFunction

			'¼εַ
			.SecList(0).sName = .Magic
			.SecList(0).lPointerToRawData = File.FileType
			.SecList(0).lSizeOfRawData = tmpResChunkHeader.Size
			.SecList(0).lVirtualAddress = .SecList(0).lPointerToRawData
			.SecList(0).lVirtualSize = .SecList(0).lSizeOfRawData

			'¼ִĿʼַʹС
			.DataDirectory(0).lPointerToRawData = File.FileType + Len(tmpResChunkHeader) + tmpResStringPoolHeader.stringsStart
			.DataDirectory(0).lSizeOfRawData = tmpResStringPoolHeader.ResChunkHeader.Size - tmpResStringPoolHeader.stringsStart
			'¼ĿʼַʹС
			.DataDirectory(0).lVirtualAddress = File.FileType + Len(tmpResChunkHeader) + Len(tmpResStringPoolHeader)
			.DataDirectory(0).lVirtualSize = tmpResStringPoolHeader.stringsStart - Len(tmpResStringPoolHeader)
    	'Chunk types In RES_XML_TYPE
    	'Case RES_XML_FIRST_CHUNK_TYPE    '= &H0100
    	'	.Magic = "Android_RES_XML_FIRST_CHUNK_TYPE"
    	'Case RES_XML_START_NAMESPACE_TYPE'= &H0100
    	'	.Magic = "Android_RES_XML_START_NAMESPACE_TYPE"
    	'Case RES_XML_END_NAMESPACE_TYPE  '= &H0101
    	'	.Magic = "Android_RES_XML_END_NAMESPACE_TYPE"
    	'Case RES_XML_START_ELEMENT_TYPE  '= &H0102
    	'	.Magic = "Android_RES_XML_START_ELEMENT_TYPE"
    	'Case RES_XML_END_ELEMENT_TYPE    '= &H0103
    	'	.Magic = "Android_RES_XML_END_ELEMENT_TYPE"
    	'Case RES_XML_CDATA_TYPE          '= &H0104
    	'	.Magic = "Android_RES_XML_CDATA_TYPE"
    	'Case RES_XML_LAST_CHUNK_TYPE     '= &H017F
    	'	.Magic = "Android_RES_XML_LAST_CHUNK_TYPE"
    	'This contains a uint32_t Array mapping strings In the String
    	'pool back To resource identifiers.  It Is Optional.
    	'Case RES_XML_RESOURCE_MAP_TYPE   '= &H0180
    	'	.Magic = "Android_RES_XML_RESOURCE_MAP_TYPE"
    	'Chunk types In RES_TABLE_TYPE
    	'Case RES_TABLE_PACKAGE_TYPE      '= &H0200
    	'	.Magic = "Android_RES_TABLE_PACKAGE_TYPE"
    	'Case RES_TABLE_TYPE_TYPE         '= &H0201
    	'	.Magic = "Android_RES_TABLE_TYPE_TYPE"
    	'Case RES_TABLE_TYPE_SPEC_TYPE    '= &H0202
    	'	.Magic = "Android_ RES_TABLE_TYPE_SPEC_TYPE"
    	'Case RES_TABLE_LIBRARY_TYPE      '= &H0203
    	'	.Magic = "Android_RES_TABLE_LIBRARY_TYPE"
    	Case Else
    		GoTo ExitFunction
		End Select

		'ȡ㷨еĻַ
		.ImageBase = -.DataDirectory(0).lPointerToRawData

		'ȡؽϢ
		.SecList(.MaxSecIndex).lPointerToRawData = .SecList(.MaxSecID).lPointerToRawData + .SecList(.MaxSecID).lSizeOfRawData
		.SecList(.MaxSecIndex).lSizeOfRawData = GetFileLength(FN,Mode) - .SecList(.MaxSecIndex).lPointerToRawData
		.SecList(.MaxSecIndex).lVirtualAddress = .SecList(.MaxSecID).lVirtualAddress + .SecList(.MaxSecID).lVirtualSize
		.SecList(.MaxSecIndex).lVirtualSize = .SecList(.MaxSecIndex).lSizeOfRawData
	End With

	'¼ĸͷ
	If HeaderID > -1 Then
		ResChunkHeader = tmpResChunkHeader
		ResTableHeader = tmpResTableHeader
		ResStringPoolHeader = tmpResStringPoolHeader
	End If

	'ǳɹ
	GetAndroidHeader = True
	Exit Function

	ExitFunction:
	'ReDim File.Header(0)					'As HEADER_PROPERTIE
	ReDim File.Header(0).SecList(1)			'As SECTION_PROPERTIE
	ReDim File.Header(0).DataDirectory(0)	'As SUB_SECTION_PROPERTIE
	ReDim File.Header(0).CLRList(0)			'As SUB_SECTION_PROPERTIE
	ReDim File.Header(0).StreamList(0)		'As SUB_SECTION_PROPERTIE
	File.MaxHeaderID = 0
	File.FileType = 0
	File.LangType = 0
	With File.Header(0)
		.Magic = ""
		.FileAlign = 0
		.SecAlign = 0
		.ImageBase = 0
		.DataDirs = 0
		.MinSecID = 0
		.MaxSecID = 0
		.MaxSecIndex = 1
		.USStreamID = -1
		.NumberOfSub = 0
		.NetStreams = 0
		.SecList(0).SubSecs = 0
		.SecList(1).SubSecs = 0
		'ļΪһ
		.SecList(0).lPointerToRawData = 0
		.SecList(0).lSizeOfRawData = GetFileLength(FN,Mode)
		.SecList(0).lVirtualAddress = 0
		.SecList(0).lVirtualSize = .SecList(0).lSizeOfRawData
		'ؽϢʾļϢ
		.SecList(1).lPointerToRawData = .SecList(0).lSizeOfRawData
		.SecList(1).lSizeOfRawData = 0
		.SecList(1).lVirtualAddress = .0
		.SecList(1).lVirtualSize = 0
	End With
End Function


'ļڳ
'fType = 0 ȡӵֽ޸ԭʼļͷд
'fType = 1 дָȶֽ޸ԭʼļͷд
'fType = 2 дָȶֽ޸ԭʼļͷ
'fType = 3 ޸Ĳд룬ȡֵ(AddSecSize(x).Length ΪƫƴСAddSecSize(x).Address ΪС)
'AddSecSize(x).Length = 0ӵֵӣ AddSecSize(x).Length ֵ
Public Function AddAndroidSectionSize(trnFile As FILE_PROPERTIE,AddSecSize() As FREE_BTYE_SPACE,ByVal fType As Long,ByVal Mode As Long) As Long
	Dim i As Long,j As Integer,k As Long,x As Long,n As Long
	Dim AddRAW As Long
	Dim FN As FILE_IMAGE,TempByte() As Byte,File As FILE_PROPERTIE

	'
	On Error GoTo localError

	'ȡ Android ͷ
	File = trnFile
	If GetAndroidHeaders(File.FilePath,File,Mode,-1,0) = False Then Exit Function

	'޸ļڵĿʼַʹС
	With File.Header(0)
		For i = 0 To UBound(AddSecSize)
			j = AddSecSize(i).inSectionID
			'Ƿڻȡֽ
			If j = .MaxSecID Then
				AddRAW = AddRAW + AddSecSize(i).Length

				'㲢¼λִַλ
				If fType = 0 Then
					AddSecSize(i).Address = .SecList(j).lPointerToRawData + .SecList(j).lSizeOfRawData
					'AddSecSize.inSectionID = j
					AddSecSize(i).inSubSecID = 0
					AddSecSize(i).MaxAddress = AddSecSize(i).Address + AddSecSize(i).Length - 1
					AddSecSize(i).lNumber = -AddSecSize(i).Address
					AddSecSize(i).MoveType = -3	'βλλ		.
				ElseIf fType = 1 Or fType = 2 Then
					'ԭļǰڵƫƵַʹСںʵλ
					AddSecSize(i).Address = trnFile.Header(0).SecList(j).lPointerToRawData
					AddSecSize(i).MaxAddress = AddSecSize(i).Address + trnFile.Header(0).SecList(j).lSizeOfRawData - 1
				End If

				'޸ĵǰڵƫƴСڵƫƵַ
				If AddSecSize(i).Length > 0 Then
					For k = 0 To .MaxSecIndex - 1
						If .SecList(k).lPointerToRawData > .SecList(j).lPointerToRawData Then
							.SecList(k).lPointerToRawData = .SecList(k).lPointerToRawData + AddSecSize(i).Length
							.SecList(k).lVirtualAddress = .SecList(k).lVirtualAddress + AddSecSize(i).Length
						End If
					Next k
					.SecList(j).lSizeOfRawData = .SecList(j).lSizeOfRawData + AddSecSize(i).Length
					.SecList(j).lVirtualSize = .SecList(j).lVirtualSize + AddSecSize(i).Length
				End If
			Else
				AddSecSize(i).Length = 0
			End If
		Next i
		If AddRAW = 0 Then Exit Function
		If fType > 2 Then
			AddAndroidSectionSize = AddRAW
			Exit Function
		End If

		'޸ؽڵƫƵַԭؽڴС
		'¶ȡļļβдִЩֽڽΪؽڱȡҪʹԭʼļؽϢ
		.SecList(.MaxSecIndex).lPointerToRawData = .SecList(.MaxSecID).lPointerToRawData + .SecList(.MaxSecID).lSizeOfRawData
		.SecList(.MaxSecIndex).lVirtualAddress = .SecList(.MaxSecID).lVirtualAddress + .SecList(.MaxSecID).lVirtualSize
		.SecList(.MaxSecIndex).lSizeOfRawData = trnFile.Header(0).SecList(trnFile.Header(0).MaxSecIndex).lSizeOfRawData
		.SecList(.MaxSecIndex).lVirtualSize = trnFile.Header(0).SecList(trnFile.Header(0).MaxSecIndex).lVirtualSize

		'޸Ŀļ
		If fType = 0 Then
			trnFile = File
			AddAndroidSectionSize = AddRAW
			Exit Function
		End If
	End With

	'ļ
	Mode = LoadFile(File.FilePath,FN,0,1,0,Mode)
	If Mode < -1 Then GoTo localError

	'޸ OptionalHeader ݲд
	Select Case File.Header(0).Magic
	Case "Android_RES_STRING_POOL_TYPE"        '= &H0001
		'޸ִشС
		With ResStringPoolHeader.ResChunkHeader
			.Size = .Size + AddRAW
			'If PutTypeValue(FN,File.FileType,ResStringPoolHeader,Mode) = False Then GoTo localError
			Select Case Mode
			Case Is < 0
				Put #FN.hFile,File.FileType + 1,ResStringPoolHeader
			Case 0
				CopyMemory FN.ImageByte(File.FileType),ResStringPoolHeader,Len(ResStringPoolHeader)
			Case Else
				WriteMemory FN.MappedAddress + File.FileType,ResStringPoolHeader,Len(ResStringPoolHeader)
			End Select
		End With
	Case "Android_RES_TABLE_TYPE"              '= &H0002
		'޸ļС
		With ResTableHeader.ResChunkHeader
			.Size = .Size + AddRAW
			'If PutTypeValue(FN,File.FileType,ResTableHeader,Mode) = False Then GoTo localError
			Select Case Mode
			Case Is < 0
				Put #FN.hFile,File.FileType + 1,ResTableHeader
			Case 0
				CopyMemory FN.ImageByte(File.FileType),ResTableHeader,Len(ResTableHeader)
			Case Else
				WriteMemory FN.MappedAddress + File.FileType,ResTableHeader,Len(ResTableHeader)
			End Select
		End With

		'޸ִشС
		With ResStringPoolHeader.ResChunkHeader
			.Size = .Size + AddRAW
			'If PutTypeValue(FN,File.FileType + Len(ResTableHeader),ResStringPoolHeader,Mode) = False Then GoTo localError
			Select Case Mode
			Case Is < 0
				Put #FN.hFile,File.FileType + Len(ResTableHeader) + 1,ResStringPoolHeader
			Case 0
				CopyMemory FN.ImageByte(File.FileType + Len(ResTableHeader)),ResStringPoolHeader,Len(ResStringPoolHeader)
			Case Else
				WriteMemory FN.MappedAddress + File.FileType + Len(ResTableHeader),ResStringPoolHeader,Len(ResStringPoolHeader)
			End Select
		End With
    Case "Android_RES_XML_TYPE"                '= &H0003
    	'޸ļС
		With ResChunkHeader
			.Size = .Size + AddRAW
			'If PutTypeValue(FN,File.FileType,ResChunkHeader,Mode) = False Then GoTo localError
			Select Case Mode
			Case Is < 0
				Put #FN.hFile,File.FileType + 1,ResChunkHeader
			Case 0
				CopyMemory FN.ImageByte(File.FileType),ResChunkHeader,Len(ResChunkHeader)
			Case Else
				WriteMemory FN.MappedAddress + File.FileType,ResChunkHeader,Len(ResChunkHeader)
			End Select
		End With

		'޸ִشС
		With ResStringPoolHeader.ResChunkHeader
			.Size = .Size + AddRAW
			'If PutTypeValue(FN,File.FileType + Len(ResChunkHeader),ResStringPoolHeader,Mode) = False Then GoTo localError
			Select Case Mode
			Case Is < 0
				Put #FN.hFile,File.FileType + Len(ResChunkHeader) + 1,ResStringPoolHeader
			Case 0
				CopyMemory FN.ImageByte(File.FileType + Len(ResChunkHeader)),ResStringPoolHeader,Len(ResStringPoolHeader)
			Case Else
				WriteMemory FN.MappedAddress + File.FileType + Len(ResChunkHeader),ResStringPoolHeader,Len(ResStringPoolHeader)
			End Select
		End With
	End Select

	'СƫƵַԱԭڱչ
	Call SortFreeByteByAddress(AddSecSize,0,UBound(AddSecSize),False)

	'λҪӴСڽںÿڣڽβӿҪӵĿֽ
	n = UBound(AddSecSize)
	For i = n To 0 Step -1
		With AddSecSize(i)
			j = AddSecSize(i).inSectionID
			'ȡǰںȫֽڳ
			If i = n Then
				If j = File.Header(0).MaxSecID Then
					'ڻȡļͷʱ»ȡļСչʱչǰдִ
					'ҪʹԭļСЩдִᱻƵ
					k = trnFile.FileSize - .MaxAddress - 1
				Else
					k = File.FileSize - .MaxAddress - 1
				End If
			Else
				k = AddSecSize(i + 1).MaxAddress - .MaxAddress + .Length
			End If
			'λֽڵǰڵַ
			If k > 0 Then
				TempByte = GetBytes(FN,k,.MaxAddress + 1,Mode)
				PutBytes(FN,File.Header(0).SecList(j).lPointerToRawData + File.Header(0).SecList(j).lSizeOfRawData,TempByte,k,Mode)
			End If

			'ӵǰںĿֽ(ÿ)
			'¶ȡļļβдִЩֽڽΪؽڱȡҪʹԭʼļؽϢ
			If .Length > 0 Then
				'ʹСΪСΪںֽ( PE)
				If j = File.Header(0).MaxSecID And trnFile.Header(0).SecList(trnFile.Header(0).MaxSecIndex).lVirtualSize < 1 Then
					x = GetFileLength(FN,Mode)
					k = trnFile.FileSize + .Length - x
					If k > 0 Then
						ReDim TempByte(k - 1) As Byte
						PutBytes(FN,x,TempByte,k,Mode)
					End If
				Else
					ReDim TempByte(.Length - 1) As Byte
					PutBytes(FN,.MaxAddress + 1,TempByte,.Length,Mode)
				End If
			End If
		End With
	Next i
	UnLoadFile(FN,FN.SizeOfFile,Mode)
	AddAndroidSectionSize = AddRAW

	'޸Ŀļ
	If fType = 2 Then trnFile = File
	Exit Function

	'ȫ˳
	localError:
	UnLoadFile(FN,0,Mode)
	AddAndroidSectionSize = -1
End Function
