'' Reference Search for Passolo
'' (c) 2015 - 2019 by wanfu (Last modified on 2020.02.01)

'' Command Line Format: Command <FilePath> <-add:Address> <-lng:Hex Language Code>
'' Command: Name of this Macros file
'' FilePath: Full path of PE file
'' Address: Offset of Dec or Hex, if Hex, use like "0xFFFF" format
'' Hex Language Code: Display UI Language. Supports EngLish, Chinese Simplified and Chinese Traditional only. For sample: 0804,1004,0404,0C04,1404.
'' Return: No
'' For example: modRefernceSearch,"d:\my folder\my file.exe" -add:35148 -lng:0804

Option Explicit

Private Const Version = "2019.12.20"
Private Const Build = "191220"
Private Const JoinStr = vbFormFeed  'vbBack
Private Const TextJoinStr = vbCrLf
Private Const RefJoinStr = "|"
Private Const LoadMode = 0&
Private Const AppName = "Reference Search"
Private Const RefFrontChar64 = "[\x0F\x4C\x48\x8B\xF2][\x05\x10\x0F\x8B\x8D\xB7][\x00-\xFF]{3}"
Private Const NewPESecName = ".movehcs"
Private Const NewMacSecName = "__MOVEHCS"

'дԻƽ̨
Private Enum PELangType
	DELPHI_FILE_SIGNATURE = &H50
	NET_FILE_SIGNATURE = &H424A5342
End Enum

'PEļṹ(Visual Basic)ִһ
'ǩ
Private Enum ImageSignatureTypes
	IMAGE_DOS_SIGNATURE = &H5A4D			'// MZ
	IMAGE_OS2_SIGNATURE = &H454E			'// NE
	IMAGE_OS2_SIGNATURE_LE = &H454C			'// LE
	IMAGE_VXD_SIGNATURE = &H454C			'// LE
	IMAGE_NT_SIGNATURE = &H4550				'// PE00
End Enum

'ж32λ64λPEļ
Private Enum ImageOptionalHeaderMagicType
	IMAGE_NT_OPTIONAL_HDR32_MAGIC = &H10B			'32λPEļ
	IMAGE_NT_OPTIONAL_HDR64_MAGIC = &H20B			'64λPEļ
End Enum

'ļ(־)
'IMAGE_FILE.Characteristics
'Private Enum ImageFileCharacteristicsTypes
'	IMAGE_FILE_RELOCS_STRIPPED = &H1				'ضλϢƳ
'	IMAGE_FILE_EXECUTABLE_IMAGE = &H2				'ļִ
'	IMAGE_FILE_LINE_NUMS_STRIPPED = &H4				'кűƳ
'	IMAGE_FILE_LOCAL_SYMS_STRIPPED = &H8			'űƳ
'	IMAGE_FILE_AGGRESIVE_WS_TRIM = &H10				'Agressively Trim working Set
'	IMAGE_FILE_LARGE_ADDRESS_AWARE = &H20			'ܴ2Gĵַ
'	IMAGE_FILE_BYTES_REVERSED_LO = &H80				'Ļ͵λ
'	IMAGE_FILE_32BIT_MACHINE = &H100				'32λ
'	IMAGE_FILE_DEBUG_STRIPPED = &H200				'.dbgļĵϢƳ
'	IMAGE_FILE_REMOVABLE_RUN_FROM_SWAP = &H400		'ƶ,ļ
'	IMAGE_FILE_NET_RUN_FROM_SWAP = &H800			',ļ
'	IMAGE_FILE_SYSTEM = &H1000						'ϵͳļ
'	IMAGE_FILE_DLL = &H2000							'ļһdll
'	IMAGE_FILE_UP_SYSTEM_ONLY = &H4000				'ļֻڵ
'	IMAGE_FILE_BYTES_REVERSED_HI = &H8000			'Ļ͸λ.
'End Enum

'ӦóִеĻƽ̨붨
'IMAGE_FILE_HEADER.iMachine
'======================================================================================
'Private Enum ImageFileMachineTypes
'	IMAGE_FILE_MACHINE_UNKNOWN = &H0		'δ֪
'	IMAGE_FILE_MACHINE_I386 = &H14C			'Intel 80386 
'	IMAGE_FILE_MACHINE_I486 = &H14D			'Intel 80486 
'	IMAGE_FILE_MACHINE_IPTM = &H14E			'Intel Pentium 
'	IMAGE_FILE_MACHINE_R 	= &H160			'R3000(MIPS)big endian
'	IMAGE_FILE_MACHINE_R3000 = &H162		'R3000(MIPS)little endian
'	IMAGE_FILE_MACHINE_R4000 = &H166		'R4000(MIPS)little endian
'	IMAGE_FILE_MACHINE_R10000 = &H168		'R10000(MIPS)little endian
'	IMAGE_FILE_MACHINE_WCEMIPSV2 = &H169	'MIPS Little-endian WCE v2
'	IMAGE_FILE_MACHINE_ALPHA = &H184		'DEC Alpha AXP
'	IMAGE_FILE_MACHINE_POWERPC= &H1F0		'IBM Power PClittle endian
'	IMAGE_FILE_MACHINE_SH3 = &H1A2			'SH3 little-endian
'	IMAGE_FILE_MACHINE_SH3E = &H1A4			'SH3E little-endian
'	IMAGE_FILE_MACHINE_SH4 = &H1A6			'SH4 little-endian
'	IMAGE_FILE_MACHINE_SH5 = &H1A8			'SH5
'	IMAGE_FILE_MACHINE_ARM = &H1C0			'ARM Little-Endian
'	IMAGE_FILE_MACHINE_THUMB = &H1C2
'	IMAGE_FILE_MACHINE_ARM33 = &H1D3
'	IMAGE_FILE_MACHINE_IA64 = &H200			'Intel 64
'	IMAGE_FILE_MACHINE_MIPS16 = &H266		'MIPS
'	IMAGE_FILE_MACHINE_ALPHA64 = &H284		'ALPHA64
'	IMAGE_FILE_MACHINE_MIPSFPU = &H366		'MIPS
'	IMAGE_FILE_MACHINE_MIPSFPU16 = &H466	'MIPS
'	IMAGE_FILE_MACHINE_AMD64 = &H500		'AMD K8
'	IMAGE_FILE_MACHINE_TRICORE = &H520		'Infineon
'	IMAGE_FILE_MACHINE_CEF = &HCEF
'	IMAGE_FILE_MACHINE_AMD64 = &H8664  		'AMD64 (K8)
'End Enum

'Ŀ¼
'======================================================================================
'Private Enum ImageDirectoryEntry
'	IMAGE_DIRECTORY_ENTRY_EXPORT = 0				'Ŀ¼
'	IMAGE_DIRECTORY_ENTRY_IMPORT = 1				'Ŀ¼
'	IMAGE_DIRECTORY_ENTRY_RESOURCE = 2				'ԴĿ¼
'	IMAGE_DIRECTORY_ENTRY_EXCEPTION = 3				'쳣Ŀ¼
'	IMAGE_DIRECTORY_ENTRY_SECURITY = 4				'ȫĿ¼
'	IMAGE_DIRECTORY_ENTRY_BASERELOC = 5				'ضλ
'	IMAGE_DIRECTORY_ENTRY_DEBUG = 6					'Ŀ¼
'	IMAGE_DIRECTORY_ENTRY_COPYRIGHT = 7				'X86ʹ-
'	IMAGE_DIRECTORY_ENTRY_ARCHITECTURE = 7			'Architecture Specific Data
'	IMAGE_DIRECTORY_ENTRY_GLOBALPTR = 8				'ֵ(MIPS GP), RVA of GlobalPtr
'	IMAGE_DIRECTORY_ENTRY_TLS = 9					'̱߳ش洢(Thread Local Storage,TLS)Ŀ¼
'	IMAGE_DIRECTORY_ENTRY_LOAD_CONFIG = 10			'Ŀ¼
'	IMAGE_DIRECTORY_ENTRY_BOUND_IMPORT = 11			'(Bound Import Directory in headers)
'	IMAGE_DIRECTORY_ENTRY_IAT = 12					'ַ
'	IMAGE_DIRECTORY_ENTRY_DELAY_IMPORT = 13			'Delay Load Import Descriptors
'	IMAGE_DIRECTORY_ENTRY_COM_DESCRIPTOR = 14		'COM б־
'	IMAGE_DIRECTORY_ENTRY_RESERVED = 15				'
'End Enum

'Զ
Private Enum ImageSectionType
	IMAGE_SCN_CNT_CODE = &H20						'а
	IMAGE_SCN_CNT_INITIALIZED_DATA = &H40			'аѳʼ
	IMAGE_SCN_CNT_UNINITIALIZED_DATA = &H80			'аδʼ
	IMAGE_SCN_MEM_DISCARDABLE = &H2000000			'һɶĽڣеڽ̿ʼ󽫱
	IMAGE_SCN_MEM_NOT_CACHED = &H4000000			'ݲ
	IMAGE_SCN_MEM_NOT_PAGED = &H8000000				'ݲڴ
	IMAGE_SCN_MEM_SHARED = &H10000000				'ݿɹ
	IMAGE_SCN_MEM_EXECUTE = &H20000000				'ִн
	IMAGE_SCN_MEM_READ = &H40000000					'ɶ
	IMAGE_SCN_MEM_WRITE = &H80000000				'д
End Enum

'Դ
'======================================================================================
'Private Enum ImageResourceEntry
'	IMAGE_RESOURCE_CURSOR = 1						'						'
'	IMAGE_RESOURCE_BITMAP = 2						'λͼ
'	IMAGE_RESOURCE_ICON = 3							'ͼ
'	IMAGE_RESOURCE_MENU = 4							'˵
'	IMAGE_RESOURCE_DIALOG = 5						'Ի
'	IMAGE_RESOURCE_STRING_TABLE = 6					'ַ
'	IMAGE_RESOURCE_FONT_DIRECTORY = 7				'Ŀ¼
'	IMAGE_RESOURCE_FONT	= 8							'
'	IMAGE_RESOURCE_ACCELERATORS = 9					'
'	IMAGE_RESOURCE_UNFORMATTED_RESOURCE_DATA = 10	'δʽԴ
'	IMAGE_RESOURCE_MESSAGE_TABEL = 11				'Ϣ
'	IMAGE_RESOURCE_GROUP_CURSOR = 12				'
'	IMAGE_RESOURCE_GROUP_ICON = 13					'ͼ
'	IMAGE_RESOURCE_VERSION_INFO = 14				'汾Ϣ
'End Enum

'======================================================================================
'ṹ: IMAGE_DOS_HEADER
'ṹС: 64ֽ
'ṹ˵: DOSӳͷ(EXEͷ)
'======================================================================================
Private Type IMAGE_DOS_HEADER
	iSignature						As Integer		'&H0    ǩ("MZ",&H5A4D)
	iLastPageBytes					As Integer		'&H2    ļҳеֽ
	iPages							As Integer		'&H4    ļҳ
	iRelocateItems					As Integer		'&H6    ضλԪظ
	iHeaderSize						As Integer		'&H8    ͷС
	iMinAlloc						As Integer		'&HA    СӶ
	iMaxAlloc						As Integer		'&HC    󸽼Ӷ
	iInitialSS						As Integer		'&HE    ʼSSֵ
	iInitialSP						As Integer		'&H10   ʼSPֵ
	iCheckSum						As Integer		'&H12   У
	iInitialIP						As Integer		'&H14   ʼIPֵ
	iInitialCS						As Integer		'&H16   ʼCSֵ(ƫ)
	iRelocateTable					As Integer		'&H18   ضļַ
	iOverlay						As Integer		'&H1A   Ǻ
	iReserved(3)					As Integer		'&H22   
	iOEMID							As Integer		'&H24   OEMʶ
	iOEMInformation					As Integer		'&H26   OEMϢ
	iReserved2(9)					As Integer		'&H28   2
	lPointerToPEHeader				As Long			'&H3C   PEͷλ
End Type

'======================================================================================
'ṹ: IMAGE_FILE_HEADER
'ṹС: 24ֽ
'ṹ˵: ӳļͷ
'======================================================================================
Private Type IMAGE_FILE_HEADER
	lSignature						As Long			'&H4	PEļͷ־("PE00",&H4550),4ֽ
	iMachine						As Integer		'&H6    ִиóĻƽ̨
	iNumberOfSections				As Integer		'&H8    ļнڵĸ
	lTimeDateStamp					As Long			'&HC    ļʱ(ʱ)
	lPointerToSymbolTable			As Long			'&H10   COFFűƫ
	lNumberOfSymbols				As Long			'&H14   Ŀ
	iSizeOfOptionalHeader			As Integer		'&H16   ѡͷС
	iCharacteristics				As Integer		'&H18   ־
End Type

'======================================================================================
'ṹ: IMAGE_DATA_DIRECTORY
'ṹС: ÿĿ¼8ֽڣ16Ŀ¼120ֽ
'ṹ˵: Ŀ¼
'0 = Ŀ¼
'1 = Ŀ¼
'2 = ԴĿ¼
'3 = 쳣Ŀ¼
'4 = ȫĿ¼
'5 = ַضλ
'6 = Ŀ¼
'7 = ȨĿ¼
'8 = ֵ(GP RVA)
'9 = ̱߳ش洢
'10 = Ŀ¼
'11 = 󶨵Ŀ¼
'12 = ַ
'13 = ӳټص
'14 = COM п־(.NET  RVA = CLR ַSize = CLR header ĴС̶Ϊ48ֽ)
'15 = Ŀ¼
'======================================================================================
Private Type IMAGE_DATA_DIRECTORY
	lVirtualAddress			As Long			'ʼRVAַ
	lSize					As Long			'lVirtualAddressָݽṹֽ
End Type

'======================================================================================
'ṹ: IMAGE_OPTIONAL_HEADER32
'ṹС: 224ֽ
'ṹ˵: ѡӳͷ
'======================================================================================
Private Type IMAGE_OPTIONAL_HEADER32
	'******************
	'׼
	'******************
	iMagic							As Integer		'&H18   32λPE&H10B64λPE&H20B
	bMajorLinkerVersion				As Byte			'&H1A   汾
	bMinorLinkerVersion				As Byte			'&H1B   ΰ汾
	lSizeOfCode						As Long			'&H1C   ִд볤
	lSizeOfInitializedData			As Long			'&H20   ʼݳ(ݽ)
	lSizeOfUninitializedData		As Long			'&H24   δʼݳ(bss)
	lAddressOfEntryPoint			As Long			'&H28   RVAַ,⿪ʼִ
	lBaseOfCode						As Long			'&H2C   ִдʼλ
	lBaseOfData						As Long			'&H30   ʼʼλ
	'******************
	'NT 
	'******************
	lImageBase						As Long			'&H34   ѡRVAַ(32λ)
	lSectionAlignment				As Long			'&H38   غڴеĶ뷽ʽ
	lFileAlignment					As Long			'&H3C   ļеĶ뷽ʽ
	iMajorOperatingSystemVersion	As Integer		'&H40   ϵͳ汾
	iMinorOperatingSystemVersion	As Integer		'&H42   ϵͳΰ汾
	iMajorImageVersion				As Integer		'&H44   ִļ汾
	iMinorImageVersion				As Integer		'&H46   ִļΰ汾
	iMajorSubsystemVersion			As Integer		'&H48   ϵͳ汾
	iMinorSubsystemVersion			As Integer		'&H50   ϵͳΰ汾
	lWin32VersionValue				As Long			'&H52   Win32汾,һΪ0
	lSizeOfImage					As Long			'&H56   ռڴС(С)
	lSizeOfHeaders					As Long			'&H5A   ͷС(ƫƴС)
	lCheckSum						As Long			'&H5E   У
	iSubsystem						As Integer		'&H62   ִļϵͳ
	iDllCharacteristics				As Integer		'&H64   ʱDllMain,һΪ0
	lSizeOfStackReserve				As Long			'&H66   ʼ߳ʱջС
	lSizeOfStackCommit				As Long			'&H6A   ʼ߳ʱύջС
	lSizeOfHeapReserve				As Long			'&H6E   ̳ʼʱջС
	lSizeOfHeapCommit				As Long			'&H72   ̳ʼʱύջС
	lLoaderFlags					As Long			'&H76   װر־,
	lNumberOfRvaAndSizes			As Long			'&H7A   Ŀ¼,һΪ16
	DataDirectory(15) 				As IMAGE_DATA_DIRECTORY			'DataDirectory(14)
End Type

'======================================================================================
'ṹ: IMAGE_OPTIONAL_HEADER64
'ṹС: 240ֽ
'ṹ˵: ѡӳͷ
'======================================================================================
Private Type IMAGE_OPTIONAL_HEADER64
	'******************
	'׼
	'******************
	iMagic							As Integer		'&H18   32λPE&H10B64λPE&H20B
	bMajorLinkerVersion				As Byte			'&H1A   汾
	bMinorLinkerVersion				As Byte			'&H1B   ΰ汾
	lSizeOfCode						As Long			'&H1C   ִд볤
	lSizeOfInitializedData			As Long			'&H20   ʼݳ(ݽ)
	lSizeOfUninitializedData		As Long			'&H24   δʼݳ(bss)
	lAddressOfEntryPoint			As Long			'&H28   RVAַ,⿪ʼִ
	lBaseOfCode						As Long			'&H2C   ִдʼλ
	'lBaseOfData					As Long			'&H30   ʼʼλ
	'******************
	'NT 
	'******************
	dImageBase(7)					As Byte			'&H34   ѡRVAַ(64λ)
	lSectionAlignment				As Long			'&H38   غڴеĶ뷽ʽ
	lFileAlignment					As Long			'&H3C   ļеĶ뷽ʽ
	iMajorOperatingSystemVersion	As Integer		'&H40   ϵͳ汾
	iMinorOperatingSystemVersion	As Integer		'&H42   ϵͳΰ汾
	iMajorImageVersion				As Integer		'&H44   ִļ汾
	iMinorImageVersion				As Integer		'&H46   ִļΰ汾
	iMajorSubsystemVersion			As Integer		'&H48   ϵͳ汾
	iMinorSubsystemVersion			As Integer		'&H50   ϵͳΰ汾
	lWin32VersionValue				As Long			'&H52   Win32汾,һΪ0
	lSizeOfImage					As Long			'&H56   ռڴС(С)
	lSizeOfHeaders					As Long			'&H5A   ͷС(ƫƴС)
	lCheckSum						As Long			'&H5E   У
	iSubsystem						As Integer		'&H62   ִļϵͳ
	iDllCharacteristics				As Integer		'&H64   ʱDllMain,һΪ0
	dSizeOfStackReserve				As Double		'&H66   ʼ߳ʱջС(64λ)
	dSizeOfStackCommit				As Double		'&H6A   ʼ߳ʱύջС(64λ)
	dSizeOfHeapReserve				As Double		'&H6E   ̳ʼʱջС(64λ)
	dSizeOfHeapCommit				As Double		'&H72   ̳ʼʱύջС(64λ)
	lLoaderFlags					As Long			'&H76   װر־,
	lNumberOfRvaAndSizes			As Long			'&H7A   Ŀ¼,һΪ16
	DataDirectory(15) 				As IMAGE_DATA_DIRECTORY
End Type

'======================================================================================
'ṹ: IMAGE_SECTION_HEADER
'ṹС: 40ֽ
'ṹ˵: ӳͷ
'======================================================================================
Private Type IMAGE_SECTION_HEADER
	sName(7)						As Byte			'&H0    (8ַֽ)
	'lPhysicalAddress				As Long			'&H8    OBJļбʾڵַ
	lVirtualSize					As Long			'&H8    EXEļбʾڵʵֽ
	lVirtualAddress					As Long			'&HC    ڵRVA
	lSizeOfRawData					As Long			'&H10   ھļĳߴ
	lPointerToRawData				As Long			'&H14   ԭʼļеλ
	lPointerToRelocations			As Long			'&H18   OBJļбʾضλϢƫ,EXEļ
	lPointerToLineNumbers			As Long			'&H1C   кƫ
	iNumberOfRelocations			As Integer		'&H20   ضλĿ
	iNumberOfLineNumbers			As Integer		'&H22   кűекĿ
	lCharacteristics				As Long			'&H24   
End Type

'======================================================================================
'ṹ: .NET CLR 2.0 ͷṹ
'ṹС: 72ֽ
'ṹ˵: CLR ͷ
'======================================================================================
Private Type IMAGE_CLR20_HEADER
	'Header versioning
	cb						As Long					'CLRͷĴСbyteΪλ
	MajorRuntimeVersion		As Integer				'иóС.NET汾汾
	MinorRuntimeVersion		As Integer				'иó.NET汾ĸ汾

	'Symbol table And startup information
	METADATA				As IMAGE_DATA_DIRECTORY	'ԪݵRVASize
	Flags					As Long					'ֶΣIL.corflagsʽã
													'Ҳڱʱ/FLAGSѡãõȼϸ
	EntryPointToken			As Long					'ڷԪIDҲtokenEXEļУ
													'DLLļдΪ0.NET 2.0УǱڴRVAֵ
	'Binding information
	Resources				As IMAGE_DATA_DIRECTORY	'йԴRVASize
	StrongNameSignature		As IMAGE_DATA_DIRECTORY	'ǿݵRVASizeǿƵںܣ

	'Regular fixup And binding information
	CodeManagerTable		As IMAGE_DATA_DIRECTORY	'CodeManagerTableRVASizeδʹãΪ0
    VTableFixups			As IMAGE_DATA_DIRECTORY	'v-tableRVASizeҪʹv-tableC++Խضλ
    ExportAddressTableJumps	As IMAGE_DATA_DIRECTORY	'C++תַRVASizeΪ0

    'Precompiled image info (internal use only - Set To zero)
    ManagedNativeHeader		As IMAGE_DATA_DIRECTORY	'ngenɱģиΪ0Ϊ0
End Type

'Ŀ¼ CLR Header Flags
'======================================================================================
'Private Enum CLR_HEADER_FLAGES
'	COMIMAGE_FLAGS_ILONLY = &H1				'CLRɴIL
'	COMIMAGE_FLAGS_32BITREQUIRED = &H2		'CLRӳֻ32λϵͳִ
'	COMIMAGE_FLAGS_IL_LIBRARY = &H4			'CLRӳΪILڵ
'	COMIMAGE_FLAGS_STRONGNAMESIGNED = &H8	'ļܵǿǩı
'	COMIMAGE_FLAGS_NATIVE_ENTRYPOINT =&H8	'˳ڷΪй
'	COMIMAGE_FLAGS_TRACKDEBUGDATA = &H10000	'LoaderJITҪ׷ٵϢȱʡ0
'End Enum

'======================================================================================
'ṹ: .NET MetaData ͷṹ
'ṹС: ̶
'ṹ˵: MetaData ͷ
'======================================================================================
Private Type IMAGE_METADATA_HEADER
	lSignature		As Long   		'Magic signature For physical metadata, currently 0x424A5342(BSJB Ϊ.Net ļı־)
	iMajorVersion	As Integer		'Major version (1 for the first release of the common language runtime)
	iMinorVersion	As Integer		'Minor Version (1 For the first release of the common language runtime)
	lExtraData		As Long			'Reserved, always 0
	lLength			As Long			'Length of Version String In bytes
	Version()		As Byte			'汾ַ, UTF8 룬4ֽڶ
	fFlags			As Integer		'Reserved, always 0
	iStreams		As Integer		'Number of streams
	'StreamHeader()	As IMAGE_STREAM_HEADER
End Type

'======================================================================================
'ṹ: .NET Stream ͷṹ
'ṹС: 72ֽ
'ṹ˵: Stream ͷ
'
'#Strings: UTF8ʽַѣԪݵƣԱȣ
'          ײһ0Ϊַַ0ʾβCLRЩƵ󳤶1024
'#Blob:    ݶѣ洢еķַϢ糣ֵsignaturePublicKeyȡ
'          ÿݵĳɸݵǰ13λ0ʾȣֽڣ10ʾ2ֽڣ110ʾ4ֽڡ
'#GUID:    洢еȫΨһʶGlobal Unique Identifier
'#US:      UnicodeʽŵILʹõûַUser Stringldstrõַ
'#~:       ԪݱҪеԪϢԱʽڴˡÿ.Net 򶼱
'#-:       #~δѹΪδŻ洢
'======================================================================================
Private Type IMAGE_STREAM_HEADER
	lOffset			As Long			' Metadata Root ڴƫ
	lSize			As Long			'ֽڴС4 ı
	rcName()		As Byte			'Կֹֽ ASCII ַ飬4ֽڶ
	RWA				As Long			'ݼ¼ƫƵַ (ʵûֵֻΪ˷㶨λλ)
End Type

'#Blob
'#Blobһݶѣезַʽݶѷ棬
'糣ֵPublic KeyֵSignatureȵȡ
'ÿݿͷһ鳤ݣΪ˽Լ洢ռ䣬CLRʹ˱Ƚ鷳ı뷽
'ʼһֽλΪ0ݿ鳤Ϊһֽڣ
'ʼһֽλΪ10ݿ鳤Ϊֽڣ
'ʼһֽλΪ110ݿ鳤Ϊĸֽڣ
'α־λͨλ㼴ɼݿʵʳֵݴ˻ݡ

'#US
'һBlobѣûԶַ
'˶ûеַЩַUTF-16ıʽ棬ŶһβΪ01ֽڣ
'ַָǷд0x007FĴַ
'βֽڱӵϵûַɵַϵĴת
'ȤǣûַᱻԪݱõʾرILַʹldstrָ
'⣬ΪһʵϵblobѣUSѲԴ洢UnicodeַԴ洢ƶʹЩȤʵֳΪܡ

'======================================================================================
'ṹ: .NET #~ Stream ṹ
'ṹС: 24ֽ
'ṹ˵: #~ Streamǿǩص
'======================================================================================
'Private Type TClrTableStreamHeader
'	Reserved		As Long			'Ϊ0
'	MajorVersion	As Byte			'Ԫݱ汾ţ.Net汾һ
'	MinorVersion	As Byte			'Ԫݱĸ汾ţһΪ0
'	HeapSizes		As Byte			'heaps жλʱĴСΪ0ʾ16λֵ
									'ݳ16λݱʾΧʹ32λֵ
									'01h strings ѣ02h GUID ѣ04h blob 
									'#-пΪ20h80hǰߴаEdit-and-Continueĵ޸ĵݣ
									'߱ʾԪиʶΪɾ
'	Rid				As Byte			'Ԫݱм¼ֵʱ.Net㣬ļͨΪ1
'	MaskValid		As Double		'8ֽڳȵ룬ÿλһΪ1ʾñЧΪ0ʾ޸ñ
'	Sorted			As Double		'8ֽڳȵ룬ÿλһΪ1ʾñ򣬷֮Ϊ0
'End Type


Private Type mac_header_32  '28ֽ
	lmagic				As Long		'mach magic number identifier
	lcputype			As Long		'cpu specifier (int)
	lcpusubtype			As Long		'machine specifier (int)
	lfiletype			As Long		'type of file
	lncmds				As Long		'ָжٸCommand
	lsizeofcmds			As Long		'ָLoadCommandܵĴС
	lflags				As Long		'file offset to this object file
End Type

Private Type mac_header_64  '32ֽ
	lmagic				As Long		'mach magic number identifier
	lcputype			As Long		'cpu specifier (int)
	lcpusubtype			As Long		'machine specifier (int)
	lfiletype			As Long		'type of file
	lncmds				As Long		'ָжٸCommand
	lsizeofcmds			As Long		'ָLoadCommandܵĴС
	lflags				As Long		'file offset to this object file
	lreserved			As Long
End Type
'magic: Կļеʼ֣ cafe babeͷ
'       һ ļ ÿͶļֽʶħͬ͵ ļԼص"ħ"
'       OS XϣִļıʶħͬħͬĿִļͣ
'       mach-oļħ0xfeedface32λ0xfeedfacf64λcafebabeǿ紦ܹͨøʽ#!ǽűļ
'cputype  cupsubtype: cpuͺͣͼϵģcpuṹx86_64,ֱӲ鿴ipaԿcpuarmsubtypearmv7arm64
'#define CPU_TYPE_ARM((cpu_type_t) 12)
'#define CPU_SUBTYPE_ARM_V7((cpu_subtype_t) 9
'filetype: &H2 ִеļ
'ncmds: ָǼ(load commands)һ650-64
'sizeofcmds: ʾ23load commandsֽڴСload commandsǽheaderġ
'flags: 000200085԰ĵ֮

'ӿļ
Private Type mac_header_fat_arch	'20ֽ
	lcputype			As Long		'CPU specifier
	lcpusubtype			As Long		'Machine specifier
	lfileoffset			As Long		'Offset of header in file
	lsize				As Long		'size of object file
	lalign				As Long		'Alignment As a power of two
End Type

'ӿļ
Private Type mac_header_fat  '32ֽ
	lmagic				As Long		'mach magic number identifier
	lfat_arch_size		As Long		'Number of fat_arch structs
	fat_archs() 		As mac_header_fat_arch
End Type

'Constants for the magic field of the mach_header
Private Enum mac_header_magic
	MH_MAGIC_32			= &HFEEDFACE		' 32-bit mach Object file
	MH_MAGIC_64			= &HFEEDFACF		' 64-bit mach Object file
	MH_MAGIC_FAT		= &HCAFEBABE		' Universal Object file / FAT_MAGIC
	MH_MAGIC_FAT_CIGAM	= &HBEBAFECA
End Enum

'Constants for the filetype field of the mach_header
Private Enum mac_header_filetype
	MH_OBJECT			= &H1			'relocatable Object file
	MH_EXECUTE			= &H2			'demand paged executable file
	MH_FVMLIB			= &H3			'fixed VM Shared library file
	MH_CORE				= &H4			'core file
	MH_PRELOAD			= &H5			'preloaded executable file
	MH_DYLIB			= &H6			'dynamically bound Shared library
	MH_DYLINKER			= &H7			'dynamic link editor
	MH_BUNDLE			= &H8			'dynamically bound bundle file
	MH_DYLIB_STUB		= &H9			'Shared library stub For Static
	MH_DSYM				= &HA			'companion file With only Debug
	MH_KEXT_BUNDLE		= &HB			'x86_64 kexts
End Enum

'Constants for the mac_header_flags field
Private Enum mac_header_flags
	MH_NOUNDEFS					= &H1			'Ŀǰûδķţ
	MH_INCRLINK					= &H2
	MH_DYLDLINK					= &H4			'ļdyldļ޷ٴξ̬
	MH_BINDATLOAD				= &H8
	MH_PREBOUND					= &H10
	MH_SPLIT_SEGS				= &H20
	MH_LAZY_INIT				= &H40
	MH_TWOLEVEL					= &H80			'þļʹ2ƿռ
	MH_FORCE_FLAT				= &H100
	MH_NOMULTIDEFS				= &H200
	MH_NOFIXPREBINDING			= &H400
	MH_PREBINDABLE				= &H800
	MH_ALLMODSBOUND				= &H1000
	MH_SUBSECTIONS_VIA_SYMBOLS	= &H2000
	MH_CANONICAL				= &H4000
	MH_WEAK_DEFINES				= &H8000
	MH_BINDS_TO_WEAK			= &H10000		'ӵľļʹ
	MH_ALLOW_STACK_EXECUTION	= &H20000
	MH_ROOT_SAFE				= &H40000
	MH_SETUID_SAFE				= &H80000
	MH_NO_REEXPORTED_DYLIBS		= &H100000
	MH_PIE						= &H200000		'سĵַռ䣬ֻ MH_EXECUTEʹ
	MH_DEAD_STRIPPABLE_DYLIB	= &H400000
	MH_HAS_TLV_DESCRIPTORS		= &H800000
	MH_NO_HEAP_EXECUTION		= &H1000000
End Enum

'load command ṹ
'Commandкܶ಻ͬ࣬ÿӦһṹ嵫еCommandͬĿʼṹ
'עСǰݣṹ屾ռĴСSectionṹĴС
'еPadding0.(ǲData,Dataһ FileOffset ָ,ݲͬCommand᲻ͬ)
'ԴʼϵڶԱĴСͿֱӶλһĿʼ
'˾൱Ĵ죬ΪΪҪȶһLoad_Commandṹ֪ǰǸʲôͣ
'ȻȥӦĽṹԺ󣬻ҪصʼټϵڶԱĴСȥһȽϴ죡
'磬cmd=19һSegment_Command_64,ҲǴ￪ʼʵһSegment_Command_64ṹ
Private Type mac_load_command	'8ֽ
	lcmd				As Long		'Command 
	lcmdsize			As Long		'Command ĴС
End Type
'load commmandֱӸ header ֵĺ

'Constants for the load_command_cmd field
Private Const REQ_DYLD		= &H80000000
Private Enum load_command_cmd
	SEGMENT					= &H1
	SYM_TAB					= &H2
	SYM_SEG					= &H3
	THREAD					= &H4
	UNIX_THREAD				= &H5
	LOAD_FVM_LIB			= &H6
	ID_FVM_LIB				= &H7
	IDENT					= &H8
	FVM_FILE				= &H9
	PREPAGE					= &HA
	DY_SYM_TAB				= &HB
	LOAD_DYLIB				= &HC
	ID_DYLIB				= &HD
	LOAD_DYLINKER			= &HE
	ID_DYLINKER				= &HF
	PREBOUND_DYLIB			= &H10
	ROUTINES				= &H11
	SUB_FRAMEWORK			= &H12
	SUB_UMBRELLA			= &H13
	SUB_CLIENT				= &H14
	SUB_LIBRARY				= &H15
	TWOLEVEL_HINTS			= &H16
	PREBIND_CKSUM			= &H17
	LOAD_WEAK_DYLIB			= &H18 Or REQ_DYLD
	SEGMENT_64				= &H19
	ROUTINES_64				= &H1A
	UUID					= &H1B
	RPATH					= &H1C Or REQ_DYLD
	CODE_SIGNATURE			= &H1D
	SEGMENT_SPLIT_INFO		= &H1E
	REEXPORT_DYLIB			= &H1F Or REQ_DYLD
	LAZY_LOAD_DYLIB			= &H20
	ENCRYPTION_INFO			= &H21
	DYLD_INFO				= &H22
	DYLD_INFO_ONLY			= &H22 Or REQ_DYLD
	LOAD_UPWARD_DYLIB		= &H23 Or REQ_DYLD
	VERSION_MIN_MAC_OSX		= &H24
	VERSION_MIN_IPHONE_OS	= &H25
	FUNCTION_STARTS			= &H26
	DYLD_ENVIRONMENT		= &H27
	MAIN_CMD				= &H28
	DATA_IN_CODE			= &H29
	SOURCE_VERSION			= &H2A
	DYLIB_CODE_SIGN_DRS		= &H2B
End Enum
'һ͵ OS X ִļͨΣ:
'__PAGEZERO : λַ0καȨ˶ļвռÿռ䣬Null.
'__TEXT : ֻݺͿִд.
'__DATA : д. Щ sectionͨں˱־Ϊcopy-On-Write .
'__OBJC : Objective C ʱʹõݡ
'__LINKEDIT :̬õԭʼ.
'__TEXT __DATAοܰ0section. ÿsectionָ͵, , ִд, , C ַ

'Segment_Command ṹ
'Ľṹ˶ͳʼڴ汣룬ַļƫƣWindowsϵݲࡣ
'Ҫ棬nsectsflagsһָ˶sectionsһǰĶԡ
'nsects>0нڣҽڵĶĶζ塣
Private Type segment_command_32	'40ֽ
	segname(15) 		As Byte			'segment name  16 ַ
	lvmaddr				As Long			'memory address of this segment εڴַ
	lvmsize				As Long			'memory size of this segment VM Address εڴС
	lfileoff			As Long			'file offset of this segment ļƫ
	lfilesize			As Long			'amount to map from the file ļеĴС
	lmaxprot			As Long			'maximum VM protection
	linitprot			As Long			'initial VM protection
	lnsects				As Long			'number of sections in segment
	lflags				As Long			'flags
End Type

Private Type segment_command_64	'64ֽ
	segname(15) 		As Byte			'segment name  16 ַ
	dvmaddr1			As Long			'memory address of this segment εڴַһ
	dvmaddr2			As Long			'memory address of this segment εڴַڶ
	dvmsize1			As Long			'memory size of this segment VM Address εڴСһ
	dvmsize2			As Long			'memory size of this segment VM Address εڴСڶ
	dfileoff1			As Long			'file offset of this segment ļƫһ
	dfileoff2			As Long			'file offset of this segment ļƫڶ
	dfilesize1			As Long			'amount to map from the file ļеĴСһ
	dfilesize2			As Long			'amount to map from the file ļеĴСڶ
	lmaxprot			As Long			'maximum VM protection
	linitprot			As Long			'initial VM protection
	lnsects				As Long			'number of sections in segment
	lflags				As Long			'flags
End Type
'öζӦļݼصڴУoffset file
'sizeСڴ vmaddr ڴַռ_PAGEZEROΣβзȨޣָ룩Զ
'Σ_TEXTӦľǴΣ_DATAӦǿɶдݣ_LINKEDIT֧dyldģһЩű
'и⣬ͼʾд__TEXT SegmentСд__text Section

'Constants for the segment_command_flags field
Private Enum segment_command_flags
	HIGH_VM					= &H1
	FVM_LIB					= &H2
	NO_RELOC				= &H4
	PROTECTION_VERSION_1	= &H8
End Enum

'ڽṹ
'һһЩڴƫƺļƫƣضλڵãϸҪԺ⡣
'ҪҲflagsָ˵ǰڵԡнԿк
'Ҫ۲ݣݣתfileOffsetٶݡ
Private Type command_section_32	'68ֽ
	sectname(15)		As Byte			'name of this section  16 ַ
	segname(15)			As Byte			'segment this section goes in  16 ַڶε
	laddr				As Long			'memory address of this section ַ
	lsize				As Long			'size in bytes of this section С
	loffset				As Long			'file offset of this section ļƫ
	lalign				As Long			'section alignment (power of 2)ڶֵ
	lreloff				As Long			'file offset of relocation entries
	lnreloc				As Long			'number of relocation entries
	lflags				As Long			'flags (section type and attributes)
	lreserved1			As Long			'reserved (for offset or index)
	lreserved2			As Long			'reserved (for count or sizeof)
End Type

Private Type command_section_64	'80ֽ
	sectname(15)		As Byte			'name of this section  16 ַ
	segname(15)			As Byte			'segment this section goes in  16 ַڶε
	daddr1				As Long			'memory address of this section ַһ
	daddr2				As Long			'memory address of this section ַڶ
	dsize1				As Long			'size in bytes of this section Сһ
	dsize2				As Long			'size in bytes of this section Сڶ
	loffset				As Long			'file offset of this section ļƫ
	lalign				As Long			'section alignment (power of 2)ڶֵ
	lreloff				As Long			'file offset of relocation entries
	lnreloc				As Long			'number of relocation entries
	lflags				As Long			'flags (section type and attributes)
	lreserved1			As Long			'reserved (for offset or index)
	lreserved2			As Long			'reserved (for count or sizeof)
	lreserved3			As Long
End Type
'section cmd ˵
'__text 
'__stubs ڶ̬ӵ׮
'__stub_helper ڶ̬ӵ׮
'__cstring ַűϢͨϢԻóַűַ
'__unwind_info ֶβ̫ɶ˼ϣָ

' __TEXT, ĸҪ section:
'__text 
'__const : ͨó.
'__cstring : ַ.
'__picsymbol_stub : ̬ʹõλ޹ stub ·.
'˿ִеĺͲִеĴڶԸ.

', ĬϵĴھ2
Private Enum command_section
	S_ATTR_PURE_INSTRUCTIONS = &H80000000
	S_ATTR_SOME_INSTRUCTIONS = &H00000400
End Enum

'COMMAND_64 
Private Type MAC_FILE_LOAD_COMMAND
	lOffset			As Long
	LoadCmd			As mac_load_command
End Type

'COMMAND_32 
Private Type MAC_FILE_COMMAND_32
	Index			As Integer
	CMD				As segment_command_32
	Section() 		As command_section_32
End Type

'COMMAND_64 
Private Type MAC_FILE_COMMAND_64
	Index			As Integer
	CMD				As segment_command_64
	Section() 		As command_section_64
End Type

'Android
Private Enum RES_TYPE
    'RES_NULL_TYPE               = &H0000
    RES_STRING_POOL_TYPE        = &H0001
    RES_TABLE_TYPE              = &H0002
    RES_XML_TYPE                = &H0003
    'Chunk types In RES_XML_TYPE
    'RES_XML_FIRST_CHUNK_TYPE    = &H0100
    'RES_XML_START_NAMESPACE_TYPE= &H0100
    'RES_XML_END_NAMESPACE_TYPE  = &H0101
    'RES_XML_START_ELEMENT_TYPE  = &H0102
    'RES_XML_END_ELEMENT_TYPE    = &H0103
    'RES_XML_CDATA_TYPE          = &H0104
    'RES_XML_LAST_CHUNK_TYPE     = &H017F
    'This contains a uint32_t Array mapping strings In the String
    'pool back To resource identifiers.  It Is Optional.
    'RES_XML_RESOURCE_MAP_TYPE   = &H0180
    'Chunk types In RES_TABLE_TYPE
    'RES_TABLE_PACKAGE_TYPE      = &H0200
    'RES_TABLE_TYPE_TYPE         = &H0201
    'RES_TABLE_TYPE_SPEC_TYPE    = &H0202
    'RES_TABLE_LIBRARY_TYPE      = &H0203
End Enum

Private Type ResChunk_header
	RES_TYPE		As Integer	'Type identifier for this chunk
	headerSize		As Integer	'Size of the chunk header (in bytes)
	size			As Long		'Total size of this chunk (in bytes)
End Type

Private Type ResTable_header
	ResChunkHeader As ResChunk_header
	packageCount	As Long		'The number of ResTable_package structures
End Type

Private Type ResStringPool_header
	ResChunkHeader As ResChunk_header
	stringCount		As Long		'Number of strings in this pool
	styleCount		As Long		'Number of style span arrays in the pool
	flags			As Long		'flags
	stringsStart	As Long		'Index from header of the string data
	stylesStart		As Long		'Index from header of the style data
End Type

'ڴӳļ
Private Enum FileMaping
	PAGE_READONLY = &H02
	PAGE_READWRITE = &H04
	PAGE_WRITECOPY = &H08
	PAGE_EXECUTE = &H10
	PAGE_EXECUTE_READ = &H20
	PAGE_EXECUTE_READWRITE = &H40
	PAGE_EXECUTE_WRITECOPY = &H80
	SEC_COMMIT = &H8000000
	SEC_IMAGE = &H1000000
	SEC_NOCACHE = &H10000000
	SEC_RESERVE = &H4000000
	SEC_IMAGE_NO_EXECUTE = &H11000000
	SEC_LARGE_PAGES = &H80000000
	SEC_WRITECOMBINE = &H40000000
	GENERIC_READ = &H80000000
	GENERIC_WRITE = &H40000000
	OPEN_EXISTING = 3
	OPEN_ALWAYS = 4
	FILE_MAP_COPY = &H01
	FILE_MAP_WRITE = &H02
	FILE_MAP_READ = &H04
	FILE_MAP_ALL_ACCESS = &H02 Or &H04
	FILE_MAP_EXECUTE = &H20
	FILE_SHARE_READ = &H01
	FILE_SHARE_WRITE = &H02
	FILE_ATTRIBUTE_NORMAL = &H80
	FILE_ATTRIBUTE_ARCHIVE = &H20
	FILE_ATTRIBUTE_READONLY = &H01
	FILE_ATTRIBUTE_HIDDEN = &H02
	FILE_ATTRIBUTE_SYSTEM = &H04
End Enum

'Ϣ
Private Enum FormatMSG
	FORMAT_MESSAGE_FROM_SYSTEM = &H1000
	FORMAT_MESSAGE_IGNORE_INSERTS = &H200
End Enum

'ļʽĽṹ
Private Type FILE_IMAGE
	ModuleName				As String	'ļļ
	hFile					As Long		' Create ļӳ OpenFile ľ
	hMap					As Long		' CreateFileMapping ļӳľ
	MappedAddress			As Long		'ļӳ䵽ڴַ
	SizeOfImage				As Long		'ӳ Image ֽĴС
	SizeOfFile				As Long		'ʵļС
	ImageByte()				As Byte		'ļֽ
End Type

'ҳת
Private Declare Function MultiByteToWideChar Lib "kernel32.dll" ( _
	ByVal CodePage As Long, _
	ByVal dwFlags As Long, _
	ByRef lpMultiByteStr As Any, _
	ByVal cchMultiByte As Long, _
	ByVal lpWideCharStr As Long, _
	ByVal cchWideChar As Long) As Long

'ڴ渴ƺͱȽϺ
Private Declare Sub CopyMemory Lib "kernel32.dll" Alias "RtlMoveMemory" ( _
	ByRef Destination As Any, _
	ByRef Source As Any, _
	ByVal Length As Long)
Private Declare Sub MoveMemory Lib "kernel32.dll" Alias "RtlMoveMemory" ( _
	Dest As Any, _
	ByVal Source As Long, _
	ByVal Length As Long)
Private Declare Sub WriteMemory Lib "kernel32.dll" Alias "RtlMoveMemory" ( _
	ByVal Dest As Long, _
	ByRef Source As Any, _
	ByVal Length As Long)
'Private Declare Function vbVarPtr Lib "msvbvm60.dll" Alias "VarPtr" (Ptr As Any) As Long

'ڶдļ
Private Declare Function CreateFile Lib "kernel32.dll" Alias "CreateFileA" ( _
	ByVal lpFileName As String, _
	ByVal dwDesiredAccess As Long, _
	ByVal dwShareMode As Long, _
	ByVal lpSecurityAttributes As Long, _
	ByVal dwCreationDisposition As Long, _
	ByVal dwFlagsAndAttributes As Long, _
	ByVal hTemplateFile As Long) As Long
Private Declare Function SetFilePointer Lib "kernel32.dll" ( _
	ByVal lngFile As Long, _
	ByVal lDistanceToMove As Long, _
	lpDistanceToMoveHigh As Long, _
	ByVal dwMoveMethod As Long) As Long
Private Declare Function CloseHandle Lib "kernel32.dll" (ByVal hObject As Long) As Long
Private Declare Function ReadFile Lib "kernel32.dll" ( _
	ByVal lngFile As Long, _
	lpBuffer As Any, _
	ByVal nNumberOfBytesToRead As Long, _
	lpNumberOfBytesRead As Long, _
	ByVal lpOverlapped As Long) As Long
Private Declare Function WriteFile Lib "kernel32.dll" ( _
	ByVal hFile As Long, _
	ByVal lpBuffer As Long, _
	ByVal nNumberOfBytesToWrite As Long, _
	lpNumberOfBytesWritten As Long, _
	ByVal lpOverlapped As Long) As Long
Private Declare Function GetFileSize Lib "kernel32.dll" ( _
	ByVal hFile As Long, _
	ByVal lpFileSizeHigh As Long) As Long
Private Declare Function SetEndOfFile Lib "kernel32.dll" (ByVal hFile As Long) As Long

'ļӳ亯
Private Declare Function CreateFileMapping Lib "kernel32.dll" Alias "CreateFileMappingA" ( _
	ByVal hFile As Long, _
	ByVal lpFileMappigAttributes As Long, _
	ByVal flProtect As Long, _
	ByVal dwMaximumSizeHigh As Long, _
	ByVal dwMaximumSizeLow As Long, _
	ByVal lpName As String) As Long
Private Declare Function MapViewOfFile Lib "kernel32.dll" ( _
	ByVal hFileMappingObject As Long, _
	ByVal dwDesiredAccess As Long, _
	ByVal dwFileOffsetHigh As Long, _
	ByVal dwFileOffsetLow As Long, _
	ByVal dwNumberOfBytesToMap As Long) As Long
Private Declare Function MapViewOfFileEx Lib "kernel32.dll" ( _
	ByVal hFileMappingObject As Long, _
	ByVal dwDesiredAccess As Long, _
	ByVal dwFileOffsetHigh As Long, _
	ByVal dwFileOffsetLow As Long, _
	ByVal dwNumberOfBytesToMap As Long, _
	lpBaseAddress As Any) As Long
Private Declare Function UnmapViewOfFile Lib "kernel32.dll" (ByVal lpBaseAddress As Long) As Long
Private Declare Function FlushViewOfFile Lib "kernel32.dll" ( _
	ByVal lpBaseAddress As Long, _
	ByVal dwNumberOfBytesToFlush As Long) As Long

'ʾϢ
Private Declare Function GetLastError Lib "kernel32.dll" () As Long
Private Declare Function FormatMessage Lib "kernel32.dll" Alias "FormatMessageA" ( _
	ByVal dwFlags As Long, _
	lpSource As Any, _
	ByVal dwMessageId As Long, _
	ByVal dwLanguageId As Long, _
	ByVal lpBuffer As String, _
	ByVal nSize As Long, _
	Arguments As Long) As Long

'ı
Private Declare Function SendMessageLNG Lib "user32.dll" Alias "SendMessage" ( _
	ByVal hwnd As Long, _
	ByVal wMsg As Long, _
	ByVal wParam As Long, _
	ByVal lParam As Long) As Long

'ڷؿؼIDľ
Private Declare Function GetDlgItem Lib "user32.dll" ( _
	ByVal hDlg As Long, _
	ByVal nIDDlgItem As Long) As Long

'SendMessage API ֳ
Private Enum SendMsgValue
	EM_GETLIMITTEXT = &HD5			'0,0				ȡһ༭ؼı󳤶
	EM_LIMITTEXT = &HC5				'ֵ,0			ñ༭ؼеı
	WM_GETTEXT = &H0D				'ֽ,ַַ	ȡıؼı
	WM_GETTEXTLENGTH = &H0E			'0,0				ȡıؼıĳ(ֽ)
	WM_SETTEXT = &H0C				'0,ַַ		ôıؼı
	WM_VSCROLL = &H115				'ؼ,,λ	 SB_BOTTOM ָĴֱλ
	SB_BOTTOM = &H07				'ؼ,,λ	ʹ WM_VSCROLL  SB_BOTTOM ָĴֱλ
End Enum

'ȡڱؼеıַ
Private Declare Function GetWindowTextLength Lib "user32" Alias "GetWindowTextLength" (ByVal hwnd As Long) As Long
'ȡڱؼеı
Private Declare Function GetWindowText Lib "user32.dll" Alias "GetWindowText" (ByVal hwnd As Long, _
	ByVal lpString As String, _
	ByVal cch As Long) As Long
'ôڱؼеı
'ܸıӦóеĿؼıݣҪ SengMessage һ WM_SETTEX Ϣ
Private Declare Function SetWindowText Lib "user32.dll" Alias "SetWindowText" (ByVal hwnd As Long, _
	ByVal lpString As String) As Long

'ڶȡļ汾Ϣ
Private Declare Function GetFileVersionInfo Lib "Version.dll" Alias "GetFileVersionInfoA" ( _
	ByVal lptstrFilename As String, _
	ByVal dwhandle As Long, _
	ByVal dwlen As Long, _
	lpData As Any) As Long
Private Declare Function GetFileVersionInfoSize Lib "Version.dll" Alias "GetFileVersionInfoSizeA" ( _
	ByVal lptstrFilename As String, _
	lpdwHandle As Long) As Long
Private Declare Function VerQueryValue Lib "Version.dll" Alias "VerQueryValueA" ( _
	pBlock As Any, _
	ByVal lpSubBlock As String, _
	lplpBuffer As Any, _
	puLen As Long) As Long
Private Declare Function lstrcpy Lib "kernel32.dll" Alias "lstrcpyA" ( _
	ByVal lpString1 As String, _
	ByVal lpString2 As Long) As Long

'ҳ
Private Enum KnownCodePage
	CP_CHINA = 936			'ANSI/OEM Simplified Chinese (PRC, Singapore); Chinese Simplified (GB2312)
	CP_TAIWAN = 950			'ANSI/OEM Traditional Chinese (Taiwan; Hong Kong SAR, PRC); Chinese Traditional (Big5)
	CP_UNICODELITTLE = 1200	'Unicode UTF-16, little endian byte order (BMP of ISO 10646); available only to managed applications
	CP_UNICODEBIG = 1201	'Unicode UTF-16, big endian byte order; available only to managed applications
	CP_WESTEUROPE = 1252	'ANSI Latin 1; Western European (Windows)
	CP_ISOLATIN1 = 28591	'ISO 8859-1 Latin 1; Western European (ISO)  ŷ
	CP_UTF_32LE = 12000  	'Unicode UTF-32, little endian byte order; available only to managed applications
	CP_UTF_32BE = 12001		'Unicode UTF-32, big endian byte order; available only to managed applications
	CP_UTF32LE = 65005  	'Unicode (UTF-32 LE)
	CP_UTF32BE = 65006		'Unicode (UTF-32 Big-Endian)
End Enum


'ڶ
Private Type SUB_SECTION_PROPERTIE
	sName				As String	'
	RWA					As Long		'ݼ¼ƫƵַ (ʵûֵֻΪ˷㶨λλ)
	lVirtualSize		As Long		'EXEļбʾڵʵֽ
	lVirtualAddress		As Long		'ڵĵλRVA
	lVirtualAddress1	As Long		'ڵĸλRVA (64 λļ)
	lSizeOfRawData		As Long		'ھļĳߴ
	lPointerToRawData	As Long		'ԭʼļеλ
End Type

'ڶ
Private Type SECTION_PROPERTIE
	sName				As String	'
	RWA					As Long		'ݼ¼ƫƵַ (ʵûֵֻΪ˷㶨λλ)
	lVirtualSize		As Long		'EXEļбʾڵʵֽ
	lVirtualAddress		As Long		'ڵĵλRVA
	lVirtualAddress1	As Long		'ڵĸλRVA (64 λļ)
	lSizeOfRawData		As Long		'ھļĳߴ
	lPointerToRawData	As Long		'ԭʼļеλ
	SubSecs				As Integer	'ӽ
	SubSecList()		As SUB_SECTION_PROPERTIE
End Type

'ļͷ
Private Type HEADER_PROPERTIE
	Magic				As String	'ļͣPE32,NET32,PE64,NET64,MAC32,MAC64Ϊ
	SecAlign			As Long		'ڴֵ
	FileAlign			As Long		'ļֵ
	MinSecID 			As Integer	'Сƫƿʼַڽ
	MaxSecID 			As Integer	'ƫƿʼַڽ
	MaxSecIndex 		As Integer	'ļڵ
	USStreamID 			As Integer	'.NET ַ

	NumberOfSub			As Integer	'Ƕ PE 
	ImageBase			As Variant	'ļRVAַ
	DataDirs			As Integer	'Ŀ¼
	NetStreams			As Integer	'.NET ļ
	SecList() 			As SECTION_PROPERTIE
	DataDirectory()		As SUB_SECTION_PROPERTIE
	CLRList()			As SUB_SECTION_PROPERTIE
	StreamList()		As SUB_SECTION_PROPERTIE
End Type

'ļ
Private Type FILE_PROPERTIE
	CompanyName			As String	'˾
	FileDescription		As String	'ļ
	FileVersion			As String	'ļ汾
	InternalName		As String	'ڲ
	LegalCopyright		As String	'Ȩ
	OrigionalFileName	As String	'ԭʼļ
	ProductName			As String	'Ʒ
	ProductVersion		As String	'Ʒ汾
	LanguageID			As String	'ID
	FileSize			As Long		'ļС
	DateCreated			As Date		'ļ
	DateLastModified	As Date		'ļ޸
	CopePage			As Long		'ļҳ
	FileName			As String	'ļ (·)
	FilePath			As String	'ļ· (ļ)
	FileType			As Integer	'ļ͵Ŀʼַ磺PE ļʼ MZ
	LangType			As Long		'ļıд
	MaxHeaderID			As Integer	'ļͷ
	Header()			As HEADER_PROPERTIE

	Info 				As String	'ļϢظȡ
End Type

'Զ
Private Type REF_TYPE
	sName				As String	'㷨
	BaseAddress			As Long		'ô㷨Ļַ
	Algorithm 			As String	'ô㷨ʽ
	ByteLength			As Integer	'õֽڳ
	ByteOrder			As Integer	'ֽ0 = Сˣ1 = 
	FileMagic			As String	'ͣNotPE32,NotPE64
	PrefixByte			As String	'ǰ׺ֽڣʮ
	PrefixLength		As Integer	'ǰ׺ֽڳȣֵԶ
	StrAddAlgorithm 	As String	'ôִַ㷨ʽ
	Template			As String	'浽ִļ
End Type

'Ϣ
Private Type PROGRESS_MSG
	Total				As Long		'ܴ
	Passed				As Long		'Ѵ
	Massage				As String	'Ϣ
	hwnd				As Long		'ʾϢĶԻؼ
End Type

'
Private Type REFERENCE_PROPERTIE
	sCode				As String	'ô
	lAddress			As Long		'õַб
	inHeadID			As Integer	'ļͷ
	inSecID				As Integer	'ִڽڵ
	StrType				As Integer	'ôִ
	Index               As Long		'õţ 1 Ϊʼִķиţò
End Type

Private Type STRING_SUB_PROPERTIE
	lStartAddress	As Long		'ִĿʼַ
	HeaderID		As Integer	'ļͷ
	inSectionID		As Integer	'ִڽڵ
	inSubSecID		As Integer	'ִڽڵӽ
	StrTypeLength	As Integer	'ִ͵ǰñʶֽ
	MoveLength		As Integer	'ɱִȱʶִͳȸֵ, 0=޸, >0=ֵ, <0=ֵ
								'ԭʼִĸֵ = ִ - ԭʼִִĸֵ = ضϺ - ԭʼ
	lReferenceNum	As Long		'ô
	GetRefState		As Integer	'ȡִб״̬0 = δȡ1 = ѻȡ
	Reference()		As REFERENCE_PROPERTIE
End Type


'ԶַͶ
Private Type STRING_TYPE
	sName					As String	'ַ͵
	CodeLoc					As Integer	'ַʶλ, 0 = ִǰ, 1 = õַǰ
	FristCodePos			As Integer	'һַʶλִǰλ
	CPCodePos				As Integer	'ַҳʶλִǰλ
	CPCodeSize				As Integer	'ַҳʶֽ
	CPCodeStartString		As String	'ַҳʶʼ(Hexı)
	CPCodeStartLength		As Integer	'ַҳʶʼ(Hexı)ֽڳ
	CPCodeStartByte()		As Byte		'ַҳʶʼ(Hexı)ֽ
	LengthCodePos			As Integer	'ַȱʶλִǰλ
	LengthCodeSize			As Integer	'ַȱʶֽ
	LengthMode				As Integer	'ַȱʶִȼ
	LengthReviseVal			As Integer	'ַȱʶִȵֵ
	ByteLengthReviseVal		As Integer	'ַȱʶִȵֵ
	CharLengthReviseVal		As Integer	'ַȱʶִȵֵ
	LengthCodeStartString	As String	'ַȱʶʼ(Hexı)
	LengthCodeStartLength	As Integer	'ַȱʶʼ(Hexı)ֽ
	LengthCodeStartByte()	As Byte		'ַȱʶʼ(Hexı)ֽ
	StartCodePos			As Integer	'ַʼʶλִǰλ
	StartCodeString			As String	'ַʼʶ(Hexı)
	StartCodeLength			As Integer	'ַʼʶֽ
	StartCodeByte()			As Byte		'ַʼʶֽ
	EndCodeString			As String	'ַʶ(Hexı)
	EndCodeLength			As Integer	'ַʶֽ
	EndCodeByte()			As Byte		'ַʶֽ
	RefCodeStartPos			As Integer	'ô뿪ʼλôǰλ
	RefCodeStartString		As String	'ô뿪ʼ(Hexı)
	RefCodeStartLength		As Integer	'ô뿪ʼ(Hexı)ֽ
	RefCodeStartByte()		As Byte		'ô뿪ʼ(Hexı)ֽ
	RegExpPattern()			As String	'ʽģ
End Type

Private DosHeader 			As IMAGE_DOS_HEADER
Private FileHeader			As IMAGE_FILE_HEADER
Private OptionalHeader32	As IMAGE_OPTIONAL_HEADER32
Private OptionalHeader64	As IMAGE_OPTIONAL_HEADER64
Private SecHeader() 		As IMAGE_SECTION_HEADER

Private MacHeaderFAT	As mac_header_fat
Private MacHeader32 	As mac_header_32
Private MacHeader64 	As mac_header_64
Private MacLoadCmd()	As MAC_FILE_LOAD_COMMAND
Private MacCmd32()		As MAC_FILE_COMMAND_32
Private MacCmd64()		As MAC_FILE_COMMAND_64

Private ResChunkHeader		As ResChunk_header
Private ResTableHeader 		As ResTable_header
Private ResStringPoolHeader	As ResStringPool_header

Private MsgList() As String,SetList() As String,RegExp As Object
Private File As FILE_PROPERTIE,Data As STRING_SUB_PROPERTIE
Private StrTypeList(0) As STRING_TYPE,UseRefTypeList(0) As REF_TYPE


'
Sub Main()
	Dim Obj As Object,Temp As String
	'ϵͳ
	On Error Resume Next
	Set Obj = CreateObject("WScript.Shell")
	If Obj Is Nothing Then
		MsgBox Err.Description & " - " & "WScript.Shell",vbInformation
		Exit Sub
	End If
	Temp = "HKLM\SYSTEM\CurrentControlSet\Control\Nls\Language\Default"
	Temp = Obj.RegRead(Temp)
	If Temp = "" Then
		Temp = "HKLM\SYSTEM\CurrentControlSet\Control\Nls\Language\InstallLanguage"
		Temp = Obj.RegRead(Temp)
		If Err.Source = "WshShell.RegRead" Then
			MsgBox Err.Description,vbInformation
			Exit Sub
		End If
	End If
	Set Obj = Nothing
	' VBScript.RegExp Ƿ
	On Error Resume Next
	Set RegExp = CreateObject("VBScript.RegExp")
	If RegExp Is Nothing Then
		MsgBox(Err.Description & " - " & "VBScript.RegExp",vbInformation)
		Exit Sub
	End If
	RegExp.MultiLine = True
	On Error GoTo SysErrorMsg
	SetList = SplitArgument(Command$,3)
	If SetList(2) <> "" Then
		If StrToLong(SetList(2),3) = 3 Then Temp = ReSplit(SetList(2),";")(0)
	End If
	If UCase(Temp) <> Right$("0" & Hex$(PSL.Option(pslOptionSystemLanguage)),4) Then
		Temp = Right$("0" & Hex$(PSL.Option(pslOptionSystemLanguage)),4)
	End If
	If GetMsgList(MsgList,Temp) = False Then GoTo SysErrorMsg
	'ֹͣťʱʾԻϵϢ
	Begin Dialog UserDialog 600,294,Replace$(Replace$(MsgList(12),"%v",Version),"%b",Build),.MainDlgFunc ' %GRID:10,7,1,1
		TextBox 0,0,0,21,.SuppValueBox
		TextBox 10,7,440,21,.FilePathBox
		PushButton 450,7,30,21,MsgList(13),.FilePathButton
		OptionGroup .ValTypeGroup
			OptionButton 10,35,60,21,MsgList(14),.DecButton
			OptionButton 80,35,60,21,MsgList(15),.HexButton
		CheckBox 80,35,60,21,"",.ValTypeCheckBox
		DropListBox 150,35,150,21,SetList(),.SecNameList
		Text 310,38,50,14,MsgList(16),.FileBitText
		DropListBox 370,35,110,21,SetList(),.FileBitList
		PushButton 490,7,100,21,MsgList(17),.AboutButton
		PushButton 490,28,100,21,MsgList(63),.LangButton
		Text 10,66,50,14,MsgList(18),.RVAText
		TextBox 60,63,100,21,.RVABox
		Text 170,66,50,14,MsgList(19),.OffsetText
		TextBox 230,63,100,21,.OffsetBox
		PushButton 350,63,130,21,MsgList(20),.VACodeButton
		PushButton 490,49,100,21,MsgList(21),.SearchButton
		Text 10,98,470,14,Replace$(MsgList(22),"%s","0"),.ShowText
		TextBox 10,119,580,168,.ShowTextBox,1
		PushButton 490,70,100,21,MsgList(23),.CopyButton
		PushButton 490,91,100,21,MsgList(66),.FileInfoButton
		CancelButton 330,91,70,21,.CancelButton
	End Dialog
	Dim dlg As UserDialog
	If Dialog(dlg) = 0 Then Exit Sub
	Exit Sub
	SysErrorMsg:
	If Err.Source <> "ExitSub" Then Call sysErrorMassage(Err,0)
End Sub


'ز鿴Ի˽Ϣ
Private Function MainDlgFunc(DlgItem$, Action%, SuppValue&) As Boolean
	Dim i As Long,Mode As Long,FN As FILE_IMAGE,Temp As String,TempList() As String
	Select Case Action%
	Case 1 ' Ի򴰿ڳʼ
		DlgText "SuppValueBox",CStr$(SuppValue)
		DlgVisible "SuppValueBox",False
		DlgVisible "CancelButton",False
		DlgVisible "ValTypeCheckBox",False
		DlgEnable "FilePathBox",False
		DlgEnable "CopyButton",False
		DlgEnable "VACodeButton",False
		DlgValue "ValTypeCheckBox",DlgValue("ValTypeGroup")
		TempList = ReSplit(MsgList(24),";")
		DlgListBoxArray "FileBitList",TempList()
		'תݲֵ
		File.FilePath = SetList(0)
		If InStr(SetList(1),"0x") Then
			Data.lStartAddress = Val("&H" & SetList(1))
		Else
			Data.lStartAddress = StrToLong(SetList(1))
		End If
		If Dir$(File.FilePath) = "" Then File.FilePath = ""
		DlgText "FilePathBox",IndentDisplay(File.FilePath,50,"\")
		If File.FilePath = "" Then
			Data.lStartAddress = -1
			DlgValue "FileBitList",0
			ReDim TempList(0) As String
			DlgListBoxArray "SecNameList",TempList()
			DlgValue "SecNameList",0
			DlgEnable "SearchButton",False
			DlgEnable "FileInfoButton",False
		Else
			Call GetFileInfo(File.FilePath,File)
			GetHeaders(File.FilePath,File,LoadMode)
			'ʾַ
			If Data.lStartAddress > -1 Then
				DlgText "OffsetBox",CStr$(Data.lStartAddress)
				DlgText "RVABox",CStr$(OffsetToRva(File,Data.lStartAddress))
			End If
			'ظ
			ChangSectionNames File,MsgList(26),MsgList(25)
			'ȡļͷ
			Data.HeaderID = SkipHeaderID(File,Data.lStartAddress)
			'ȡļб
			TempList = getSectionList(File,2)
			i = UBound(TempList)
			If File.Header(Data.HeaderID).Magic = "" Then
				ReDim Preserve TempList(i + 1) As String
				TempList(i + 1) = MsgList(27)
			Else
				ReDim Preserve TempList(i + 3) As String
				TempList(i + 1) = MsgList(27)
				TempList(i + 2) = MsgList(28)
				TempList(i + 3) = MsgList(29)
			End If
			DlgListBoxArray "SecNameList",TempList()
			With Data
				.inSectionID = SkipSection(File.Header(.HeaderID),.lStartAddress,0,0,1)
				.inSubSecID = SkipSubSection(File.Header(.HeaderID),.inSectionID,.lStartAddress,0,0)
				Select Case .inSectionID
				Case Is > -1
					DlgText "SecNameList",GetSectionName(File,.HeaderID,.inSectionID,.inSubSecID)
					DlgEnable "SearchButton",IIf(File.Header(.HeaderID).Magic = "",False,True)
				Case Else
					DlgValue "SecNameList",File.Header(.HeaderID).MaxSecIndex - .inSectionID - 1
					DlgEnable "SearchButton",False
				End Select
			End With
			'ȡļ
			Select Case File.Header(Data.HeaderID).Magic
			Case ""
				DlgValue "FileBitList",1
			Case "PE32"
				DlgValue "FileBitList",2
			Case "PE64"
				DlgValue "FileBitList",3
			Case "MAC32"
				DlgValue "FileBitList",4
			Case "MAC64"
				DlgValue "FileBitList",5
			Case "Android_RES_STRING_POOL_TYPE","Android_RES_TABLE_TYPE","Android_RES_XML_TYPE"
				DlgValue "FileBitList",6
			End Select
			DlgEnable "FileInfoButton",True
		End If
	Case 2 ' ֵĻ߰°ťʱ
		MainDlgFunc = True ' ֹ°ťʱرնԻ򴰿
		Select Case DlgItem$
		Case "CancelButton"
			MainDlgFunc = False
		Case "AboutButton"
			MsgBox Replace$(Replace$(MsgList(31),"%v",Version),"%b",Build),vbOkOnly+vbInformation,MsgList(32)
		Case "FilePathButton"
			If PSL.SelectFile(Temp,True,MsgList(33),MsgList(34)) = False Then Exit Function
			If File.FilePath = Temp Then Exit Function
			If IsOpen(Temp,2,0) = True Then Exit Function
			File.FilePath = Temp
			DlgText "FilePathBox",IndentDisplay(File.FilePath,50,"\")
			Data.lStartAddress = 0
			DlgText "OffsetBox",""
			DlgText "RVABox",""
			DlgText "ShowTextBox",""
			DlgText "ShowText",Replace$(MsgList(22),"%s","0")
			DlgEnable "CopyButton",False
			DlgEnable "VACodeButton",False
			File.Info = ""
			Call GetFileInfo(File.FilePath,File)
			GetHeaders(File.FilePath,File,LoadMode)
			'ظ
			ChangSectionNames File,MsgList(26),MsgList(25)
			'ȡļͷ
			Data.HeaderID = SkipHeaderID(File,Data.lStartAddress)
			'ȡļб
			TempList = getSectionList(File,2)
			i = UBound(TempList)
			If File.Header(Data.HeaderID).Magic = "" Then
				ReDim Preserve TempList(i + 1) As String
				TempList(i + 1) = MsgList(27)
			Else
				ReDim Preserve TempList(i + 3) As String
				TempList(i + 1) = MsgList(27)
				TempList(i + 2) = MsgList(28)
				TempList(i + 3) = MsgList(29)
			End If
			DlgListBoxArray "SecNameList",TempList()
			With Data
				.inSectionID = SkipSection(File.Header(.HeaderID),.lStartAddress,0,0,1)
				.inSubSecID = SkipSubSection(File.Header(.HeaderID),.inSectionID,.lStartAddress,0,0)
				Select Case .inSectionID
				Case Is > -1
					DlgText "SecNameList",GetSectionName(File,.HeaderID,.inSectionID,.inSubSecID)
					DlgEnable "SearchButton",IIf(File.Header(.HeaderID).Magic = "",False,True)
				Case Else
					DlgValue "SecNameList",File.Header(.HeaderID).MaxSecIndex - .inSectionID - 1
					DlgEnable "SearchButton",False
				End Select
			End With
			DlgEnable "FileInfoButton",True
			'ȡļ
			Select Case File.Header(Data.HeaderID).Magic
			Case ""
				DlgValue "FileBitList",1
			Case "PE32"
				DlgValue "FileBitList",2
			Case "PE64"
				DlgValue "FileBitList",3
			Case "MAC32"
				DlgValue "FileBitList",4
			Case "MAC64"
				DlgValue "FileBitList",5
			Case "Android_RES_STRING_POOL_TYPE","Android_RES_TABLE_TYPE","Android_RES_XML_TYPE"
				DlgValue "FileBitList",6
			End Select
			Data.lReferenceNum = 0
			ReDim Data.Reference(0) 'As REFERENCE_PROPERTIE
			Data.GetRefState = 0
		Case "ValTypeGroup"
			If DlgValue("ValTypeGroup") = DlgValue("ValTypeCheckBox") Then Exit Function
			DlgValue "ValTypeCheckBox",DlgValue("ValTypeGroup")
			If DlgValue("ValTypeGroup") = 0 Then
				If DlgText("OffsetBox") <> "" Then
					DlgText "OffsetBox",CStr$(Val("&H" & DlgText("OffsetBox")))
				End If
				If DlgText("RVABox") <> "" Then
					DlgText "RVABox",CStr$(Val("&H" & DlgText("RVABox")))
				End If
			Else
				If DlgText("OffsetBox") <> "" Then
					DlgText "OffsetBox",FormatHexStr(Hex$(StrToLong(DlgText("OffsetBox"))),2)
				End If
				If DlgText("RVABox") <> "" Then
					DlgText "RVABox",FormatHexStr(Hex$(StrToLong(DlgText("RVABox"))),2)
				End If
			End If
		Case "SecNameList"
			With Data
				.inSectionID = SkipSection(File.Header(.HeaderID),.lStartAddress,0,0,1)
				.inSubSecID = SkipSubSection(File.Header(.HeaderID),.inSectionID,.lStartAddress,0,0)
				Select Case .inSectionID
				Case Is > -1
					DlgText "SecNameList",GetSectionName(File,.HeaderID,.inSectionID,.inSubSecID)
					DlgEnable "SearchButton",IIf(File.Header(.HeaderID).Magic = "",False,True)
				Case Else
					DlgValue "SecNameList",File.Header(.HeaderID).MaxSecIndex - .inSectionID - 1
					DlgEnable "SearchButton",False
				End Select
			End With
		Case "FileBitList"
			'ȡļ
			Select Case File.Header(Data.HeaderID).Magic
			Case ""
				DlgValue "FileBitList",1
			Case "PE32"
				DlgValue "FileBitList",2
			Case "PE64"
				DlgValue "FileBitList",3
			Case "MAC32"
				DlgValue "FileBitList",4
			Case "MAC64"
				DlgValue "FileBitList",5
			Case "Android_RES_STRING_POOL_TYPE","Android_RES_TABLE_TYPE","Android_RES_XML_TYPE"
				DlgValue "FileBitList",6
			End Select
		Case "VACodeButton"
			If DlgText("FilePathBox") = "" Then Exit Function
			If DlgText("OffsetBox") = "" Or File.Header(Data.HeaderID).Magic = "" Then Exit Function
			If Data.inSectionID < 0 Then Exit Function
			If Data.GetRefState = 0 Then
				MsgBox(MsgList(60),vbOkOnly+vbInformation,MsgList(59))
				Exit Function
			ElseIf Data.lReferenceNum = 0 Then
				MsgBox(MsgList(61),vbOkOnly+vbInformation,MsgList(59))
				Exit Function
			End If
			DlgEnable "CopyButton",False
			DlgEnable "SearchButton",False
			Call GetVARefList(File,FN,Data,StrTypeList,0,0,"",1,Mode,Data.HeaderID,0)
			DlgText "ShowTextBox",Reference2Str(File,Data)
			DlgText "ShowText",Replace$(MsgList(22),"%s",CStr$(Data.lReferenceNum))
			DlgEnable "SearchButton",IIf(File.Header(Data.HeaderID).Magic = "",False,True)
			DlgEnable "CopyButton",IIf(DlgText("ShowTextBox") = "",False,True)
		Case "SearchButton"
			If DlgText("FilePathBox") = "" Then Exit Function
			DlgText "ShowTextBox",""
			DlgText "ShowText",Replace$(MsgList(22),"%s","0")
			DlgEnable "CopyButton",False
			DlgEnable "VACodeButton",False
			If DlgText("OffsetBox") = "" Or File.Header(Data.HeaderID).Magic = "" Then Exit Function
			If Data.inSectionID < 0 Then Exit Function
			Mode = LoadFile(File.FilePath,FN,0,0,0,Mode)
			If Mode < -1 Then
				UnLoadFile(FN,0,Mode)
				Exit Function
			End If
			DlgEnable "SearchButton",False
			'PSL.OutputWnd(0).Clear
			'PSL.Output MsgList(35)
			DlgText "ShowText",MsgList(35)
			Data.lReferenceNum = 0
			ReDim Data.Reference(0) 'As REFERENCE_PROPERTIE
			Data.GetRefState = 0
			Call GetVARefList(File,FN,Data,StrTypeList,0,0,"",0,Mode,Data.HeaderID,GetDlgItem(CLng(DlgText("SuppValueBox")),DlgControlId("ShowText")))
			UnLoadFile(FN,0,Mode)
			DlgText "ShowTextBox",Reference2Str(File,Data)
			DlgText "ShowText",Replace$(MsgList(22),"%s",CStr$(Data.lReferenceNum))
			DlgEnable "SearchButton",True
			DlgEnable "CopyButton",IIf(DlgText("ShowTextBox") = "",False,True)
			If Data.lReferenceNum > 0 Then DlgEnable "VACodeButton",True
		Case "CopyButton"
			Clipboard Replace$(Replace$(Replace$(Replace$(MsgList(36),"%p",File.FilePath), _
					"%o",DlgText("OffsetBox")),"%r",DlgText("RVABox")),"%s",DlgText("ShowTextBox"))
		Case "FileInfoButton"
			If File.Info = "" Then Call FileInfoView(File,True)
			ShowInfo File.FilePath,File.Info
		Case "LangButton"
			ReDim TempList(0) As String
			TempList = ReSplit(MsgList(64),";")
			i = ShowPopupMenu(TempList,vbPopupUseRightButton)
			If i < 0 Then Exit Function
			TempList = ReSplit(MsgList(65),";")
			If GetMsgList(MsgList,TempList(i)) = False Then Exit Function
			File.Info = ""

			'ı
			DlgText -1,Replace$(Replace$(MsgList(12),"%v",Version),"%b",Build)
			DlgText "FilePathButton",MsgList(13)
			DlgText "DecButton",MsgList(14)
			DlgText "HexButton",MsgList(15)
			DlgText "FileBitText",MsgList(16)
			DlgText "AboutButton",MsgList(17)
			DlgText "LangButton",MsgList(63)
			DlgText "RVAText",MsgList(18)
			DlgText "OffsetText",MsgList(19)
			DlgText "VACodeButton",MsgList(20)
			DlgText "SearchButton",MsgList(21)
			DlgText "ShowText",Replace$(MsgList(22),"%s","0")
			DlgText "CopyButton",MsgList(23)
			DlgText "FileInfoButton",MsgList(66)

			'ļб
			i = DlgValue("FileBitList")
			TempList = ReSplit(MsgList(24),";")
			DlgListBoxArray "FileBitList",TempList()
			DlgValue "FileBitList",i

			'ļ
			If DlgText("FilePathBox") = "" Then Exit Function
			'ظ
			ChangSectionNames File,MsgList(26),MsgList(25)
			'ȡļб
			TempList = getSectionList(File,2)
			i = UBound(TempList)
			If File.Header(Data.HeaderID).Magic = "" Then
				ReDim Preserve TempList(i + 1) As String
				TempList(i + 1) = MsgList(27)
			Else
				ReDim Preserve TempList(i + 3) As String
				TempList(i + 1) = MsgList(27)
				TempList(i + 2) = MsgList(28)
				TempList(i + 3) = MsgList(29)
			End If
			i = DlgValue("SecNameList")
			DlgListBoxArray "SecNameList",TempList()
			DlgValue "SecNameList",i

			'
			DlgText "ShowTextBox",Reference2Str(File,Data)
			DlgText "ShowText",Replace$(MsgList(22),"%s",CStr$(Data.lReferenceNum))
		End Select
	Case 3 ' ıϿıʱ
		Select Case DlgItem$
		Case "OffsetBox"
			If DlgText("FilePathBox") = "" Then Exit Function
			If DlgText("OffsetBox") = "" Then
				Data.lStartAddress = -1
				Data.inSectionID = -1
				DlgText "RVABox",""
				DlgText "SecNameList",MsgList(27)
				DlgEnable "SearchButton",False
				DlgText "ShowTextBox",""
				DlgText "ShowText",Replace$(MsgList(22),"%s","0")
				DlgEnable "CopyButton",False
				DlgEnable "SearchButton",False
				Exit Function
			End If
			DlgText "OffsetBox",Replace$(DlgText("OffsetBox")," ","")
			If DlgValue("ValTypeGroup") = 0 Then
				If CheckDecStr(DlgText("OffsetBox"),0) = False Then
					MsgBox(MsgList(40),vbOkOnly+vbInformation,MsgList(0))
					DlgText "OffsetBox",CStr$(Data.lStartAddress)
					Exit Function
				ElseIf StrToLong(DlgText("OffsetBox")) >= File.FileSize Then
					MsgBox(MsgList(41),vbOkOnly+vbInformation,MsgList(0))
					DlgText "OffsetBox",CStr$(Data.lStartAddress)
					Exit Function
				Else
					i = Data.lStartAddress
					Data.lStartAddress = StrToLong(DlgText("OffsetBox"))
					Data.HeaderID = SkipHeaderID(File,Data.lStartAddress)
					DlgText "RVABox",CStr$(OffsetToRva(File,Data.lStartAddress))
					If i = Data.lStartAddress Then Exit Function
				End If
			Else
				If CheckHexStr(DlgText("OffsetBox"),0) = False Then
					MsgBox(MsgList(40),vbOkOnly+vbInformation,MsgList(0))
					DlgText "OffsetBox",FormatHexStr(Hex$(Data.lStartAddress),2)
					Exit Function
				ElseIf Val("&H" & DlgText("OffsetBox")) >= File.FileSize Then
					MsgBox(MsgList(41),vbOkOnly+vbInformation,MsgList(0))
					DlgText "OffsetBox",FormatHexStr(Hex$(Data.lStartAddress),2)
					Exit Function
				Else
					i = Data.lStartAddress
					Data.lStartAddress = Val("&H" & DlgText("OffsetBox"))
					Data.HeaderID = SkipHeaderID(File,Data.lStartAddress)
					DlgText "RVABox",FormatHexStr(Hex$(OffsetToRva(File,Data.lStartAddress)),2)
					If i = Data.lStartAddress Then Exit Function
				End If
			End If
			With Data
				.inSectionID = SkipSection(File.Header(.HeaderID),.lStartAddress,0,0,1)
				.inSubSecID = SkipSubSection(File.Header(.HeaderID),.inSectionID,.lStartAddress,0,0)
				Select Case .inSectionID
				Case Is > -1
					DlgText "SecNameList",GetSectionName(File,.HeaderID,.inSectionID,.inSubSecID)
					DlgEnable "SearchButton",IIf(File.Header(.HeaderID).Magic = "",False,True)
				Case Else
					DlgValue "SecNameList",File.Header(.HeaderID).MaxSecIndex - .inSectionID - 1
					DlgEnable "SearchButton",False
				End Select
			End With
			'ȡļ
			Select Case File.Header(Data.HeaderID).Magic
			Case ""
				DlgValue "FileBitList",1
			Case "PE32"
				DlgValue "FileBitList",2
			Case "PE64"
				DlgValue "FileBitList",3
			Case "MAC32"
				DlgValue "FileBitList",4
			Case "MAC64"
				DlgValue "FileBitList",5
			Case "Android_RES_STRING_POOL_TYPE","Android_RES_TABLE_TYPE","Android_RES_XML_TYPE"
				DlgValue "FileBitList",6
			End Select
			DlgText "ShowTextBox",""
			DlgText "ShowText",Replace$(MsgList(22),"%s","0")
			DlgEnable "CopyButton",False
		Case "RVABox"
			If DlgText("FilePathBox") = "" Then Exit Function
			If DlgText("RVABox") = "" Then
				Data.lStartAddress = -1
				Data.inSectionID = -1
				DlgText "OffsetBox",""
				DlgText "SecNameList",MsgList(27)
				DlgEnable "SearchButton",False
				DlgText "ShowTextBox",""
				DlgText "ShowText",Replace$(MsgList(22),"%s","0")
				DlgEnable "CopyButton",False
				DlgEnable "SearchButton",False
				Exit Function
			End If
			DlgText "RVABox",Replace$(DlgText("RVABox")," ","")
			If DlgValue("ValTypeGroup") = 0 Then
				If CheckDecStr(DlgText("RVABox"),0) = False Then
					MsgBox(MsgList(40),vbOkOnly+vbInformation,MsgList(0))
					DlgText "RVABox",CStr$(OffsetToRva(File,Data.lStartAddress))
					Exit Function
				End If
				i = SkipHeaderID(File,RvaToOffset(File,StrToLong(DlgText("RVABox"))))
				If SkipSection(File.Header(i),StrToLong(DlgText("RVABox")),0,0,3) = -3 Then
					MsgBox(MsgList(41),vbOkOnly+vbInformation,MsgList(0))
					DlgText "RVABox",CStr$(OffsetToRva(File,Data.lStartAddress))
					Exit Function
				Else
					i = Data.lStartAddress
					Data.lStartAddress = RvaToOffset(File,StrToLong(DlgText("RVABox")))
					Data.HeaderID = SkipHeaderID(File,Data.lStartAddress)
					DlgText "OffsetBox",CStr$(Data.lStartAddress)
					If i = Data.lStartAddress Then Exit Function
				End If
			Else
				If CheckHexStr(DlgText("RVABox"),0) = False Then
					MsgBox(MsgList(40),vbOkOnly+vbInformation,MsgList(0))
					DlgText "RVABox",FormatHexStr(Hex$(OffsetToRva(File,Data.lStartAddress)),2)
					Exit Function
				End If
				i = SkipHeaderID(File,RvaToOffset(File,Val("&H" & DlgText("RVABox"))))
				If SkipSection(File.Header(i),Val("&H" & DlgText("RVABox")),0,0,3) = -3 Then
					MsgBox(MsgList(41),vbOkOnly+vbInformation,MsgList(0))
					DlgText "RVABox",FormatHexStr(Hex$(OffsetToRva(File,Data.lStartAddress)),2)
					Exit Function
				Else
					i = Data.lStartAddress
					Data.lStartAddress = RvaToOffset(File,Val("&H" & DlgText("RVABox")))
					Data.HeaderID = SkipHeaderID(File,Data.lStartAddress)
					DlgText "OffsetBox",FormatHexStr(Hex$(Data.lStartAddress),2)
					If i = Data.lStartAddress Then Exit Function
				End If
			End If
			With Data
				.inSectionID = SkipSection(File.Header(.HeaderID),.lStartAddress,0,0,1)
				.inSubSecID = SkipSubSection(File.Header(.HeaderID),.inSectionID,.lStartAddress,0,0)
				Select Case .inSectionID
				Case Is > -1
					DlgText "SecNameList",GetSectionName(File,.HeaderID,.inSectionID,.inSubSecID)
					DlgEnable "SearchButton",IIf(File.Header(.HeaderID).Magic = "",False,True)
				Case Else
					DlgValue "SecNameList",File.Header(.HeaderID).MaxSecIndex - .inSectionID - 1
					DlgEnable "SearchButton",False
				End Select
			End With
			'ȡļ
			Select Case File.Header(Data.HeaderID).Magic
			Case ""
				DlgValue "FileBitList",1
			Case "PE32"
				DlgValue "FileBitList",2
			Case "PE64"
				DlgValue "FileBitList",3
			Case "MAC32"
				DlgValue "FileBitList",4
			Case "MAC64"
				DlgValue "FileBitList",5
			Case "Android_RES_STRING_POOL_TYPE","Android_RES_TABLE_TYPE","Android_RES_XML_TYPE"
				DlgValue "FileBitList",6
			End Select
			DlgText "ShowTextBox",""
			DlgText "ShowText",Replace$(MsgList(22),"%s","0")
			DlgEnable "CopyButton",False
		End Select
	Case 6 ' ܼ
		Select Case SuppValue
		Case 1
			MsgBox Replace$(Replace$(MsgList(31),"%v",Version),"%b",Build),vbOkOnly+vbInformation,MsgList(32)
		Case 2
			Clipboard Replace$(Replace$(Replace$(Replace$(MsgList(36),"%p",File.FilePath), _
					"%o",DlgText("OffsetBox")),"%r",DlgText("RVABox")),"%s",DlgText("ShowTextBox"))
		End Select
	End Select
End Function


'ʮִǷҪ
Private Function CheckDecStr(ByVal textStr As String,ByVal Length As Integer) As Boolean
	If textStr = "" Then Exit Function
	If Length <> 0 Then
		If (Len(textStr) Mod Length) <> 0 Then Exit Function
	End If
	If CheckStrRegExp(textStr,"[0-9]",0,1) = False Then Exit Function
	CheckDecStr = True
End Function


'ʮִǷҪ
Private Function CheckHexStr(ByVal textStr As String,ByVal Length As Integer) As Boolean
	If textStr = "" Then Exit Function
	If Length <> 0 Then
		If (Len(textStr) Mod Length) <> 0 Then Exit Function
	End If
	If CheckStrRegExp(textStr,"[0-9A-Fa-f]",0,1) = False Then Exit Function
	CheckHexStr = True
End Function


'ִǷַָ(ʽȽ)
'Mode = 0 ִǷַָҳַָλ
'Mode = 1 ִǷַָֻ
'Mode = 2 ִǷַָ
'Mode = 3 ִǷֻСдַָʱ IgnoreCase Ч
'Mode = 4 ִǷַͬStrNum Ϊظַ
'Mode = 5 ִǷִָƥִܳ (ʺַϲѯ)
'Patrn  Ϊʽģ
Private Function CheckStrRegExp(ByVal textStr As String,ByVal Patrn As String,Optional ByVal StrNum As Long, _
				Optional ByVal Mode As Long,Optional ByVal IgnoreCase As Boolean) As Long
	Dim n As Long,Matches As Object
	If Patrn = "" Then Exit Function
	If Trim$(textStr) = "" Then Exit Function
	With RegExp
		Select Case Mode
		Case 0
			.Global = True
			.IgnoreCase = IgnoreCase
			.Pattern = Patrn
			Set Matches = .Execute(textStr)
			If Matches.Count > 0 Then CheckStrRegExp = Matches(0).FirstIndex + 1
		Case 1
			.Global = True
			.IgnoreCase = IgnoreCase
			.Pattern = Patrn
			Set Matches = .Execute(textStr)
			If Matches.Count = Len(textStr) Then CheckStrRegExp = True
		Case 2
			.Global = False
			.IgnoreCase = IgnoreCase
			.Pattern = Patrn
			If .Test(textStr) Then CheckStrRegExp = True
		Case 3
			If InStr(textStr," ") Then Exit Function
			n = Len(textStr)
			If n < 2 Then Exit Function
			If LCase$(textStr) = textStr Then Exit Function
			If UCase$(textStr) = textStr Then Exit Function
			.Global = True
			.IgnoreCase = False
			.Pattern = Patrn
			Set Matches = .Execute(textStr)
			If Matches.Count <> n Then Exit Function
			textStr = Mid$(textStr,2)
			If LCase$(textStr) = textStr Then Exit Function
			CheckStrRegExp = True
		Case 4
			If StrNum < 2 Then Exit Function
			If Len(textStr) < StrNum Then Exit Function
			If InStr(textStr," ") Then Exit Function
			If StrNum = 3 Then
				If InStr(textStr,"://www.") Then Exit Function
			End If
			.Global = False
			.IgnoreCase = IgnoreCase
			.Pattern = "(" & Patrn & ")\1{" & CStr$(StrNum - 1) & ",}"
			If .Test(textStr) Then CheckStrRegExp = True
		Case 5
			.Global = True
			.IgnoreCase = IgnoreCase
			.Pattern = Patrn
			Set Matches = .Execute(textStr)
			If Matches.Count = 0 Then Exit Function
			For n = 0 To Matches.Count - 1
				CheckStrRegExp = CheckStrRegExp + Matches(n).Length
			Next n
			CheckStrRegExp = IIf(CheckStrRegExp = Len(textStr),True,False)
		End Select
	End With
End Function


'ݷõַбȡԴб(ִ)
'Mode = False '޸õַб򣬻ȡõַʹб
Private Sub GetRefList(strData As STRING_SUB_PROPERTIE,RefAddList() As String,RefVAList() As String,ByVal Mode As Boolean)
	Dim i As Long,n As Long,Dic As Object
	With strData
		If .lReferenceNum = 0 Then
			ReDim RefList(0) As REFERENCE_PROPERTIE
			ReDim AddList(0) As String,VAList(0) As String
		Else
			n = UBound(RefAddList)
			ReDim RefList(n) As REFERENCE_PROPERTIE
			ReDim AddList(n) As String,VAList(n) As String
			Set Dic = CreateObject("Scripting.Dictionary")
			For i = 0 To .lReferenceNum - 1
				If Not Dic.Exists(.Reference(i).lAddress) Then
					Dic.Add(CStr(.Reference(i).lAddress),i)
				End If
			Next i
			n = 0
			For i = 0 To UBound(RefAddList)
				If Dic.Exists(RefAddList(i)) Then
					RefList(n) = .Reference(Dic.Item(RefAddList(i)))
					AddList(n) = CStr(RefList(n).lAddress)
					VAList(n) = RefList(n).sCode
					n = n + 1
				End If
			Next i
			Set Dic = Nothing
			If n > 0 Then
				ReDim Preserve RefList(n - 1) As REFERENCE_PROPERTIE
				ReDim Preserve AddList(n - 1) As String,VAList(n - 1) As String
			Else
				ReDim RefList(0) As REFERENCE_PROPERTIE
				ReDim AddList(0) As String,VAList(0) As String
			End If
		End If
		If Mode = False Then
			RefAddList = AddList
			RefVAList = VAList
		Else
			.Reference = RefList
			.lReferenceNum = n
			.GetRefState = IIf(n = 0,0,1)
		End If
	End With
End Sub


'ǵֽλãطǵֽڿʼλ
Private Function getNotNullByteRegExp(FN As FILE_IMAGE,ByVal Offset As Long,ByVal Max As Long,ByVal Mode As Long) As Long
	If Offset + 1 > Max Then
		getNotNullByteRegExp = Offset
		Exit Function
	End If
	Dim Matches As Object,endPos As Long
	With RegExp
		.Global = False
		.IgnoreCase = False
		.Pattern = "[^\x00]+?"
		Do
			endPos = IIf(Offset + 512 < Max,Offset + 512,Max)
			Set Matches = .Execute(ByteToString(GetBytes(FN,endPos - Offset + 1,Offset,Mode),CP_ISOLATIN1))
			If Matches.Count > 0 Then
				Offset = Offset + Matches(0).FirstIndex
				Exit Do
			End If
			Offset = endPos
		Loop Until endPos >= Max
	End With
	getNotNullByteRegExp = Offset
End Function


'ָĿֽλãؿֽڿʼλãBit ΪСֽ
Private Function getNullByte(FN As FILE_IMAGE,ByVal Offset As Long,ByVal Max As Long,ByVal Mode As Long,ByVal Bit As Integer) As Long
	If Offset + 1 > Max Then
		getNullByte = Offset
		Exit Function
	End If
  	Do
		If GetByte(FN,Offset,Mode) = 0 Then
			getNullByte = getNullByte + 1
		Else
			getNullByte = 0
		End If
		Offset = Offset + 1
	Loop Until Offset > Max Or getNullByte = Bit
	getNullByte = Offset - 1
End Function


'תַΪ Long ֵ
Private Function StrToLong(ByVal mStr As String,Optional ByVal DefaultValue As Long) As Long
	On Error GoTo errHandle
	StrToLong = CLng(mStr)
	Exit Function
	errHandle:
	StrToLong = DefaultValue
End Function


'ȡ4ֵֽ (32 λֵ,4ֽ, -2,147,483,648  2,147,483,647)
Private Function GetLong(Source As Variant,Optional ByVal Offset As Long = -1,Optional ByVal Mode As Long = -1) As Long
	On Error GoTo errHandle
	If Offset + 4 > Source.SizeOfImage Then GoTo errHandle
	Select Case Mode
	Case Is < 0
		If Offset < 0 Then
			Get #Source.hFile, , GetLong
		Else
			Get #Source.hFile, Offset + 1, GetLong
		End If
	Case 0
		If Offset < 0 Then GoTo errHandle
		CopyMemory GetLong, Source.ImageByte(Offset), 4
	Case Else
		If Offset < 0 Then GoTo errHandle
		MoveMemory GetLong, Source.MappedAddress + Offset, 4
	End Select
	errHandle:
End Function


'ȡ2ֵֽ (16 λֵ, 2ֽ, -32,768  32,767)
Private Function GetInteger(Source As Variant,Optional ByVal Offset As Long = -1,Optional ByVal Mode As Long = -1) As Integer
	On Error GoTo errHandle
	If Offset + 2 > Source.SizeOfImage Then GoTo errHandle
	Select Case Mode
	Case Is < 0
		If Offset < 0 Then
			Get #Source.hFile, , GetInteger
		Else
			Get #Source.hFile, Offset + 1, GetInteger
		End If
	Case 0
		If Offset < 0 Then GoTo errHandle
		CopyMemory GetInteger, Source.ImageByte(Offset), 2
	Case Else
		If Offset < 0 Then GoTo errHandle
		MoveMemory GetInteger, Source.MappedAddress + Offset, 2
	End Select
	errHandle:
End Function


'ַָȡһֽ(8 λֵ, 1ֽ)
Private Function GetByte(Source As Variant,Optional ByVal Offset As Long = -1,Optional ByVal Mode As Long = -1) As Byte
	On Error GoTo errHandle
	If Offset + 1 > Source.SizeOfImage Then GoTo errHandle
	Select Case Mode
	Case Is < 0
		If Offset < 0 Then
			Get #Source.hFile, , GetByte
		Else
			Get #Source.hFile, Offset + 1, GetByte
		End If
	Case 0
		If Offset < 0 Then GoTo errHandle
		GetByte = Source.ImageByte(Offset)
	Case Else
		If Offset < 0 Then GoTo errHandle
		MoveMemory GetByte, Source.MappedAddress + Offset, 1
	End Select
	errHandle:
End Function


'ȡڵֽ
Private Function GetBytes(Source As Variant,ByVal Length As Long,Optional ByVal Offset As Long = -1,Optional ByVal Mode As Long = -1) As Byte()
	On Error GoTo errHandle
	If Offset + Length > Source.SizeOfImage Then GoTo errHandle
	ReDim Bytes(Length - 1) As Byte
	Select Case Mode
	Case Is < 0
		If Offset < 0 Then
			Get #Source.hFile, , Bytes
		Else
			Get #Source.hFile, Offset + 1, Bytes
		End If
	Case 0
		If Offset < 0 Then GoTo errHandle
		CopyMemory Bytes(0), Source.ImageByte(Offset), Length
	Case Else
		If Offset < 0 Then GoTo errHandle
		MoveMemory Bytes(0), Source.MappedAddress + Offset, Length
	End Select
	GetBytes = Bytes
	Exit Function
	errHandle:
	ReDim Bytes(0) As Byte
	GetBytes = Bytes
End Function


'ȡԶֵ
Private Function GetTypeValue(Source As FILE_IMAGE,ByVal Offset As Long,Target As Variant,Optional ByVal Mode As Long = -1) As Boolean
	On Error GoTo errHandle
	If Offset < 0 Then GoTo errHandle
	If Offset +  Len(Target) > Source.SizeOfImage Then GoTo errHandle
	Select Case Mode
	Case Is < 0
		Get #Source.hFile, Offset + 1, Target
	Case 0
		CopyMemory Target, Source.ImageByte(Offset), Len(Target)
	Case Else
		MoveMemory Target, Source.MappedAddress + Offset, Len(Target)
	End Select
	GetTypeValue = True
	errHandle:
End Function


'ȡԶ
Private Function GetTypeArray(Source As FILE_IMAGE,ByVal Offset As Long,Target As Variant,Optional ByVal Mode As Long = -1) As Boolean
	On Error GoTo errHandle
	If Offset < 0 Then GoTo errHandle
	If Offset + Len(Target(0)) * (UBound(Target) + 1) > Source.SizeOfImage Then GoTo errHandle
	Select Case Mode
	Case Is < 0
		Get #Source.hFile, Offset + 1, Target
	Case 0
		CopyMemory Target(0), Source.ImageByte(Offset), Len(Target(0)) * (UBound(Target) + 1)
	Case Else
		MoveMemory Target(0), Source.MappedAddress + Offset, Len(Target(0)) * (UBound(Target) + 1)
	End Select
	GetTypeArray = True
	errHandle:
End Function


'ȡֽڳ
Private Function GetFileLength(Source As FILE_IMAGE,Optional ByVal Mode As Long = -1) As Long
	Select Case Mode
	Case Is < 0
		GetFileLength = LOF(Source.hFile)
	Case 0
		GetFileLength = Source.SizeOfFile	'UBound(Source.ImageByte) + 1
	Case Else
		GetFileLength = Source.SizeOfFile	'GetFileSize(Source.hFile, 0&)
	End Select
End Function


'ļǷѱ򿪻ռ
Private Function IsOpen(ByVal strFilePath As String,Optional ByVal Continue As Long = 2,Optional ByVal WaitTime As Double = 0.5) As Boolean
	Dim i As Long,FN As Variant
	'Դļ
	If Dir$(strFilePath) = "" Then Exit Function
	On Error Resume Next
	FN = FreeFile
	Do
		Open strFilePath For Binary Access Read Lock Write As #FN
		If Err.Number = 0 Or i > 10 Then Exit Do
		Wait WaitTime
		Err.Clear
		i = i + 1
	Loop
	Close #FN
	If Err.Number = 0 Then Exit Function
	ErrorHandle:
	IsOpen = True
	Err.Source = "NotOpenFile"
	Err.Description = Err.Description & JoinStr & strFilePath
	Call sysErrorMassage(Err,Continue)
End Function


'ȡļļݽṹϢ
Private Function GetPEHeaders(ByVal strFilePath As String,File As FILE_PROPERTIE,ByVal Mode As Long, _
				Optional ByVal Offset As Long = -1,Optional ByVal HeaderID As Integer) As Boolean
	Dim i As Long,FN As FILE_IMAGE,TempList() As String,Temp As String
	On Error GoTo ExitFunction
	File.FileSize = FileLen(strFilePath)
	'ļ
	Mode = LoadFile(strFilePath,FN,0,0,0,Mode)
	If Mode < -1 Then Exit Function
	'ȡļͷ
	GetPEHeaders = GetPEHeader(FN,File,Mode,Offset,HeaderID)
	If GetPEHeaders = False Then GoTo ExitFunction
	'ȡļͷ
	With File.Header(0).SecList(File.Header(0).MaxSecIndex)
		If .lSizeOfRawData = 0 Then GoTo ExitFunction
		Temp = ByteToString(GetBytes(FN,.lSizeOfRawData,.lPointerToRawData,Mode),CP_ISOLATIN1)
		TempList = GetVAListRegExp(Temp,"MZ[\x00-\xFF]{64,384}?PE\x00",.lPointerToRawData)
		If CheckArray(TempList) = False Then GoTo ExitFunction
		Dim SubFile As FILE_PROPERTIE
		File.Header(0).NumberOfSub = UBound(TempList) + 1
		For i = 0 To File.Header(0).NumberOfSub - 1
			'If GetPEHeader(FN,SubFile,Mode,CLng(TempList(i))) = True Then
				'޸ļؽڴС
				.lSizeOfRawData = CLng(TempList(i)) - .lPointerToRawData
				Exit For
			'End If
		Next i
	End With
	ExitFunction:
	'رļ
	On Error Resume Next
	UnLoadFile(FN,0,Mode)
End Function


'ȡļݽṹϢ
Private Function GetPEHeader(FN As FILE_IMAGE,File As FILE_PROPERTIE,ByVal Mode As Long, _
				Optional ByVal Offset As Long = -1,Optional ByVal HeaderID As Integer = -1) As Boolean
	Dim i As Long,n As Long
	Dim tmpDosHeader 		As IMAGE_DOS_HEADER
	Dim tmpFileHeader		As IMAGE_FILE_HEADER
	Dim tmpOptionalHeader32	As IMAGE_OPTIONAL_HEADER32
	Dim tmpOptionalHeader64	As IMAGE_OPTIONAL_HEADER64
	Dim tmpSecHeader() 		As IMAGE_SECTION_HEADER
	ReDim File.Header(0)							'As HEADER_PROPERTIE
	ReDim File.Header(0).SecList(1)					'As SECTION_PROPERTIE
	ReDim File.Header(0).SecList(0).SubSecList(0)	'As SUB_SECTION_PROPERTIE
	ReDim File.Header(0).SecList(1).SubSecList(0)	'As SUB_SECTION_PROPERTIE
	ReDim File.Header(0).DataDirectory(0)			'As SUB_SECTION_PROPERTIE
	ReDim File.Header(0).CLRList(0)					'As SUB_SECTION_PROPERTIE
	ReDim File.Header(0).StreamList(0)				'As SUB_SECTION_PROPERTIE
	i = Offset
	If i = -1 Then i = File.FileType
	On Error GoTo ExitFunction
	File.MaxHeaderID = 0
	File.LangType = 0
	With File.Header(0)
		'ʼ
		.Magic = ""
		.FileAlign = 0
		.SecAlign = 0
		.ImageBase = 0
		.DataDirs = 0
		.MinSecID = 0
		.MaxSecID = 0
		.MaxSecIndex = 1
		.USStreamID = -1
		.NumberOfSub = 0
		.NetStreams = 0

		'ȡ IMAGE_DOS_HEADERS ṹ
		'GetTypeValue(FN,i,tmpDosHeader,Mode)
		Select Case Mode
		Case Is < 0
			Get #FN.hFile, i + 1, tmpDosHeader
		Case 0
			CopyMemory tmpDosHeader, FN.ImageByte(i), Len(tmpDosHeader)
		Case Else
			MoveMemory tmpDosHeader, FN.MappedAddress + i, Len(tmpDosHeader)
		End Select
		If tmpDosHeader.iSignature <> IMAGE_DOS_SIGNATURE Then GoTo ExitFunction

		'ȡ IMAGE_FILE_HEADERS ṹ
		i = i + tmpDosHeader.lPointerToPEHeader
		'GetTypeValue(FN,i,tmpFileHeader,Mode)
		Select Case Mode
		Case Is < 0
			Get #FN.hFile, i + 1, tmpFileHeader
		Case 0
			CopyMemory tmpFileHeader, FN.ImageByte(i), Len(tmpFileHeader)
		Case Else
			MoveMemory tmpFileHeader, FN.MappedAddress + i, Len(tmpFileHeader)
		End Select
		If tmpFileHeader.lSignature <> IMAGE_NT_SIGNATURE Then GoTo ExitFunction
		'Ƿļڽṹ
		If tmpFileHeader.iNumberOfSections = 0 Then GoTo ExitFunction

		' PE λȡ IMAGE_OPTIONAL_HEADER ṹ32λPE&H10B64λPE&H20B
		i = i + Len(tmpFileHeader)
		Select Case GetInteger(FN,i,Mode)
		Case IMAGE_NT_OPTIONAL_HDR32_MAGIC	'32λPEļ
			'GetTypeValue(FN,i.tmpOptionalHeader32,Mode)
			Select Case Mode
			Case Is < 0
				Get #FN.hFile, i + 1, tmpOptionalHeader32
			Case 0
				CopyMemory tmpOptionalHeader32, FN.ImageByte(i), Len(tmpOptionalHeader32)
			Case Else
				MoveMemory tmpOptionalHeader32, FN.MappedAddress + i, Len(tmpOptionalHeader32)
			End Select

			'ȡļڽṹ
			i = i + Len(tmpOptionalHeader32)
			ReDim tmpSecHeader(tmpFileHeader.iNumberOfSections - 1) 'As IMAGE_SECTION_HEADER
			'GetTypeArray(FN,i,tmpSecHeader,Mode)
			Select Case Mode
			Case Is < 0
				Get #FN.hFile, i + 1, tmpSecHeader
			Case 0
				CopyMemory tmpSecHeader(0), FN.ImageByte(i), Len(tmpSecHeader(0)) * tmpFileHeader.iNumberOfSections
			Case Else
				MoveMemory tmpSecHeader(0), FN.MappedAddress + i, Len(tmpSecHeader(0)) * tmpFileHeader.iNumberOfSections
			End Select

			'¼εַ
			ReDim File.Header(0).SecList(tmpFileHeader.iNumberOfSections) 'As SECTION_PROPERTIE
			n = 0
			For i = 0 To tmpFileHeader.iNumberOfSections - 1
				.SecList(i).sName = Replace$(StrConv$(tmpSecHeader(i).sName,vbUnicode),vbNullChar,"")
				.SecList(i).lPointerToRawData = tmpSecHeader(i).lPointerToRawData
				.SecList(i).lSizeOfRawData = tmpSecHeader(i).lSizeOfRawData
				.SecList(i).lVirtualAddress = tmpSecHeader(i).lVirtualAddress
				.SecList(i).lVirtualSize = tmpSecHeader(i).lVirtualSize
				.SecList(i).SubSecs = 0
				If .SecList(i).lSizeOfRawData = 0 Then n = n + 1
			Next i
			If n = tmpFileHeader.iNumberOfSections Then GoTo ExitFunction

			'¼ DataDirectory ַ
			ReDim File.Header(0).DataDirectory(15)			'As SUB_SECTION_PROPERTIE
			For i = 0 To 15
				.DataDirectory(i).lPointerToRawData = RvaToOffset(File,tmpOptionalHeader32.DataDirectory(i).lVirtualAddress)
				.DataDirectory(i).lSizeOfRawData = tmpOptionalHeader32.DataDirectory(i).lSize
				.DataDirectory(i).lVirtualAddress = tmpOptionalHeader32.DataDirectory(i).lVirtualAddress
				.DataDirectory(i).lVirtualSize = tmpOptionalHeader32.DataDirectory(i).lSize
			Next i
			.Magic = "PE32"
			.FileAlign = tmpOptionalHeader32.lFileAlignment
			.SecAlign = tmpOptionalHeader32.lSectionAlignment
			.ImageBase = tmpOptionalHeader32.lImageBase
			'¼Ŀ¼
			.DataDirs = 16
		Case IMAGE_NT_OPTIONAL_HDR64_MAGIC	'64λPEļ
			'GetTypeValue(FN,i,tmpOptionalHeader64,Mode)
			Select Case Mode
			Case Is < 0
				Get #FN.hFile, i + 1, tmpOptionalHeader64
			Case 0
				CopyMemory tmpOptionalHeader64, FN.ImageByte(i), Len(tmpOptionalHeader64)
			Case Else
				MoveMemory tmpOptionalHeader64, FN.MappedAddress + i, Len(tmpOptionalHeader64)
			End Select

			'ȡļڽṹ
			i = i + Len(tmpOptionalHeader64)
			ReDim tmpSecHeader(tmpFileHeader.iNumberOfSections - 1) 'As IMAGE_SECTION_HEADER
			'GetTypeArray(FN,i,tmpSecHeader,Mode)
			Select Case Mode
			Case Is < 0
				Get #FN.hFile, i + 1, tmpSecHeader
			Case 0
				CopyMemory tmpSecHeader(0), FN.ImageByte(i), Len(tmpSecHeader(0)) * tmpFileHeader.iNumberOfSections
			Case Else
				MoveMemory tmpSecHeader(0), FN.MappedAddress + i, Len(tmpSecHeader(0)) * tmpFileHeader.iNumberOfSections
			End Select

			'¼εַ
			ReDim File.Header(0).SecList(tmpFileHeader.iNumberOfSections) 'As SECTION_PROPERTIE
			n = 0
			For i = 0 To tmpFileHeader.iNumberOfSections - 1
				.SecList(i).sName = Replace$(StrConv$(tmpSecHeader(i).sName,vbUnicode),vbNullChar,"")
				.SecList(i).lPointerToRawData = tmpSecHeader(i).lPointerToRawData
				.SecList(i).lSizeOfRawData = tmpSecHeader(i).lSizeOfRawData
				.SecList(i).lVirtualAddress = tmpSecHeader(i).lVirtualAddress
				.SecList(i).lVirtualSize = tmpSecHeader(i).lVirtualSize
				.SecList(i).SubSecs = 0
				If .SecList(i).lSizeOfRawData = 0 Then n = n + 1
			Next i
			If n = tmpFileHeader.iNumberOfSections Then GoTo ExitFunction

			'¼ DataDirectory ַ
			ReDim File.Header(0).DataDirectory(15)			'As SUB_SECTION_PROPERTIE
			For i = 0 To 15
				.DataDirectory(i).lPointerToRawData = RvaToOffset(File,tmpOptionalHeader64.DataDirectory(i).lVirtualAddress)
				.DataDirectory(i).lSizeOfRawData = tmpOptionalHeader64.DataDirectory(i).lSize
				.DataDirectory(i).lVirtualAddress = tmpOptionalHeader64.DataDirectory(i).lVirtualAddress
				.DataDirectory(i).lVirtualSize = tmpOptionalHeader64.DataDirectory(i).lSize
			Next i
			.Magic = "PE64"
			.FileAlign = tmpOptionalHeader64.lFileAlignment
			.SecAlign = tmpOptionalHeader64.lSectionAlignment
			.ImageBase = tmpOptionalHeader64.dImageBase
			'¼Ŀ¼
			.DataDirs = 16
		Case Else
			GoTo ExitFunction
		End Select

		'ȡļšСƫƵַڽڵ
		.MaxSecIndex = tmpFileHeader.iNumberOfSections
		Call GetSectionID(File,0,.MinSecID,.MaxSecID,False)
		File.LangType = tmpDosHeader.iLastPageBytes

		'ȡ .NET ͷṹ
		i = Offset
		If i = -1 Then i = File.FileType
		If GetNETHeader(FN,File,Mode,i) = True Then File.LangType = NET_FILE_SIGNATURE

		'
		'tmpSecHeader(.MaxSecID).lSizeOfRawData = Alignment(tmpSecHeader(.MaxSecID).lSizeOfRawData,.FileAlign,1)
		'tmpSecHeader(.MaxSecID).lVirtualSize = Alignment(tmpSecHeader(.MaxSecID).lVirtualSize,.SecAlign,1)
		'.SecList(.MaxSecID).lSizeOfRawData = tmpSecHeader(.MaxSecID).lSizeOfRawData
		'.SecList(.MaxSecID).lVirtualSize = tmpSecHeader(.MaxSecID).lVirtualSize

		'ȡؽϢ
		.SecList(.MaxSecIndex).lPointerToRawData = .SecList(.MaxSecID).lPointerToRawData + .SecList(.MaxSecID).lSizeOfRawData
		.SecList(.MaxSecIndex).lSizeOfRawData = GetFileLength(FN,Mode) - .SecList(.MaxSecIndex).lPointerToRawData
		.SecList(.MaxSecIndex).lVirtualAddress = .SecList(.MaxSecID).lVirtualAddress + .SecList(.MaxSecID).lVirtualSize
		.SecList(.MaxSecIndex).lVirtualSize = .SecList(.MaxSecIndex).lSizeOfRawData
	End With

	'¼ĸͷ
	If HeaderID > -1 Then
		DosHeader = tmpDosHeader
		FileHeader = tmpFileHeader
		OptionalHeader32 = tmpOptionalHeader32
		OptionalHeader64 = tmpOptionalHeader64
		SecHeader = tmpSecHeader
	End If

	'ǳɹ
	GetPEHeader = True
	Exit Function

	ExitFunction:
	'ReDim File.Header(0)					'As HEADER_PROPERTIE
	ReDim File.Header(0).SecList(1)			'As SECTION_PROPERTIE
	ReDim File.Header(0).DataDirectory(0)	'As SUB_SECTION_PROPERTIE
	ReDim File.Header(0).CLRList(0)			'As SUB_SECTION_PROPERTIE
	ReDim File.Header(0).StreamList(0)		'As SUB_SECTION_PROPERTIE
	File.MaxHeaderID = 0
	File.FileType = 0
	File.LangType = 0
	With File.Header(0)
		.Magic = ""
		.FileAlign = 0
		.SecAlign = 0
		.ImageBase = 0
		.DataDirs = 0
		.MinSecID = 0
		.MaxSecID = 0
		.MaxSecIndex = 1
		.USStreamID = -1
		.NumberOfSub = 0
		.NetStreams = 0
		.SecList(0).SubSecs = 0
		.SecList(1).SubSecs = 0
		'ļΪһ
		.SecList(0).lPointerToRawData = 0
		.SecList(0).lSizeOfRawData = GetFileLength(FN,Mode)
		.SecList(0).lVirtualAddress = 0
		.SecList(0).lVirtualSize = .SecList(0).lSizeOfRawData
		'ؽϢʾļϢ
		.SecList(1).lPointerToRawData = .SecList(0).lSizeOfRawData
		.SecList(1).lSizeOfRawData = 0
		.SecList(1).lVirtualAddress = .0
		.SecList(1).lVirtualSize = 0
	End With
End Function


'ȡ .NET ͷṹ
Private Function GetNETHeader(FN As FILE_IMAGE,File As FILE_PROPERTIE,ByVal Mode As Long,Optional ByVal Offset As Long) As Boolean
	Dim i As Long,Length As Long,dwOffset As Long
	Dim CLRHeader			As IMAGE_CLR20_HEADER
	Dim MetaDataHeader		As IMAGE_METADATA_HEADER
	On Error GoTo ExitFunction
	With File.Header(0)
		'ת15Ŀ¼ַתƫƵַ
		dwOffset = RvaToOffset(File,.DataDirectory(14).lVirtualAddress)
		If dwOffset = 0 Then Exit Function
		'ȡ CLR ṹ
		'GetTypeValue(FN,Offset + dwOffset,CLRHeader,Mode)
		Select Case Mode
		Case Is < 0
			Get #FN.hFile, Offset + dwOffset + 1, CLRHeader
		Case 0
			CopyMemory CLRHeader, FN.ImageByte(Offset + dwOffset), Len(CLRHeader)
		Case Else
			MoveMemory CLRHeader, Offset + FN.MappedAddress + dwOffset, Len(CLRHeader)
		End Select
		'ת CLR е MetaData ַתƫƵַ
		dwOffset = RvaToOffset(File,CLRHeader.METADATA.lVirtualAddress)
		If dwOffset = 0 Then Exit Function
	End With

	'ǷΪ .NET ļ
	With MetaDataHeader
		.lSignature = GetLong(FN,Offset + dwOffset,Mode)
		If .lSignature <> NET_FILE_SIGNATURE Then Exit Function
		'ȡ MetaDataHeader.Version ֽڳ
		.lLength = GetLong(FN,Offset + dwOffset + 12,Mode)
		' 4 ֽڶ MetaDataHeader.Version ֽڳ
		.lLength = Alignment(.lLength,4,1)
		'ȡ METADATA ṹ
		.iMajorVersion = GetInteger(FN,Offset + dwOffset + 4,Mode)
		.iMinorVersion = GetInteger(FN,Offset + dwOffset + 6,Mode)
		.lExtraData = GetLong(FN,Offset + dwOffset + 8,Mode)
		.Version = GetBytes(FN,.lLength,Offset + dwOffset + 16,Mode)
		.fFlags = GetInteger(FN,Offset + dwOffset + 16 + .lLength,Mode)
		.iStreams = GetInteger(FN,Offset + dwOffset + 18 + .lLength,Mode)

		'ȡļͷṹ
		If .iStreams > 0 Then
			ReDim StreamHeader(.iStreams - 1) As IMAGE_STREAM_HEADER
			dwOffset = dwOffset + 20 + .lLength
			For i = 0 To .iStreams - 1
				'lOffset  Metadata Rootʵ RVA = .CLRHeader.MetaData.lVirtualAddress + .StreamHeader(i).lOffset
				StreamHeader(i).RWA = dwOffset + 0
				StreamHeader(i).lOffset = GetLong(FN,Offset + dwOffset + 0,Mode)
				StreamHeader(i).lSize = GetLong(FN,Offset + dwOffset + 4,Mode)
				'ȡ .StreamHeader.rcName ֽڳ
				dwOffset = dwOffset + 8
				Length = getNullByte(FN,Offset + dwOffset,Offset + dwOffset + 16,Mode,1) - dwOffset + 1
				' 4 ֽڶ .StreamHeader.rcName ֽڳ
				Length = Alignment(Length,4,1)
				StreamHeader(i).rcName = GetBytes(FN,Length,Offset + dwOffset,Mode)
				dwOffset = dwOffset + Length
			Next i
		End If
	End With

	'ת.NET ͷṹַΪַ
	ReDim File.Header(0).CLRList(6)	'As SUB_SECTION_PROPERTIE
	With File.Header(0)
		.CLRList(0).lPointerToRawData = RvaToOffset(File,CLRHeader.METADATA.lVirtualAddress)
		.CLRList(1).lPointerToRawData = RvaToOffset(File,CLRHeader.Resources.lVirtualAddress)
		.CLRList(2).lPointerToRawData = RvaToOffset(File,CLRHeader.StrongNameSignature.lVirtualAddress)
		.CLRList(3).lPointerToRawData = RvaToOffset(File,CLRHeader.CodeManagerTable.lVirtualAddress)
		.CLRList(4).lPointerToRawData = RvaToOffset(File,CLRHeader.VTableFixups.lVirtualAddress)
		.CLRList(5).lPointerToRawData = RvaToOffset(File,CLRHeader.ExportAddressTableJumps.lVirtualAddress)
		.CLRList(6).lPointerToRawData = RvaToOffset(File,CLRHeader.ManagedNativeHeader.lVirtualAddress)
		.CLRList(0).lSizeOfRawData = CLRHeader.METADATA.lSize
		.CLRList(1).lSizeOfRawData = CLRHeader.Resources.lSize
		.CLRList(2).lSizeOfRawData = CLRHeader.StrongNameSignature.lSize
		.CLRList(3).lSizeOfRawData = CLRHeader.CodeManagerTable.lSize
		.CLRList(4).lSizeOfRawData = CLRHeader.VTableFixups.lSize
		.CLRList(5).lSizeOfRawData = CLRHeader.ExportAddressTableJumps.lSize
		.CLRList(6).lSizeOfRawData = CLRHeader.ManagedNativeHeader.lSize

		.CLRList(0).lVirtualAddress = CLRHeader.METADATA.lVirtualAddress
		.CLRList(1).lVirtualAddress = CLRHeader.Resources.lVirtualAddress
		.CLRList(2).lVirtualAddress = CLRHeader.StrongNameSignature.lVirtualAddress
		.CLRList(3).lVirtualAddress = CLRHeader.CodeManagerTable.lVirtualAddress
		.CLRList(4).lVirtualAddress = CLRHeader.VTableFixups.lVirtualAddress
		.CLRList(5).lVirtualAddress = CLRHeader.ExportAddressTableJumps.lVirtualAddress
		.CLRList(6).lVirtualAddress = CLRHeader.ManagedNativeHeader.lVirtualAddress
		.CLRList(0).lVirtualSize = CLRHeader.METADATA.lSize
		.CLRList(1).lVirtualSize = CLRHeader.Resources.lSize
		.CLRList(2).lVirtualSize = CLRHeader.StrongNameSignature.lSize
		.CLRList(3).lVirtualSize = CLRHeader.CodeManagerTable.lSize
		.CLRList(4).lVirtualSize = CLRHeader.VTableFixups.lSize
		.CLRList(5).lVirtualSize = CLRHeader.ExportAddressTableJumps.lSize
		.CLRList(6).lVirtualSize = CLRHeader.ManagedNativeHeader.lSize

		.NetStreams = MetaDataHeader.iStreams
		If .NetStreams > 0 Then
			ReDim File.Header(0).StreamList(.NetStreams - 1) 'As SUB_SECTION_PROPERTIE
			For i = 0 To .NetStreams - 1
				.StreamList(i).lPointerToRawData = .CLRList(0).lPointerToRawData + StreamHeader(i).lOffset
				.StreamList(i).lSizeOfRawData = StreamHeader(i).lSize
				.StreamList(i).lVirtualAddress = .CLRList(0).lVirtualAddress + StreamHeader(i).lOffset
				.StreamList(i).lVirtualSize = StreamHeader(i).lSize
				.StreamList(i).sName = Replace$(StrConv$(StreamHeader(i).rcName,vbUnicode),vbNullChar,"")
				If UCase$(.StreamList(i).sName) = "#US" Then .USStreamID = i
			Next i
		End If
	End With
	'ǳɹ
	GetNETHeader = True
	ExitFunction:
End Function


'ַתƫƵַ
Private Function RvaToOffset(File As FILE_PROPERTIE,ByVal dwRvaAddr As Long) As Long
	Dim i As Integer,j As Integer
	On Error GoTo ErrHandle
	For j = 0 To File.MaxHeaderID
		With File.Header(j)
			For i = 0 To UBound(.SecList)
				If dwRvaAddr >= .SecList(i).lVirtualAddress Then
					If dwRvaAddr < .SecList(i).lVirtualAddress + .SecList(i).lVirtualSize Then
						RvaToOffset = dwRvaAddr + .SecList(i).lPointerToRawData - .SecList(i).lVirtualAddress
						Exit Function
					End If
				End If
			Next i
		End With
	Next j
	Exit Function
	ErrHandle:
	RvaToOffset = 0
End Function


'ƫƵַתַ
Private Function OffsetToRva(File As FILE_PROPERTIE,ByVal dwOffset As Long) As Long
	Dim i As Integer,j As Integer
	On Error GoTo ErrHandle
	For j = 0 To File.MaxHeaderID
		With File.Header(j)
			For i = 0 To UBound(.SecList)
				If dwOffset >= .SecList(i).lPointerToRawData Then
					If dwOffset < .SecList(i).lPointerToRawData + .SecList(i).lSizeOfRawData Then
						OffsetToRva = dwOffset + .SecList(i).lVirtualAddress - .SecList(i).lPointerToRawData
						Exit Function
					End If
				End If
			Next i
		End With
	Next j
	Exit Function
	ErrHandle:
	OffsetToRva = 0
End Function


'ȡļļݽṹϢ
Private Function GetMacHeaders(ByVal strFilePath As String,File As FILE_PROPERTIE,ByVal Mode As Long, _
				Optional ByVal Offset As Long = -1,Optional ByVal HeaderID As Integer = -1) As Boolean
	Dim i As Long,FN As FILE_IMAGE,TempList() As String,Temp As String
	On Error GoTo ExitFunction
	File.FileSize = FileLen(strFilePath)
	'ļ
	Mode = LoadFile(strFilePath,FN,0,0,0,Mode)
	If Mode < -1 Then Exit Function
	'ȡļͷ
	GetMacHeaders = GetMacHeader(FN,File,Mode,Offset,HeaderID)
	If GetMacHeaders = False Then GoTo ExitFunction
	'ȡļͷ
	With File.Header(File.MaxHeaderID).SecList(File.Header(File.MaxHeaderID).MaxSecIndex)
		If .lSizeOfRawData = 0 Then GoTo ExitFunction
		Temp = ByteToString(GetBytes(FN,.lSizeOfRawData,.lPointerToRawData,Mode),CP_ISOLATIN1)
		TempList = GetVAListRegExp(Temp,"(\xCE\xFA\xED\xFE)|(\xCF\xFA\xED\xFE)",.lPointerToRawData)
		If CheckArray(TempList) = False Then GoTo ExitFunction
		Dim SubFile As FILE_PROPERTIE
		File.Header(File.MaxHeaderID).NumberOfSub = UBound(TempList) + 1
		For i = 0 To File.Header(File.MaxHeaderID).NumberOfSub - 1
			'If GetMacHeader(FN,SubFile,Mode,CLng(TempList(i))) = True Then
				'޸ļؽڴС
				.lSizeOfRawData = CLng(TempList(i)) - .lPointerToRawData
				Exit For
			'End If
		Next i
	End With
	ExitFunction:
	'رļ
	On Error Resume Next
	UnLoadFile(FN,0,Mode)
End Function


'ȡļݽṹϢ
Private Function GetMacHeader(FN As FILE_IMAGE,File As FILE_PROPERTIE,ByVal Mode As Long, _
				Optional ByVal Offset As Long = -1,Optional ByVal HeaderID As Integer = -1) As Boolean
	Dim i As Long,j As Long,k As Long,n As Long,x As Integer,y As Integer
	Dim tmpMacHeaderFAT	As mac_header_fat
	Dim tmpMacHeader32 	As mac_header_32
	Dim tmpMacHeader64 	As mac_header_64
	Dim tmpMacLoadCmd()	As MAC_FILE_LOAD_COMMAND
	Dim tmpMacCmd32()	As MAC_FILE_COMMAND_32
	Dim tmpMacCmd64()	As MAC_FILE_COMMAND_64
	k = Offset
	If k = -1 Then k = File.FileType
	On Error GoTo ExitFunction
	'ȡ FAT Header
	File.MaxHeaderID = 0
	File.LangType = 0
	With File
		Select Case GetLong(FN,k,Mode)
		Case MH_MAGIC_FAT,MH_MAGIC_FAT_CIGAM
			With tmpMacHeaderFAT
				.lmagic = GetLong(FN,k,Mode)
				.lfat_arch_size = Bytes2Val(GetBytes(FN,4,k + 4,Mode),4,True)
				If .lfat_arch_size = 0 Then GoTo ExitFunction
				ReDim tmpMacHeaderFAT.fat_archs(.lfat_arch_size - 1)	'As mac_header_fat_arch
				k = k + 8
				For i = 0 To .lfat_arch_size - 1
					.fat_archs(i).lcputype = Bytes2Val(GetBytes(FN,4,k,Mode),4,True)
					.fat_archs(i).lcpusubtype = Bytes2Val(GetBytes(FN,4,k + 4,Mode),4,True)
					.fat_archs(i).lfileoffset = Bytes2Val(GetBytes(FN,4,k + 8,Mode),4,True)
					.fat_archs(i).lsize	= Bytes2Val(GetBytes(FN,4,k + 12,Mode),4,True)
					.fat_archs(i).lalign = Bytes2Val(GetBytes(FN,4,k + 16,Mode),4,True)
					k = k + 20
				Next i
				'Select Case Mode
				'Case Is < 0
				'	Get #FN.hFile, k + 1, .fat_archs
				'Case 0
				'	CopyMemory .fat_archs(0), FN.ImageByte(k), Len(.fat_archs(0)) * .lfat_arch_size
				'Case Else
				'	MoveMemory .fat_archs(0), FN.MappedAddress + k, Len(.fat_archs(0)) * .lfat_arch_size
				'End Select
			End With
			.MaxHeaderID = tmpMacHeaderFAT.lfat_arch_size - 1
		End Select
	End With

	'ȡ Header
	ReDim File.Header(File.MaxHeaderID)								'As HEADER_PROPERTIE
	ReDim File.Header(File.MaxHeaderID).SecList(1)					'As SECTION_PROPERTIE
	ReDim File.Header(File.MaxHeaderID).SecList(0).SubSecList(0)	'As SUB_SECTION_PROPERTIE
	ReDim File.Header(File.MaxHeaderID).SecList(1).SubSecList(0)	'As SUB_SECTION_PROPERTIE
	ReDim File.Header(File.MaxHeaderID).DataDirectory(0)			'As SUB_SECTION_PROPERTIE
	ReDim File.Header(File.MaxHeaderID).CLRList(0)					'As SUB_SECTION_PROPERTIE
	ReDim File.Header(File.MaxHeaderID).StreamList(0)				'As SUB_SECTION_PROPERTIE
	For x = 0 To File.MaxHeaderID
		n = 0
		If tmpMacHeaderFAT.lfat_arch_size > 0 Then
			k = tmpMacHeaderFAT.fat_archs(x).lfileoffset
			If HeaderID > -1 Then
				If x <> HeaderID Then GoTo NextNo
			End If
		End If
		With File.Header(y)
			'ʼ
			.Magic = ""
			.FileAlign = 0
			.SecAlign = 0
			.ImageBase = -k
			.DataDirs = 0
			.MinSecID = 0
			.MaxSecID = 0
			.MaxSecIndex = 1
			.USStreamID = -1
			.NumberOfSub = 0
			.NetStreams = 0

			Select Case GetLong(FN,k,Mode)
			Case MH_MAGIC_32
				Select Case Mode
				Case Is < 0
					Get #FN.hFile, k + 1, tmpMacHeader32
				Case 0
					CopyMemory tmpMacHeader32, FN.ImageByte(k), Len(tmpMacHeader32)
				Case Else
					MoveMemory tmpMacHeader32, FN.MappedAddress + k, Len(tmpMacHeader32)
				End Select
				If tmpMacHeader32.lncmds = 0 Then GoTo NextNo
				.Magic = "MAC32"
				.MaxSecIndex = tmpMacHeader32.lncmds
				k = k + Len(tmpMacHeader32)
			Case MH_MAGIC_64
				Select Case Mode
				Case Is < 0
					Get #FN.hFile, k + 1, tmpMacHeader64
				Case 0
					CopyMemory tmpMacHeader64, FN.ImageByte(k), Len(tmpMacHeader64)
				Case Else
					MoveMemory tmpMacHeader64, FN.MappedAddress + k, Len(tmpMacHeader64)
				End Select
				If tmpMacHeader64.lncmds = 0 Then GoTo NextNo
				.Magic = "MAC64"
				.MaxSecIndex = tmpMacHeader64.lncmds
				k = k + Len(tmpMacHeader64)
			Case Else
				GoTo NextNo
			End Select

			'ȡ Command 
			ReDim tmpMacLoadCmd(.MaxSecIndex - 1)	'As MAC_FILE_LOAD_COMMAND
			ReDim tmpMacCmd32(.MaxSecIndex - 1) 	'As MAC_FILE_COMMAND_32
			ReDim tmpMacCmd64(.MaxSecIndex - 1)		'As MAC_FILE_COMMAND_64
			ReDim Preserve File.Header(y).SecList(.MaxSecIndex)	'As SECTION_PROPERTIE
			For i = 0 To .MaxSecIndex - 1
				tmpMacLoadCmd(i).loffset = k
				If k + tmpMacLoadCmd(i).LoadCmd.lcmdsize <= File.FileSize Then
					'ȡ Load Command 
					Select Case Mode
					Case Is < 0
						Get #FN.hFile, k + 1, tmpMacLoadCmd(i).LoadCmd
					Case 0
						CopyMemory tmpMacLoadCmd(i).LoadCmd, FN.ImageByte(k), Len(tmpMacLoadCmd(i).LoadCmd)
					Case Else
						MoveMemory tmpMacLoadCmd(i).LoadCmd, FN.MappedAddress + k, Len(tmpMacLoadCmd(i).LoadCmd)
					End Select

					'ȡ Command 
					Select Case tmpMacLoadCmd(i).LoadCmd.lcmd
					Case SEGMENT	'32λ׼ Command
						'ȡ Command 
						j = k + Len(tmpMacLoadCmd(i).LoadCmd)
						tmpMacCmd32(n).Index = i
						Select Case Mode
						Case Is < 0
							Get #FN.hFile, j + 1, tmpMacCmd32(n).CMD
						Case 0
							CopyMemory tmpMacCmd32(n).CMD, FN.ImageByte(j), Len(tmpMacCmd32(n).CMD)
						Case Else
							MoveMemory tmpMacCmd32(n).CMD, FN.MappedAddress + j, Len(tmpMacCmd32(n).CMD)
						End Select

						'ȡ
						If tmpMacCmd32(n).CMD.lnsects > 0 Then
							ReDim Preserve tmpMacCmd32(n).Section(tmpMacCmd32(n).CMD.lnsects - 1)	'As command_section_32
							ReDim Preserve File.Header(y).SecList(n).SubSecList(tmpMacCmd32(n).CMD.lnsects - 1) 'SECTION_PROPERTIE
							j = j + Len(tmpMacCmd32(n).CMD)
							Select Case Mode
							Case Is < 0
								Get #FN.hFile, j + 1, tmpMacCmd32(n).Section
							Case 0
								CopyMemory tmpMacCmd32(n).Section(0), FN.ImageByte(j), Len(tmpMacCmd32(n).Section(0)) * tmpMacCmd32(n).CMD.lnsects
							Case Else
								MoveMemory tmpMacCmd32(n).Section(0), FN.MappedAddress + j, Len(tmpMacCmd32(n).Section(0)) * tmpMacCmd32(n).CMD.lnsects
							End Select
							'¼ڵַ
							For j = 0 To tmpMacCmd32(n).CMD.lnsects - 1
								.SecList(n).SubSecList(j).sName = Replace$(StrConv$(tmpMacCmd32(n).Section(j).sectname,vbUnicode),vbNullChar,"")
								.SecList(n).SubSecList(j).lPointerToRawData = tmpMacCmd32(n).Section(j).loffset - .ImageBase
								.SecList(n).SubSecList(j).lSizeOfRawData = tmpMacCmd32(n).Section(j).lsize
								.SecList(n).SubSecList(j).lVirtualAddress = tmpMacCmd32(n).Section(j).laddr - .ImageBase
								.SecList(n).SubSecList(j).lVirtualSize = tmpMacCmd32(n).Section(j).lsize
							Next j
						Else
							ReDim Preserve tmpMacCmd32(n).Section(0)	'As command_section_32
							ReDim Preserve File.Header(y).SecList(n).SubSecList(0) 'SECTION_PROPERTIE
						End If

						'¼εַ
						.SecList(n).sName = Replace$(StrConv$(tmpMacCmd32(n).CMD.segname,vbUnicode),vbNullChar,"")
						.SecList(n).lPointerToRawData = tmpMacCmd32(n).CMD.lfileoff - .ImageBase
						.SecList(n).lSizeOfRawData = tmpMacCmd32(n).CMD.lfilesize
						.SecList(n).lVirtualAddress = tmpMacCmd32(n).CMD.lvmaddr - .ImageBase
						.SecList(n).lVirtualSize = tmpMacCmd32(n).CMD.lvmsize
						.SecList(n).SubSecs = tmpMacCmd32(n).CMD.lnsects
						If .SecList(n).lSizeOfRawData > 0 Then n = n + 1
					Case SEGMENT_64	'64λ׼ Command
						'ȡ Command 
						j = k + Len(tmpMacLoadCmd(i).LoadCmd)
						tmpMacCmd64(n).Index = i
						Select Case Mode
						Case Is < 0
							Get #FN.hFile, j + 1, tmpMacCmd64(n).CMD
						Case 0
							CopyMemory tmpMacCmd64(n).CMD, FN.ImageByte(j), Len(tmpMacCmd64(n).CMD)
						Case Else
							MoveMemory tmpMacCmd64(n).CMD, FN.MappedAddress + j, Len(tmpMacCmd64(n).CMD)
						End Select

						'ȡ
						If tmpMacCmd64(n).CMD.lnsects > 0 Then
							ReDim Preserve tmpMacCmd64(n).Section(tmpMacCmd64(n).CMD.lnsects - 1)	'As command_section_64
							ReDim Preserve File.Header(y).SecList(n).SubSecList(tmpMacCmd64(n).CMD.lnsects - 1) 'SECTION_PROPERTIE
							j = j + Len(tmpMacCmd64(n).CMD)
							Select Case Mode
							Case Is < 0
								Get #FN.hFile, j + 1, tmpMacCmd64(n).Section
							Case 0
								CopyMemory tmpMacCmd64(n).Section(0), FN.ImageByte(j), Len(tmpMacCmd64(n).Section(0)) * tmpMacCmd64(n).CMD.lnsects
							Case Else
								MoveMemory tmpMacCmd64(n).Section(0), FN.MappedAddress + j, Len(tmpMacCmd64(n).Section(0)) * tmpMacCmd64(n).CMD.lnsects
							End Select
							'¼ڵַ
							For j = 0 To tmpMacCmd64(n).CMD.lnsects - 1
								.SecList(n).SubSecList(j).sName = Replace$(StrConv$(tmpMacCmd64(n).Section(j).sectname,vbUnicode),vbNullChar,"")
								.SecList(n).SubSecList(j).lPointerToRawData = tmpMacCmd64(n).Section(j).loffset - .ImageBase
								.SecList(n).SubSecList(j).lSizeOfRawData = tmpMacCmd64(n).Section(j).dsize1
								.SecList(n).SubSecList(j).lVirtualAddress = tmpMacCmd64(n).Section(j).daddr1 - .ImageBase
								.SecList(n).SubSecList(j).lVirtualAddress1 = tmpMacCmd64(n).Section(j).daddr2
								.SecList(n).SubSecList(j).lVirtualSize = tmpMacCmd64(n).Section(j).dsize1
							Next j
						Else
							ReDim Preserve tmpMacCmd64(n).Section(0)	'As command_section_32
							ReDim Preserve File.Header(y).SecList(n).SubSecList(0) 'SECTION_PROPERTIE
						End If

						'¼εַ
						.SecList(n).sName = Replace$(StrConv$(tmpMacCmd64(n).CMD.segname,vbUnicode),vbNullChar,"")
						.SecList(n).lPointerToRawData = tmpMacCmd64(n).CMD.dfileoff1 - .ImageBase
						.SecList(n).lSizeOfRawData = tmpMacCmd64(n).CMD.dfilesize1
						.SecList(n).lVirtualAddress = tmpMacCmd64(n).CMD.dvmaddr1 - .ImageBase
						.SecList(n).lVirtualAddress1 = tmpMacCmd64(n).CMD.dvmaddr2
						.SecList(n).lVirtualSize = tmpMacCmd64(n).CMD.dvmsize1
						.SecList(n).SubSecs = tmpMacCmd64(n).CMD.lnsects
						If .SecList(n).lSizeOfRawData > 0 Then n = n + 1
					End Select
				End If
				k = k + tmpMacLoadCmd(i).LoadCmd.lcmdsize
			Next i
			If n > 0 Then
				.MaxSecIndex = n
				ReDim Preserve tmpMacCmd32(n - 1) As MAC_FILE_COMMAND_32
				ReDim Preserve tmpMacCmd64(n - 1) As MAC_FILE_COMMAND_64
				ReDim Preserve File.Header(y).SecList(n) 'SECTION_PROPERTIE
				'һζǴ0ʼļͷҪ
				For i = 0 To .MaxSecIndex - 1
					If .SecList(i).lPointerToRawData = 0 Then
						If .SecList(i).SubSecs > 0 Then
							.SecList(i).lPointerToRawData = .SecList(i).SubSecList(0).lPointerToRawData
							.SecList(i).lSizeOfRawData = .SecList(i).lSizeOfRawData - .SecList(i).lPointerToRawData
						End If
					End If
					If .SecList(i).lVirtualAddress = 0 Then
						If .SecList(i).SubSecs > 0 Then
							.SecList(i).lVirtualAddress = .SecList(i).SubSecList(0).lVirtualAddress
							.SecList(i).lVirtualSize = .SecList(i).lVirtualSize - .SecList(i).lVirtualAddress
						End If
					End If
				Next i
			Else
				.MaxSecIndex = 1
				ReDim tmpMacCmd32(0) As MAC_FILE_COMMAND_32
				ReDim tmpMacCmd64(0) As MAC_FILE_COMMAND_64
				ReDim Preserve File.Header(y).SecList(1) 'SECTION_PROPERTIE
				GoTo NextNo
			End If

			'ȡļšСƫƵַڽڵ
			Call GetSectionID(File,y,.MinSecID,.MaxSecID,False)

			'ȡؽϢ
			If x = File.MaxHeaderID Or x = HeaderID Then
				.SecList(.MaxSecIndex).lPointerToRawData = .SecList(.MaxSecID).lPointerToRawData + .SecList(.MaxSecID).lSizeOfRawData
				.SecList(.MaxSecIndex).lSizeOfRawData = GetFileLength(FN,Mode) - .SecList(.MaxSecIndex).lPointerToRawData
				.SecList(.MaxSecIndex).lVirtualAddress = .SecList(.MaxSecID).lVirtualAddress + .SecList(.MaxSecID).lVirtualSize
				.SecList(.MaxSecIndex).lVirtualSize = .SecList(.MaxSecIndex).lSizeOfRawData
			Else
				.SecList(.MaxSecIndex).lPointerToRawData = .SecList(.MaxSecID).lPointerToRawData + .SecList(.MaxSecID).lSizeOfRawData
				.SecList(.MaxSecIndex).lSizeOfRawData = tmpMacHeaderFAT.fat_archs(x + 1).lfileoffset - .SecList(.MaxSecIndex).lPointerToRawData
				.SecList(.MaxSecIndex).lVirtualAddress = .SecList(.MaxSecID).lVirtualAddress + .SecList(.MaxSecID).lVirtualSize
				.SecList(.MaxSecIndex).lVirtualSize = .SecList(.MaxSecIndex).lSizeOfRawData
			End If
		End With
		y = y + 1
		NextNo:
	Next x
	If y = 0 Then GoTo ExitFunction
	File.MaxHeaderID = y - 1
	ReDim Preserve File.Header(File.MaxHeaderID) 'As HEADER_PROPERTIE
	'¼ĸͷ
	If HeaderID > -1 Then
		File.MaxHeaderID = 0
		MacHeaderFAT = tmpMacHeaderFAT
		MacHeader32 = tmpMacHeader32
		MacHeader64 = tmpMacHeader64
		MacLoadCmd = tmpMacLoadCmd
		MacCmd32 = tmpMacCmd32
		MacCmd64 = tmpMacCmd64
	End If

	'ǳɹ
	GetMacHeader = True
	Exit Function

	ExitFunction:
	'ReDim File.Header(0)					'As HEADER_PROPERTIE
	ReDim File.Header(0).SecList(1)			'As SECTION_PROPERTIE
	ReDim File.Header(0).DataDirectory(0)	'As SECTION_PROPERTIE
	ReDim File.Header(0).CLRList(0)			'As SECTION_PROPERTIE
	ReDim File.Header(0).StreamList(0)		'As SUB_SECTION_PROPERTIE
	File.MaxHeaderID = 0
	File.FileType = 0
	File.LangType = 0
	With File.Header(0)
		.Magic = ""
		.FileAlign = 0
		.SecAlign = 0
		.ImageBase = 0
		.DataDirs = 0
		.MinSecID = 0
		.MaxSecID = 0
		.MaxSecIndex = 1
		.USStreamID = -1
		.NumberOfSub = 0
		.NetStreams = 0
		.SecList(0).SubSecs = 0
		.SecList(1).SubSecs = 0
		'ļΪһ
		.SecList(0).lPointerToRawData = 0
		.SecList(0).lSizeOfRawData = GetFileLength(FN,Mode)
		.SecList(0).lVirtualAddress = 0
		.SecList(0).lVirtualSize = .SecList(0).lSizeOfRawData
		'ؽϢʾļϢ
		.SecList(1).lPointerToRawData = .SecList(0).lSizeOfRawData
		.SecList(1).lSizeOfRawData = 0
		.SecList(1).lVirtualAddress = .0
		.SecList(1).lVirtualSize = 0
	End With
End Function


'ȡ Android ļļݽṹϢ
Private Function GetAndroidHeaders(ByVal strFilePath As String,File As FILE_PROPERTIE,ByVal Mode As Long, _
				Optional ByVal Offset As Long = -1,Optional ByVal HeaderID As Integer = -1) As Boolean
	Dim i As Long,FN As FILE_IMAGE
	On Error GoTo ExitFunction
	File.FileSize = FileLen(strFilePath)
	'ļ
	Mode = LoadFile(strFilePath,FN,0,0,0,Mode)
	If Mode < -1 Then Exit Function
	'ȡļͷ
	GetAndroidHeaders = GetAndroidHeader(FN,File,Mode,Offset,HeaderID)
	If GetAndroidHeaders = False Then GoTo ExitFunction
	ExitFunction:
	'رļ
	On Error Resume Next
	UnLoadFile(FN,0,Mode)
End Function


'ȡ Android ļݽṹϢ
Private Function GetAndroidHeader(FN As FILE_IMAGE,File As FILE_PROPERTIE,ByVal Mode As Long, _
				Optional ByVal Offset As Long = -1,Optional ByVal HeaderID As Integer = -1) As Boolean
	Dim i As Long
	Dim tmpResChunkHeader		As ResChunk_header
	Dim tmpResTableHeader 		As ResTable_header
	Dim tmpResStringPoolHeader	As ResStringPool_header
	ReDim File.Header(0)						'As HEADER_PROPERTIE
	ReDim File.Header(0).SecList(1)				'As SECTION_PROPERTIE
	ReDim File.Header(0).SecList(0).SubSecList(0)	'As SUB_SECTION_PROPERTIE
	ReDim File.Header(0).SecList(1).SubSecList(0)	'As SUB_SECTION_PROPERTIE
	ReDim File.Header(0).DataDirectory(0)			'As SUB_SECTION_PROPERTIE
	ReDim File.Header(0).CLRList(0)				'As SUB_SECTION_PROPERTIE
	ReDim File.Header(0).StreamList(0)			'As SUB_SECTION_PROPERTIE
	i = Offset
	If i = -1 Then i = File.FileType
	On Error GoTo ExitFunction
	File.MaxHeaderID = 0
	File.LangType = 0
	With File.Header(0)
		'ʼ
		.Magic = ""
		.FileAlign = 0
		.SecAlign = 0
		.ImageBase = 0
		.DataDirs = 0
		.MinSecID = 0
		.MaxSecID = 0
		.MaxSecIndex = 1
		.USStreamID = -1
		.NumberOfSub = 0
		.NetStreams = 0

		Select Case GetInteger(FN,i,Mode)
		'Case RES_NULL_TYPE          	'= &H0000
		'	.Magic = "Android_RES_NULL_TYPE"
    	Case RES_STRING_POOL_TYPE        '= &H0001
    		.Magic = "Android_RES_STRING_POOL_TYPE"
    		'ȡ ResStringPoolHeader ṹ
			'GetTypeValue(FN,i,tmpResStringPoolHeader,Mode)
			Select Case Mode
			Case Is < 0
				Get #FN.hFile, i + 1, tmpResStringPoolHeader
			Case 0
				CopyMemory tmpResStringPoolHeader, FN.ImageByte(i), Len(tmpResStringPoolHeader)
			Case Else
				MoveMemory tmpResStringPoolHeader, FN.MappedAddress + i, Len(tmpResStringPoolHeader)
			End Select
			If tmpResStringPoolHeader.ResChunkHeader.RES_TYPE <> RES_STRING_POOL_TYPE Then GoTo ExitFunction
			If tmpResStringPoolHeader.StringCount = 0 Then GoTo ExitFunction

			'¼εַ
			.SecList(0).sName = .Magic
			.SecList(0).lPointerToRawData = File.FileType
			.SecList(0).lSizeOfRawData = tmpResStringPoolHeader.ResChunkHeader.Size
			.SecList(0).lVirtualAddress = .SecList(0).lPointerToRawData
			.SecList(0).lVirtualSize = .SecList(0).lSizeOfRawData

			'¼ DataDirectory ַΪִִַõַ
			'ȡ tmpResStringPoolHeader ṹ
			.DataDirectory(0).lPointerToRawData = File.FileType + tmpResStringPoolHeader.stringsStart
			.DataDirectory(0).lSizeOfRawData = tmpResStringPoolHeader.ResChunkHeader.Size - tmpResStringPoolHeader.stringsStart
			.DataDirectory(0).lVirtualAddress = File.FileType + Len(tmpResStringPoolHeader)
			.DataDirectory(0).lVirtualSize = tmpResStringPoolHeader.stringsStart - Len(tmpResStringPoolHeader)
    	Case RES_TABLE_TYPE              '= &H0002
    		.Magic = "Android_RES_TABLE_TYPE"
    		'ȡ tmpResTableHeader ṹ
			'GetTypeValue(FN,i,tmpResTableHeader,Mode)
			Select Case Mode
			Case Is < 0
				Get #FN.hFile, i + 1, tmpResTableHeader
			Case 0
				CopyMemory tmpResTableHeader, FN.ImageByte(i), Len(tmpResTableHeader)
			Case Else
				MoveMemory tmpResTableHeader, FN.MappedAddress + i, Len(tmpResTableHeader)
			End Select
			If tmpResTableHeader.packageCount = 0 Then GoTo ExitFunction

			'ȡ ResStringPoolHeader ṹ
			i = i + Len(tmpResTableHeader)
			'GetTypeValue(FN,i,tmpResStringPoolHeader,Mode)
			Select Case Mode
			Case Is < 0
				Get #FN.hFile, i + 1, tmpResStringPoolHeader
			Case 0
				CopyMemory tmpResStringPoolHeader, FN.ImageByte(i), Len(tmpResStringPoolHeader)
			Case Else
				MoveMemory tmpResStringPoolHeader, FN.MappedAddress + i, Len(tmpResStringPoolHeader)
			End Select
			If tmpResStringPoolHeader.ResChunkHeader.RES_TYPE <> RES_STRING_POOL_TYPE Then GoTo ExitFunction
			If tmpResStringPoolHeader.StringCount = 0 Then GoTo ExitFunction

			'¼εַ
			.SecList(0).sName = .Magic
			.SecList(0).lPointerToRawData = File.FileType
			.SecList(0).lSizeOfRawData = tmpResTableHeader.ResChunkHeader.Size
			.SecList(0).lVirtualAddress = .SecList(0).lPointerToRawData
			.SecList(0).lVirtualSize = .SecList(0).lSizeOfRawData

			'¼ DataDirectory ַΪִִַõַ
			'ȡ tmpResStringPoolHeader ṹ
			.DataDirectory(0).lPointerToRawData = File.FileType + Len(tmpResTableHeader) + tmpResStringPoolHeader.stringsStart
			.DataDirectory(0).lSizeOfRawData = tmpResStringPoolHeader.ResChunkHeader.Size - tmpResStringPoolHeader.stringsStart
			.DataDirectory(0).lVirtualAddress = File.FileType + Len(tmpResTableHeader) + Len(tmpResStringPoolHeader)
			.DataDirectory(0).lVirtualSize = tmpResStringPoolHeader.stringsStart - Len(tmpResStringPoolHeader)
    	Case RES_XML_TYPE                '= &H0003
    		.Magic = "Android_RES_XML_TYPE"
    		'ȡ tmpResChunkHeader ṹ
			'GetTypeValue(FN,i,tmpResChunkHeader,Mode)
			Select Case Mode
			Case Is < 0
				Get #FN.hFile, i + 1, tmpResChunkHeader
			Case 0
				CopyMemory tmpResChunkHeader, FN.ImageByte(i), Len(tmpResChunkHeader)
			Case Else
				MoveMemory tmpResChunkHeader, FN.MappedAddress + i, Len(tmpResChunkHeader)
			End Select

			'ȡ ResStringPoolHeader ṹ
			i = i + Len(tmpResChunkHeader)
			'GetTypeValue(FN,i,tmpResStringPoolHeader,Mode)
			Select Case Mode
			Case Is < 0
				Get #FN.hFile, i + 1, tmpResStringPoolHeader
			Case 0
				CopyMemory tmpResStringPoolHeader, FN.ImageByte(i), Len(tmpResStringPoolHeader)
			Case Else
				MoveMemory tmpResStringPoolHeader, FN.MappedAddress + i, Len(tmpResStringPoolHeader)
			End Select
			If tmpResStringPoolHeader.ResChunkHeader.RES_TYPE <> RES_STRING_POOL_TYPE Then GoTo ExitFunction
			If tmpResStringPoolHeader.StringCount = 0 Then GoTo ExitFunction

			'¼εַ
			.SecList(0).sName = .Magic
			.SecList(0).lPointerToRawData = File.FileType
			.SecList(0).lSizeOfRawData = tmpResChunkHeader.Size
			.SecList(0).lVirtualAddress = .SecList(0).lPointerToRawData
			.SecList(0).lVirtualSize = .SecList(0).lSizeOfRawData

			'¼ִĿʼַʹС
			.DataDirectory(0).lPointerToRawData = File.FileType + Len(tmpResChunkHeader) + tmpResStringPoolHeader.stringsStart
			.DataDirectory(0).lSizeOfRawData = tmpResStringPoolHeader.ResChunkHeader.Size - tmpResStringPoolHeader.stringsStart
			'¼ĿʼַʹС
			.DataDirectory(0).lVirtualAddress = File.FileType + Len(tmpResChunkHeader) + Len(tmpResStringPoolHeader)
			.DataDirectory(0).lVirtualSize = tmpResStringPoolHeader.stringsStart - Len(tmpResStringPoolHeader)
    	'Chunk types In RES_XML_TYPE
    	'Case RES_XML_FIRST_CHUNK_TYPE    '= &H0100
    	'	.Magic = "Android_RES_XML_FIRST_CHUNK_TYPE"
    	'Case RES_XML_START_NAMESPACE_TYPE'= &H0100
    	'	.Magic = "Android_RES_XML_START_NAMESPACE_TYPE"
    	'Case RES_XML_END_NAMESPACE_TYPE  '= &H0101
    	'	.Magic = "Android_RES_XML_END_NAMESPACE_TYPE"
    	'Case RES_XML_START_ELEMENT_TYPE  '= &H0102
    	'	.Magic = "Android_RES_XML_START_ELEMENT_TYPE"
    	'Case RES_XML_END_ELEMENT_TYPE    '= &H0103
    	'	.Magic = "Android_RES_XML_END_ELEMENT_TYPE"
    	'Case RES_XML_CDATA_TYPE          '= &H0104
    	'	.Magic = "Android_RES_XML_CDATA_TYPE"
    	'Case RES_XML_LAST_CHUNK_TYPE     '= &H017F
    	'	.Magic = "Android_RES_XML_LAST_CHUNK_TYPE"
    	'This contains a uint32_t Array mapping strings In the String
    	'pool back To resource identifiers.  It Is Optional.
    	'Case RES_XML_RESOURCE_MAP_TYPE   '= &H0180
    	'	.Magic = "Android_RES_XML_RESOURCE_MAP_TYPE"
    	'Chunk types In RES_TABLE_TYPE
    	'Case RES_TABLE_PACKAGE_TYPE      '= &H0200
    	'	.Magic = "Android_RES_TABLE_PACKAGE_TYPE"
    	'Case RES_TABLE_TYPE_TYPE         '= &H0201
    	'	.Magic = "Android_RES_TABLE_TYPE_TYPE"
    	'Case RES_TABLE_TYPE_SPEC_TYPE    '= &H0202
    	'	.Magic = "Android_ RES_TABLE_TYPE_SPEC_TYPE"
    	'Case RES_TABLE_LIBRARY_TYPE      '= &H0203
    	'	.Magic = "Android_RES_TABLE_LIBRARY_TYPE"
    	Case Else
    		GoTo ExitFunction
		End Select

		'ȡ㷨еĻַ
		.ImageBase = -.DataDirectory(0).lPointerToRawData

		'ȡؽϢ
		.SecList(.MaxSecIndex).lPointerToRawData = .SecList(.MaxSecID).lPointerToRawData + .SecList(.MaxSecID).lSizeOfRawData
		.SecList(.MaxSecIndex).lSizeOfRawData = GetFileLength(FN,Mode) - .SecList(.MaxSecIndex).lPointerToRawData
		.SecList(.MaxSecIndex).lVirtualAddress = .SecList(.MaxSecID).lVirtualAddress + .SecList(.MaxSecID).lVirtualSize
		.SecList(.MaxSecIndex).lVirtualSize = .SecList(.MaxSecIndex).lSizeOfRawData
	End With

	'¼ĸͷ
	If HeaderID > -1 Then
		ResChunkHeader = tmpResChunkHeader
		ResTableHeader = tmpResTableHeader
		ResStringPoolHeader = tmpResStringPoolHeader
	End If

	'ǳɹ
	GetAndroidHeader = True
	Exit Function

	ExitFunction:
	'ReDim File.Header(0)					'As HEADER_PROPERTIE
	ReDim File.Header(0).SecList(1)			'As SECTION_PROPERTIE
	ReDim File.Header(0).DataDirectory(0)	'As SUB_SECTION_PROPERTIE
	ReDim File.Header(0).CLRList(0)			'As SUB_SECTION_PROPERTIE
	ReDim File.Header(0).StreamList(0)		'As SUB_SECTION_PROPERTIE
	File.MaxHeaderID = 0
	File.FileType = 0
	File.LangType = 0
	With File.Header(0)
		.Magic = ""
		.FileAlign = 0
		.SecAlign = 0
		.ImageBase = 0
		.DataDirs = 0
		.MinSecID = 0
		.MaxSecID = 0
		.MaxSecIndex = 1
		.USStreamID = -1
		.NumberOfSub = 0
		.NetStreams = 0
		.SecList(0).SubSecs = 0
		.SecList(1).SubSecs = 0
		'ļΪһ
		.SecList(0).lPointerToRawData = 0
		.SecList(0).lSizeOfRawData = GetFileLength(FN,Mode)
		.SecList(0).lVirtualAddress = 0
		.SecList(0).lVirtualSize = .SecList(0).lSizeOfRawData
		'ؽϢʾļϢ
		.SecList(1).lPointerToRawData = .SecList(0).lSizeOfRawData
		.SecList(1).lSizeOfRawData = 0
		.SecList(1).lVirtualAddress = .0
		.SecList(1).lVirtualSize = 0
	End With
End Function


'ӳļ
'MapSize = 0 ļʼʱĴСӳ䣬ָСӳ
'ReadOnly = 0 ֻʽдʽ
'SizeOfFile = 0 ȡļʼʱĴС򲻻ȡ
'IsPE = 0 һļӳ䣬 PE ļӳ(ÿڶ)
Private Function MapFile(ByVal strFilePath As String,LoadedImage As FILE_IMAGE,ByVal MapSize As Long, _
		ByVal ReadOnly As Long,Optional ByVal SizeOfFile As Long,Optional ByVal IsPE As Long) As Boolean
	With LoadedImage
		If UnMapFile(LoadedImage,SizeOfFile) = False Then Exit Function
		.ModuleName = strFilePath
		.hFile = CreateFile(strFilePath, _
				GENERIC_READ Or GENERIC_WRITE, _
				FILE_SHARE_READ Or FILE_SHARE_WRITE, _
				0&, _
				OPEN_EXISTING, _
				FILE_ATTRIBUTE_NORMAL Or FILE_ATTRIBUTE_ARCHIVE Or _
				FILE_ATTRIBUTE_READONLY Or FILE_ATTRIBUTE_HIDDEN Or _
				FILE_ATTRIBUTE_SYSTEM, _
				0&)
		If .hFile = 0 Then Exit Function
		If SizeOfFile = 0 Then .SizeOfFile = GetFileSize(.hFile, 0&)
		If IsPE = 0 Then
			.hMap = CreateFileMapping(.hFile, 0&, PAGE_READWRITE, 0, MapSize, vbNullChar)
		Else
			.hMap = CreateFileMapping(.hFile, 0&, PAGE_EXECUTE_READWRITE Or SEC_IMAGE, 0, MapSize, vbNullChar)
		End If
		If .hMap = 0 Then
			DisplayError "CreateFileMapping",GetLastError()
			If CloseHandle(.hFile) = 0 Then
				DisplayError "CloseHandle",GetLastError()
			End If
			Exit Function
		End If
		If ReadOnly = 0 Then
			.MappedAddress = MapViewOfFile(.hMap, FILE_MAP_READ, 0, 0, MapSize)
		Else
			.MappedAddress = MapViewOfFile(.hMap, FILE_MAP_WRITE, 0, 0, MapSize)
		End If
		If .MappedAddress = 0 Then
			DisplayError "MapViewOfFile",GetLastError()
			If CloseHandle(.hMap) = 0 Then
				DisplayError "CloseHandle",GetLastError()
			End If
			If CloseHandle(.hFile) = 0 Then
				DisplayError "CloseHandle",GetLastError()
			End If
			Exit Function
    	End If
    	If MapSize = 0 Then
    		.SizeOfImage = GetFileSize(.hFile, 0&)
    	Else
    		.SizeOfImage = MapSize
    	End If
    	MapFile = True
    End With
End Function


'رӳļ
'SizeOfFile = 0 ļʵʴС棬ָС
Private Function UnMapFile(LoadedImage As FILE_IMAGE,Optional ByVal SizeOfFile As Long) As Boolean
	With LoadedImage
		If .MappedAddress > 0 Then
			If UnmapViewOfFile(.MappedAddress) = 0 Then
				DisplayError "UnmapViewOfFile",GetLastError()
				Exit Function
			Else
				.MappedAddress = 0
			End If
		End If
		If .hMap > 0 Then
 			If CloseHandle(.hMap) = 0 Then
 				DisplayError "CloseHandle",GetLastError()
 				Exit Function
 			Else
 				.hMap = 0
 			End If
 		End If
 		If .hFile > 0 Then
 			If SizeOfFile > 0 Then
 				SetFilePointer(.hFile, SizeOfFile, 0&, 0)
 				SetEndOfFile(.hFile)
 				'WriteFile(.hFile,Mode, SizeOfFile, 0&, 0&)
 			End If
 			If CloseHandle(.hFile) = 0 Then
 				DisplayError "CloseHandle",GetLastError()
 				Exit Function
 			Else
 				.hFile = 0
 			End If
 		End If
 		If .MappedAddress + .hMap + .hFile = 0 Then
 			.ModuleName = ""
 			.SizeOfImage = 0
 			If SizeOfFile = 0 Then .SizeOfFile = 0
 			Erase LoadedImage.ImageByte
 			UnMapFile = True
 		End If
 	End With
End Function


'ȡϢ
Private Sub DisplayError(ByVal lpSource As String,ByVal dwError As Long)
    Dim GetLastDllErrMsg As String
    GetLastDllErrMsg = String$(256, 32)
    FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM Or _
    			FORMAT_MESSAGE_IGNORE_INSERTS, _
    			lpSource, dwError, 0&, _
    			GetLastDllErrMsg,Len(GetLastDllErrMsg),0&)
    Err.Raise(dwError,lpSource,Trim(GetLastDllErrMsg))
End Sub


'ȡļ
'Mode = 0 ƫƵַ(ؽ)
'Mode = 1 ƫƵַ(ؽ)
'Mode = 2 ַ(ؽ)
'Mode = 3 ַ(ؽ)
'ļšMinValMaxVal ֵ
Private Function SkipSection(Header As HEADER_PROPERTIE,ByVal Offset As Long,MinVal As Long,MaxVal As Long,Optional ByVal Mode As Long) As Long
	Dim i As Integer,j As Integer
	SkipSection = -1
	MinVal = 0: MaxVal = 0
	If Offset < 0 Then Exit Function
	If Mode < 3 Then
		For i = 0 To Header.MaxSecIndex - 1
			With Header.SecList(i)
				If Offset >= .lPointerToRawData And Offset < .lPointerToRawData + .lSizeOfRawData Then
					SkipSection = i
					MinVal = .lPointerToRawData
					MaxVal = MinVal + .lSizeOfRawData - 1
					Exit Function
				End If
			End With
		Next i
		If Mode = 1 Then
			If SkipSection = -1 Then
				With Header.SecList(Header.MaxSecIndex)
					If .lSizeOfRawData > 0 Then
						If Offset >= .lPointerToRawData And Offset < .lPointerToRawData + .lSizeOfRawData Then
							SkipSection = Header.MaxSecIndex
							MinVal = .lPointerToRawData
							MaxVal = MinVal + .lSizeOfRawData - 1
							Exit Function
						End If
					End If
				End With
			End If
		End If
		If SkipSection = -1 Then
			If Header.Magic <> "" Then
				If Offset < Header.SecList(Header.MinSecID).lPointerToRawData Then
					SkipSection = -2	'ļͷ
				ElseIf Offset > Header.SecList(Header.MaxSecIndex).lPointerToRawData Then
					SkipSection = -3	' PE ļ
				End If
			End If
		End If
	Else
		For i = 0 To Header.MaxSecIndex - 1
			With Header.SecList(i)
				If Offset >= .lVirtualAddress And Offset < .lVirtualAddress + .lVirtualSize Then
					SkipSection = i
					MinVal = .lVirtualAddress
					MaxVal = MinVal + .lVirtualSize - 1
					Exit Function
				End If
			End With
		Next i
		If Mode = 3 Then
			If SkipSection = -1 Then
				With Header.SecList(Header.MaxSecIndex)
					If .lVirtualSize > 0 Then
						If Offset >= .lVirtualAddress And Offset < .lVirtualAddress + .lVirtualSize Then
							SkipSection = Header.MaxSecIndex
							MinVal = .lVirtualAddress
							MaxVal = MinVal + .lVirtualSize - 1
							Exit Function
						End If
					End If
				End With
			End If
		End If
		If SkipSection = -1 Then
			If Header.Magic <> "" Then
				If Offset < Header.SecList(Header.MinSecID).lVirtualAddress Then
					SkipSection = -2	'ļͷ
				ElseIf Offset > Header.SecList(Header.MaxSecIndex).lVirtualAddress Then
					SkipSection = -3	' PE ļ
				End If
			End If
		End If
	End If
End Function


'ȡļ
'Mode = False ƫƵַ
'Mode = True ַ
'ļšMinValMaxVal ֵ
Public Function SkipSubSection(Header As HEADER_PROPERTIE,ByVal SecID As Integer,ByVal Offset As Long, _
				MinVal As Long,MaxVal As Long,Optional ByVal Mode As Boolean) As Long
	Dim i As Integer,j As Integer
	SkipSubSection = -1
	If SecID < 0 Then Exit Function
	If Header.SecList(SecID).SubSecs = 0 Then Exit Function
	'ֵúΪʱԲıֵ
	MinVal = 0: MaxVal = 0
	If Offset < 0 Then Exit Function
	If Mode = False Then
		For i = 0 To Header.SecList(SecID).SubSecs - 1
			With Header.SecList(SecID).SubSecList(i)
				If Offset >= .lPointerToRawData And Offset < .lPointerToRawData + .lSizeOfRawData Then
					SkipSubSection = i
					MinVal = .lPointerToRawData
					MaxVal = MinVal + .lSizeOfRawData - 1
					Exit For
				End If
			End With
		Next i
	Else
		For i = 0 To Header.SecList(SecID).SubSecs - 1
			With Header.SecList(SecID).SubSecList(i)
				If Offset >= .lVirtualAddress And Offset < .lVirtualAddress + .lVirtualSize Then
					SkipSubSection = i
					MinVal = .lVirtualAddress
					MaxVal = MinVal + .lVirtualSize - 1
					Exit For
				End If
			End With
		Next i
	End If
End Function


'ȡļͷ
'Mode = False 'ؽڣ򲻰ؽ
Private Function SkipHeaderID(File As FILE_PROPERTIE,ByVal RVA As Long,Optional ByVal Mode As Boolean) As Long
	If File.MaxHeaderID = 0 Then
		Exit Function
	ElseIf RVA < 0 Then
		Exit Function
	ElseIf RVA > File.FileSize Then
		SkipHeaderID = File.MaxHeaderID
		Exit Function
	End If
	Dim i As Integer
	If Mode = False Then
		For i = 0 To File.MaxHeaderID
			With File.Header(i)
				If RVA >= .SecList(.MinSecID).lPointerToRawData And _
					RVA <= .SecList(.MaxSecIndex).lPointerToRawData + .SecList(.MaxSecIndex).lSizeOfRawData - 1 Then
					SkipHeaderID = i
					Exit Function
				End If
			End With
		Next i
	Else
		For i = 0 To File.MaxHeaderID
			With File.Header(i)
				If RVA >= .SecList(.MinSecID).lPointerToRawData And _
					RVA <= .SecList(.MaxSecID).lPointerToRawData + .SecList(.MaxSecID).lSizeOfRawData - 1 Then
					SkipHeaderID = i
					Exit Function
				End If
			End With
		Next i
	End If
End Function


'ȡͷżַ (ĵַתΪƫƵַ)
'Mode = 0 ʱ RVA Ŀ¼
'Mode = 1 ʱRVA = RVA Ŀ¼ַ + 1SkipVal =  RVA Ŀ¼Сַ
'Mode > 1 ʱRVA = RVA Ŀ¼Сַ - 1SkipVal =  RVA СĿ¼ַ
'fType = 0 ʱ .NET US 
Private Function SkipHeader(File As FILE_PROPERTIE,RVA As Long,Optional SkipVal As Long,Optional ByVal Mode As Long,Optional ByVal fType As Long) As Long
	Dim i As Integer,j As Integer,EndPos As Long
	SkipHeader = -1
	If File.Header(0).DataDirs = 0 Then Exit Function
	i = 15 + IIf(File.LangType = NET_FILE_SIGNATURE,7 + File.Header(0).NetStreams,0)
	ReDim List(i) As IMAGE_DATA_DIRECTORY
	With File.Header(0)
		If .DataDirs > 0 Then
			For i = 0 To .DataDirs - 1
				List(j).lVirtualAddress = .DataDirectory(i).lPointerToRawData
				List(j).lSize = .DataDirectory(i).lSizeOfRawData
				j = j + 1
			Next i
		End If
		If File.LangType = NET_FILE_SIGNATURE Then
			For i = 0 To UBound(.CLRList)
				List(j).lVirtualAddress = .CLRList(i).lPointerToRawData
				List(j).lSize = .CLRList(i).lSizeOfRawData
				j = j + 1
			Next i
		End If
		If .NetStreams > 0 Then
			For i = 0 To .NetStreams - 1
				List(j).lVirtualAddress  = .StreamList(i).lPointerToRawData
				List(j).lSize = .StreamList(i).lSizeOfRawData
				If i = .USStreamID And fType > 0 Then
					fType = 0
					EndPos = .StreamList(i).lPointerToRawData + .StreamList(i).lSizeOfRawData - 1
					If RVA >= .StreamList(i).lPointerToRawData And RVA <= EndPos Then
						fType = RVA
					ElseIf Mode = 1 And RVA < EndPos Then
						fType = .StreamList(i).lPointerToRawData
					ElseIf Mode > 1 And RVA > .StreamList(i).lPointerToRawData Then
						fType = .StreamList(i).lPointerToRawData
					End If
				End If
				j = j + 1
			Next i
		Else
			fType = 0
		End If
	End With
	If j = 0 Then Exit Function
	ReDim Preserve List(j - 1)	'As IMAGE_DATA_DIRECTORY
	For i = 0 To j - 1
		With List(i)
			If .lVirtualAddress > 0 And .lSize > 0 Then
				EndPos = .lVirtualAddress + .lSize - 1		'ַ
				Select Case Mode
				Case 0
					If SkipHeader < 0 Then
						If RVA >= .lVirtualAddress And RVA <= EndPos Then
							SkipHeader = i
						End If
					Else
						If fType = 0 Then Exit Function
						If .lVirtualAddress >= List(SkipHeader).lVirtualAddress And _
							EndPos < List(SkipHeader).lVirtualAddress + List(SkipHeader).lSize Then
							If .lVirtualAddress <= fType And EndPos >= fType Then
								SkipHeader = -1
								Exit Function
							End If
						End If
					End If
				Case 1
					If .lVirtualAddress > RVA Then
						If RVA > SkipVal Then
							SkipVal = .lVirtualAddress
						ElseIf .lVirtualAddress < SkipVal Then
							SkipVal = .lVirtualAddress
						End If
					ElseIf RVA <= EndPos Then
						If fType > 0 Then
							If .lVirtualAddress <= fType And EndPos >= fType Then SkipHeader = i
						Else
							 SkipHeader = i
						End If
						RVA = EndPos + 1
						If SkipVal < EndPos Then SkipVal = EndPos
					ElseIf SkipHeader > -1 Then
						If .lVirtualAddress >= List(SkipHeader).lVirtualAddress And _
							EndPos < List(SkipHeader).lVirtualAddress + List(SkipHeader).lSize Then
							If .lVirtualAddress <= fType And EndPos >= fType Then
								SkipHeader = -1
								RVA = fType
								SkipVal = EndPos
								Exit Function
							End If
						End If
					End If
				Case Else
					If EndPos < RVA Then
						If RVA < SkipVal Then
							SkipVal = EndPos
						ElseIf EndPos > SkipVal Then
							SkipVal = EndPos
						End If
					ElseIf RVA >= .lVirtualAddress Then
						If fType > 0 Then
							If .lVirtualAddress <= fType And EndPos >= fType Then SkipHeader = i
						Else
							 SkipHeader = i
						End If
						RVA = .lVirtualAddress - 1
						If SkipVal > .lVirtualAddress Then SkipVal = .lVirtualAddress
					ElseIf SkipHeader > -1 Then
						If .lVirtualAddress >= List(SkipHeader).lVirtualAddress And _
							EndPos < List(SkipHeader).lVirtualAddress + List(SkipHeader).lSize Then
							If .lVirtualAddress <= fType And EndPos >= fType Then
								SkipHeader = -1
								RVA = fType - 1
								SkipVal = .lVirtualAddress
								Exit Function
							End If
						End If
					End If
				End Select
			End If
		End With
	Next i
End Function


'͸ļб
Private Sub ChangSectionNames(File As FILE_PROPERTIE,Optional ByVal HideSecName As String,Optional ByVal NoPEName As String)
	Dim i As Integer,j As Integer,k As Integer,Dic As Object
	Set Dic = CreateObject("Scripting.Dictionary")
	For j = 0 To File.MaxHeaderID
		With File.Header(j)
			Select Case .Magic
			Case "","NotPE32","NotPE64"
				.SecList(0).sName = NoPEName
				.SecList(1).sName = HideSecName
			Case Else
				For i = 0 To .MaxSecIndex - 1
					If Trim$(.SecList(i).sName) = "" Then
						.SecList(i).sName = "Untitled_" & CStr$(i)
					ElseIf Dic.Exists(.SecList(i).sName) Then
						.SecList(i).sName = .SecList(i).sName & "_" & CStr$(i)
					Else
						Dic.Add(.SecList(i).sName,"")
					End If
				Next i
				.SecList(i).sName = HideSecName
			End Select
			Dic.RemoveAll
			For i = 0 To .MaxSecIndex - 1
				If .SecList(i).SubSecs > 0 Then
					With File.Header(j).SecList(i)
						For k = 0 To .SubSecs - 1
							If Trim$(.SubSecList(k).sName) = "" Then
								.SubSecList(k).sName = "Untitled_" & CStr$(i)
							ElseIf Dic.Exists(.SubSecList(k).sName) Then
								.SubSecList(k).sName = .SubSecList(k).sName & "_" & CStr$(k)
							Else
								Dic.Add(.SubSecList(k).sName,"")
							End If
						Next k
					End With
					Dic.RemoveAll
				End If
			Next i
		End With
	Next j
	Set Dic = Nothing
End Sub


'ȡļƻַΧб
'Mode = 0 ȡεƣ
'Mode = 1 ȡεƣ
'Mode = 2 ȡεƺƣ
'Mode = 3 ȡεƺƣ
'Mode = 4 ȡεƺ͵ַΧ
'Mode = 5 ȡεƺ͵ַΧ

'Mode = 6 ȡεƺƺͿʼַ(˵ʽ)
'Mode = 7 ȡεƺƺͿʼַ(˵ʽ)
'Mode = 8 ȡεƺƺͽַ(˵ʽ)
'Mode = 9 ȡεƺƺͽַ(˵ʽ)

'Mode = 10 ȡIDIDϣ
'Mode = 11 ȡIDIDϣ

'Mode = 12 ȡκεĿʼַ(ֵ)
'Mode = 13 ȡκεĿʼַ(ֵ)
'Mode = 14 ȡκεĽַ(ֵ)
'Mode = 15 ȡκεĽַ(ֵ)

'Mode = 16 ȡļͷIDϣڻȡλõĿַ
'Mode = 17 ȡļͷIDϣڻȡλõĿַ

'Mode = 18 ȡļͷƺIDϣʾλã
'Mode = 19 ȡļͷƺIDϣʾλã

'ӽʽ  (ڵַ)
'ӽʽ  - ӽ (ӽڵַ)
Private Function getSectionList(File As FILE_PROPERTIE,Optional ByVal Mode As Integer, _
					Optional ByVal MaxVal As Long,Optional ByVal DisPlayFormat As Boolean) As String()
	Dim i As Integer,j As Integer,k As Integer,n As Integer,x As Integer,Temp As String
	ReDim TempList(0) As String
	For x = 0 To File.MaxHeaderID
		With File.Header(x)
			Select Case Mode
			Case 0,1	'ȡε
				Temp = IIf(File.MaxHeaderID > 0,.Magic & "-","")
				n = UBound(.SecList)
				If Mode = 0 Then
					If .SecList(n).lSizeOfRawData = 0 Then n = n - 1
				Else
					n = n - 1
				End If
				ReDim Preserve TempList(k + n) As String
				For i = 0 To n
					TempList(k) = Temp & .SecList(i).sName
					k = k + 1
				Next i
			Case 2,3	'ȡεƺ
				Temp = IIf(File.MaxHeaderID > 0,.Magic & "-","")
				n = UBound(.SecList)
				If Mode = 2 Then
					If .SecList(n).lSizeOfRawData = 0 Then n = n - 1
				Else
					n = n - 1
				End If
				ReDim Preserve TempList(k + n) As String
				For i = 0 To n
					If .SecList(i).SubSecs = 0 Then
						ReDim Preserve TempList(k + 1) As String
						TempList(k) = Temp & .SecList(i).sName
						k = k + 1
					Else
						ReDim Preserve TempList(k + .SecList(i).SubSecs) As String
						For j = 0 To .SecList(i).SubSecs - 1
							TempList(k) = Temp & .SecList(i).sName & "-" & .SecList(i).SubSecList(j).sName
							k = k + 1
						Next j
					End If
				Next i
			Case 4,5	'ȡεƺ͵ַΧ
				Temp = IIf(File.MaxHeaderID > 0,.Magic & "-","")
				n = UBound(.SecList)
				If Mode = 4 Then
					If .SecList(n).lSizeOfRawData = 0 Then n = n - 1
				Else
					n = n - 1
				End If
				ReDim Preserve TempList(k + n) As String
				For i = 0 To n
					TempList(k) = Temp & .SecList(i).sName & " (" & .SecList(i).lPointerToRawData & "-" & _
								.SecList(i).lPointerToRawData + .SecList(i).lSizeOfRawData - 1 & ")"
					k = k + 1
				Next i
			Case 6,7	'ȡεƺƺͿʼַ(˵ʽ)
				Temp = IIf(File.MaxHeaderID > 0,.Magic & "-","")
				n = UBound(.SecList)
				If Mode = 6 Then
					If .SecList(n).lSizeOfRawData = 0 Then n = n - 1
				Else
					n = n - 1
				End If
				ReDim Preserve TempList(k + n) As String
				For i = 0 To n
					If .SecList(i).SubSecs = 0 Then
						TempList(k) = Temp & .SecList(i).sName & " (" & _
									ValToStr(.SecList(i).lPointerToRawData,MaxVal,DisPlayFormat) & ")"
					Else
						ReDim TempArray(.SecList(i).SubSecs - 1) As String
						For j = 0 To .SecList(i).SubSecs - 1
							TempArray(j) = .SecList(i).SubSecList(j).sName & " (" & _
										ValToStr(.SecList(i).SubSecList(j).lPointerToRawData,MaxVal,DisPlayFormat) & ")"
						Next j
						TempList(k) = Temp & .SecList(i).sName & vbNullChar & StrListJoin(TempArray,vbNullChar)
					End If
					k = k + 1
				Next i
			Case 8,9	'ȡεƺƺͽַ(˵ʽ)
				Temp = IIf(File.MaxHeaderID > 0,.Magic & "-","")
				n = UBound(.SecList)
				If Mode = 8 Then
					If .SecList(n).lSizeOfRawData = 0 Then n = n - 1
				Else
					n = n - 1
				End If
				ReDim Preserve TempList(k + n) As String
				For i = 0 To n
					If .SecList(i).SubSecs = 0 Then
						TempList(k) = Temp & .SecList(i).sName & " (" & _
									ValToStr(.SecList(i).lPointerToRawData + _
									.SecList(i).lSizeOfRawData - 1,MaxVal,DisPlayFormat) & ")"
					Else
						ReDim TempArray(.SecList(i).SubSecs - 1) As String
						For j = 0 To .SecList(i).SubSecs - 1
							TempArray(j) = .SecList(i).SubSecList(j).sName & " (" & _
										ValToStr(.SecList(i).SubSecList(j).lPointerToRawData + _
										.SecList(i).SubSecList(j).lSizeOfRawData - 1,MaxVal,DisPlayFormat) & ")"
						Next j
						TempList(k) = Temp & .SecList(i).sName & vbNullChar & StrListJoin(TempArray,vbNullChar)
					End If
					k = k + 1
				Next i
			Case 10,11		'ȡIDID(ʾʹ)
				Temp = IIf(File.MaxHeaderID > 0,CStr$(x) & "-","")
				n = UBound(.SecList)
				If Mode = 10 Then
					If .SecList(n).lSizeOfRawData = 0 Then n = n - 1
				Else
					n = n - 1
				End If
				ReDim Preserve TempList(k + n) As String
				For i = 0 To n
					If .SecList(i).SubSecs = 0 Then
						ReDim Preserve TempList(k + 1) As String
						TempList(k) = Temp & CStr$(i)
						k = k + 1
					Else
						ReDim Preserve TempList(k + .SecList(i).SubSecs) As String
						For j = 0 To .SecList(i).SubSecs  - 1
							TempList(k) = Temp & CStr$(i) & "-" & CStr$(j)
							k = k + 1
						Next j
					End If
				Next i
			Case 12,13	'ȡκεĿʼַ(ֵ)
				n = UBound(.SecList)
				If Mode = 12 Then
					If .SecList(n).lSizeOfRawData = 0 Then n = n - 1
				Else
					n = n - 1
				End If
				ReDim Preserve TempList(k + n) As String
				For i = 0 To n
					If .SecList(i).SubSecs = 0 Then
						ReDim Preserve TempList(k + 1) As String
						TempList(k) = ValToStr(.SecList(i).lPointerToRawData,MaxVal,DisPlayFormat)
						k = k + 1
					Else
						ReDim Preserve TempList(k + .SecList(i).SubSecs) As String
						For j = 0 To .SecList(i).SubSecs - 1
							TempList(k) = ValToStr(.SecList(i).SubSecList(j).lPointerToRawData,MaxVal,DisPlayFormat)
							k = k + 1
						Next j
					End If
				Next i
			Case 14,15	'ȡκεĽַ(ֵ)
				n = UBound(.SecList)
				If Mode = 14 Then
					If .SecList(n).lSizeOfRawData = 0 Then n = n - 1
				Else
					n = n - 1
				End If
				ReDim Preserve TempList(k + n) As String
				For i = 0 To n
					If .SecList(i).SubSecs = 0 Then
						ReDim Preserve TempList(k + 1) As String
						TempList(k) = ValToStr(.SecList(i).lPointerToRawData + _
										.SecList(i).lSizeOfRawData - 1,MaxVal,DisPlayFormat)
						k = k + 1
					Else
						ReDim Preserve TempList(k + .SecList(i).SubSecs) As String
						For j = 0 To .SecList(i).SubSecs - 1
							TempList(k) = ValToStr(.SecList(i).SubSecList(j).lPointerToRawData + _
										.SecList(i).SubSecList(j).lSizeOfRawData - 1,MaxVal,DisPlayFormat)
							k = k + 1
						Next j
					End If
				Next i
			Case 16,17	'ȡļͷIDϣжǷȡַ
				n = UBound(.SecList)
				If Mode = 16 Then
					If .SecList(n).lSizeOfRawData = 0 Then n = n - 1
				Else
					n = n - 1
				End If
				ReDim Preserve TempList(k + n) As String
				For i = 0 To n
					TempList(k) = CStr$(x) & "-" & CStr$(i)
					k = k + 1
				Next i
			Case 18,19	'ȡļͷƺIDϣʾλ
				Temp = IIf(File.MaxHeaderID > 0,.Magic & "-","")
				n = UBound(.SecList)
				If Mode = 18 Then
					If .SecList(n).lSizeOfRawData = 0 Then n = n - 1
				Else
					n = n - 1
				End If
				ReDim Preserve TempList(k + n) As String
				For i = 0 To n
					TempList(k) = CStr$(x) & "+" & CStr$(i) & "-" & Temp & .SecList(i).sName
					k = k + 1
				Next i
			End Select
		End With
	Next x
	If k > 0 Then k = k - 1
	ReDim Preserve TempList(k) As String
	getSectionList = TempList
End Function


'ȡڱСȴСĵַڽ
'MinID = 0  MaxID = 0 ȡڱСַڽ
'MinID = -1 ȡ MaxID Сĵַڽ
'MaxID = -1 ȡ MinID ڴĵַڽ
'Mode = False ȽƫƵַȽַ
Private Function GetSectionID(File As FILE_PROPERTIE,ByVal HeaderID As Integer,MinID As Integer,MaxID As Integer,ByVal Mode As Boolean) As Long
	Dim i As Long,MinVal As Variant,MaxVal As Variant
	With File.Header(HeaderID)
		If Mode = False Then
			If MinID = 0 And MaxID = 0 Then
				For i = 0 To .MaxSecIndex - 1
					If .SecList(i).lPointerToRawData > 0 Then
						If MinVal = 0 Then
							MinVal = .SecList(i).lPointerToRawData
						ElseIf .SecList(i).lPointerToRawData <= MinVal Then
							MinVal = .SecList(i).lPointerToRawData
							MinID = i
						End If
						If .SecList(i).lPointerToRawData >= MaxVal Then
							MaxVal = .SecList(i).lPointerToRawData
							MaxID = i
						End If
					End If
				Next i
			ElseIf MinID < 0 Then
				MaxVal = .SecList(MaxID).lPointerToRawData
				For i = 0 To .MaxSecIndex - 1
					If .SecList(i).lSizeOfRawData > 0 Then
						If .SecList(i).lPointerToRawData < MaxVal Then
							If MinVal = 0 Then
								MinVal = .SecList(i).lPointerToRawData
								MinID = i
							ElseIf .SecList(i).lPointerToRawData > MinVal Then
								MinVal = .SecList(i).lPointerToRawData
								MinID = i
							End If
						End If
					End If
				Next i
				GetSectionID = IIf(MinID < 0,MaxID,MinID)
			ElseIf MaxID < 0 Then
				MinVal = .SecList(MinID).lPointerToRawData
				For i = 0 To .MaxSecIndex - 1
					If .SecList(i).lSizeOfRawData > 0 Then
						If .SecList(i).lPointerToRawData > MinVal Then
							If MaxVal = 0 Then
								MaxVal = .SecList(i).lPointerToRawData
								MaxID = i
							ElseIf .SecList(i).lPointerToRawData < MaxVal Then
								MaxVal = .SecList(i).lPointerToRawData
								MaxID = i
							End If
						End If
					End If
				Next i
				GetSectionID = IIf(MaxID < 0,MinID,MaxID)
			End If
		Else
			If MinID = 0 And MaxID = 0 Then
				For i = 0 To .MaxSecIndex - 1
					If .SecList(i).lVirtualAddress > 0 Then
						If MinVal = 0 Then
							MinVal = .SecList(i).lVirtualAddress
						ElseIf .SecList(i).lVirtualAddress <= MinVal Then
							MinVal = .SecList(i).lVirtualAddress
							MinID = i
						End If
						If .SecList(i).lVirtualAddress >= MaxVal Then
							MaxVal = .SecList(i).lVirtualAddress
							MaxID = i
						End If
					End If
				Next i
			ElseIf MinID < 0 Then
				MaxVal = .SecList(MaxID).lVirtualAddress
				For i = 0 To .MaxSecIndex - 1
					If .SecList(i).lVirtualSize > 0 Then
						If .SecList(i).lVirtualAddress < MaxVal Then
							If MinVal = 0 Then
								MinVal = .SecList(i).lVirtualAddress
								MinID = i
							ElseIf .SecList(i).lVirtualAddress > MinVal Then
								MinVal = .SecList(i).lVirtualAddress
								MinID = i
							End If
						End If
					End If
				Next i
				GetSectionID = IIf(MinID < 0,MaxID,MinID)
			ElseIf MaxID < 0 Then
				MinVal = .SecList(MinID).lVirtualAddress
				For i = 0 To .MaxSecIndex - 1
					If .SecList(i).lVirtualSize > 0 Then
						If .SecList(i).lVirtualAddress > MinVal Then
							If MaxVal = 0 Then
								MaxVal = .SecList(i).lVirtualAddress
								MaxID = i
							ElseIf .SecList(i).lVirtualAddress < MaxVal Then
								MaxVal = .SecList(i).lVirtualAddress
								MaxID = i
							End If
						End If
					End If
				Next i
				GetSectionID = IIf(MaxID < 0,MinID,MaxID)
			End If
		End If
	End With
End Function


'ݽںӽڵŻȡںӽڵ(ʾ)
Private Function GetSectionName(File As FILE_PROPERTIE,ByVal HeaderID As Integer,ByVal SecID As Integer,Optional ByVal SubSecID As Integer = -1) As String
	With File.Header(HeaderID)
		If File.MaxHeaderID = 0 Then
			If SecID = -1 Then
				Select Case .Magic
				Case "PE32","PE64","NET32","NET64"
					GetSectionName = NewPESecName
				Case "MAC32","MAC64"
					GetSectionName = NewMacSecName
				End Select
				Exit Function
			ElseIf SubSecID = -1 Then
				GetSectionName = .SecList(SecID).sName
				Exit Function
			ElseIf .SecList(SecID).SubSecs = 0 Then
				GetSectionName = .SecList(SecID).sName
			Else
				GetSectionName = .SecList(SecID).sName & "-" & .SecList(SecID).SubSecList(SubSecID).sName
			End If
		Else
			If SecID = -1 Then
				Select Case .Magic
				Case "PE32","PE64","NET32","NET64"
					GetSectionName = .Magic & "-" & NewPESecName
				Case "MAC32","MAC64"
					GetSectionName = .Magic & "-" & NewMacSecName
				End Select
				Exit Function
			ElseIf SubSecID = -1 Then
				GetSectionName = .Magic & "-" & .SecList(SecID).sName
				Exit Function
			ElseIf .SecList(SecID).SubSecs = 0 Then
				GetSectionName = .Magic & "-" & .SecList(SecID).sName
			Else
				GetSectionName = .Magic & "-" & .SecList(SecID).sName & "-" & .SecList(SecID).SubSecList(SubSecID).sName
			End If
		End If
	End With
End Function


'ļ
'ImageSize = 0 ļĳʼС򿪣ָС
'ReadOnly = 0 ֻʽ򿪣дʽ
'ImageByte = 0 ȡֻֽʼ(淽ʽȡֽ) ImageByte ָСȡ
'Mode < 0 ֱӷʽMode = 0 淽ʽMode > 0 ӳ䷽ʽ
'IsPE = 0 һļӳ䣬 PE ļӳ(ÿڶ)
'LoadFile = -2 ʧܣʵʴ򿪷ʽ
'LoadedImage ļȡ
Private Function LoadFile(ByVal strFilePath As String,LoadedImage As FILE_IMAGE,ByVal ImageSize As Long,ByVal ReadOnly As Long, _
		ByVal ImageByte As Long,ByVal Mode As Long,Optional ByVal IsPE As Long,Optional ByVal WaitTime As Double = 0.5) As Long
	Dim i As Long
	'Դļ
	If IsOpen(strFilePath,2,WaitTime) = True Then
		LoadFile = -2
		Exit Function
	End If
	'ļ
	On Error GoTo ErrorHandle
	LoadedImage.ModuleName = strFilePath
	If Mode < 0 Then
		LoadedImage.hFile = FreeFile
		If ReadOnly = 0 Then
			Open strFilePath For Binary Access Read Lock Write As #LoadedImage.hFile
		Else
			Open strFilePath For Binary Access Read Write Lock Write As #LoadedImage.hFile
		End If
		LoadedImage.SizeOfFile = LOF(LoadedImage.hFile)
		If ImageByte > 0 Then
			LoadedImage.SizeOfImage = ImageByte
			LoadedImage.ImageByte = GetBytes(LoadedImage,ImageByte,0,-1)
		Else
			LoadedImage.SizeOfImage = LoadedImage.SizeOfFile
			ReDim LoadedImage.ImageByte(0) 'As Byte
		End If
	Else
		If Mode > 0 Then
			If MapFile(strFilePath,LoadedImage,ImageSize,ReadOnly,0,IsPE) = True Then
				If ImageByte > 0 Then
					'LoadedImage.ImageByte = getBytesByMap(LoadedImage.MappedAddress,LoadedImage.SizeOfFile)
					LoadedImage.ImageByte = GetBytes(LoadedImage,ImageByte,0,Mode)
				Else
					ReDim LoadedImage.ImageByte(0) 'As Byte
				End If
			Else
				UnMapFile(LoadedImage,0)
				Mode = 0
			End If
		End If
		If Mode = 0 Then
			LoadedImage.hFile = FreeFile
			Open strFilePath For Binary Access Read Lock Write As #LoadedImage.hFile
			LoadedImage.SizeOfFile = LOF(LoadedImage.hFile)
			If ImageByte > 0 Then
				LoadedImage.SizeOfImage = ImageByte
				LoadedImage.ImageByte = GetBytes(LoadedImage,ImageByte,0,-1)
			Else
				LoadedImage.SizeOfImage = LoadedImage.SizeOfFile
				LoadedImage.ImageByte = GetBytes(LoadedImage,LoadedImage.SizeOfFile,0,-1)
			End If
			Close #LoadedImage.hFile
		End If
	End If
	LoadFile = Mode
	Exit Function
	ErrorHandle:
	UnLoadFile(LoadedImage,0,Mode)
	LoadFile = -2
	Err.Source = IIf(ReadOnly = 0,"NotOpenFile","NotWriteFile")
	Err.Description = Err.Description & JoinStr & strFilePath
	Call sysErrorMassage(Err,3)
End Function


'жļ
'SizeOfFile = 0 д룬ָСд룬ڻӳ䷽ʽʱЧ
Private Function UnLoadFile(LoadedImage As FILE_IMAGE,ByVal SizeOfFile As Long,ByVal Mode As Long) As Boolean
	On Error GoTo ErrorHandle
	If Mode < 0 Then
		Close #LoadedImage.hFile
		LoadedImage.ModuleName = ""
		LoadedImage.hFile = 0
		LoadedImage.hMap = 0
		LoadedImage.MappedAddress = 0
		LoadedImage.SizeOfFile = 0
		LoadedImage.SizeOfImage = 0
		Erase LoadedImage.ImageByte
		UnLoadFile = True
	ElseIf Mode = 0 Then
		If SizeOfFile > 0 Then
			LoadedImage.hFile = FreeFile
			Open LoadedImage.ModuleName For Binary Access Write Lock Write As #LoadedImage.hFile
			ReDim Preserve LoadedImage.ImageByte(LoadedImage.SizeOfFile - 1) 'As Byte
			Put #LoadedImage.hFile,1,LoadedImage.ImageByte
			Close #LoadedImage.hFile
		End If
		LoadedImage.ModuleName = ""
		LoadedImage.hFile = 0
		LoadedImage.hMap = 0
		LoadedImage.MappedAddress = 0
		LoadedImage.SizeOfFile = 0
		LoadedImage.SizeOfImage = 0
		Erase LoadedImage.ImageByte
		UnLoadFile = True
	ElseIf UnMapFile(LoadedImage,SizeOfFile) = True Then
		UnLoadFile = True
	End If
	ErrorHandle:
End Function


' .NET ִõַб
'fType = 0 Դбô
'fType = 1 ҷбô룬 RefAdds Ϊգԭõַô
'fType = 2 ҷбô룬 RefAdds Ϊգʼб
'fType > 2 ʼշбô
Private Function GetNETVARefList(File As FILE_PROPERTIE,FN As Variant,strData As STRING_SUB_PROPERTIE,ByVal StrTypeLength As Integer, _
				ByVal RefAdds As String,ByVal fType As Long,ByVal Mode As Long,Optional ByVal ShowMsg As Long) As Long
	Dim i As Long,j As Long,m As Long,n As Long
	Dim Msg As String,TempList() As String
	On Error GoTo ExitFunction
	If File.Header(0).Magic = "" Then GoTo ExitFunction
	If fType > 2 Then GoTo ExitFunction
	If ShowMsg > 0 Then
		Msg = GetTextBoxString(ShowMsg) & " "
	ElseIf ShowMsg < 0 Then
		ReDim TempList(PSL.OutputWnd(0).LineCount - 1) As String
		For i = 1 To PSL.OutputWnd(0).LineCount
			TempList(i - 1) = PSL.OutputWnd(0).Text(i)
		Next i
		Msg = StrListJoin(TempList,vbCrLf) & " "
	End If
	With strData
		'ԭ뿪ʼַôȡµַôб
		If fType < 0 Then
			'If RefAdds <> "" Then Call getRefList(strData,ReSplit(RefAdds,RefJoinStr),TempList,True)
			If .lReferenceNum = 0 Then GoTo ExitFunction
			If InStr(File.Header(0).Magic,"Android") Then
				.Reference(0).sCode = ReverseHexCode(Hex$(.lStartAddress + File.Header(0).ImageBase - StrTypeLength + .MoveLength),8)
			Else
				j = File.Header(0).StreamList(File.Header(0).USStreamID).lPointerToRawData
				.Reference(0).sCode = ReverseHexCode(Hex$(.lStartAddress - j - StrTypeLength + .MoveLength),6) & "70"
			End If
			For i = 0 To .lReferenceNum - 1
				.Reference(i).sCode = .Reference(0).sCode
			Next i
			.GetRefState = 1
			Exit Function
		End If
		If fType = 0 Then
			'ȡõ˳
			If .GetRefState > 0 Then Exit Function
			.lReferenceNum = 0
			ReDim strData.Reference(0) 'As REFERENCE_PROPERTIE
			If InStr(File.Header(0).Magic,"Android") Then
				.Reference(0).sCode = ReverseHexCode(Hex$(.lStartAddress + File.Header(0).ImageBase - StrTypeLength),8)
				i = File.Header(0).DataDirectory(0).lVirtualAddress
				If RefAdds = "" Then
					j = File.Header(0).DataDirectory(0).lVirtualSize
					RefAdds = ByteToString(GetBytes(FN,j,i,Mode),CP_ISOLATIN1)
				End If
				TempList = GetVAListRegExp(RefAdds,HexStr2RegExpPattern(.Reference(0).sCode,1),i)
			Else
				j = File.Header(0).StreamList(File.Header(0).USStreamID).lPointerToRawData
				.Reference(0).sCode = ReverseHexCode(Hex$(.lStartAddress - j - StrTypeLength),6) & "70"
				i = File.Header(0).SecList(File.Header(0).MinSecID).lPointerToRawData
				If RefAdds = "" Then
					RefAdds = ByteToString(GetBytes(FN,j - i + 1,i,Mode),CP_ISOLATIN1)
				End If
				TempList = GetVAListRegExp(RefAdds,"\x72" & HexStr2RegExpPattern(.Reference(0).sCode,1),i)
			End If
			If CheckArray(TempList) = True Then
				.lReferenceNum = UBound(TempList) + 1
				ReDim Preserve strData.Reference(.lReferenceNum - 1) 'As REFERENCE_PROPERTIE
				For i = 0 To .lReferenceNum - 1
					If InStr(File.Header(0).Magic,"Android") Then
						.Reference(i).lAddress = CLng(TempList(i))
					Else
						.Reference(i).lAddress = CLng(TempList(i)) + 1
					End If
					.Reference(i).sCode = .Reference(0).sCode
					If .Reference(i).lAddress < n Or .Reference(i).lAddress > m Then
						j = SkipSection(File.Header(0),.Reference(i).lAddress,n,m)
					End If
					.Reference(i).inHeadID = 0
					.Reference(i).inSecID = j
					If ShowMsg > 0 Then
						SetTextBoxString ShowMsg,Msg & Format$(i / .lReferenceNum,"#%")
					ElseIf ShowMsg < 0 Then
						PSL.OutputWnd(0).Clear
						PSL.Output Msg & Format$(i / .lReferenceNum,"#%")
					End If
				Next i
			End If
			.GetRefState = 1
		ElseIf RefAdds <> "" Or (.lReferenceNum > 0 And fType < 2) Then
			If RefAdds <> "" Then Call GetRefList(strData,ReSplit(RefAdds,RefJoinStr),TempList,True)
			If .lReferenceNum > 0 Then
				If InStr(File.Header(0).Magic,"Android") Then
					.Reference(0).sCode = ReverseHexCode(Hex$(.lStartAddress + File.Header(0).ImageBase - StrTypeLength),8)
				Else
					j = File.Header(0).StreamList(File.Header(0).USStreamID).lPointerToRawData
					.Reference(0).sCode = ReverseHexCode(Hex$(.lStartAddress - j - StrTypeLength),6) & "70"
				End If
				For i = 0 To .lReferenceNum - 1
					.Reference(i).sCode = .Reference(0).sCode
					If ShowMsg > 0 Then
						SetTextBoxString ShowMsg,Msg & Format$(i / .lReferenceNum,"#%")
					ElseIf ShowMsg < 0 Then
						PSL.OutputWnd(0).Clear
						PSL.Output Msg & Format$(i / .lReferenceNum,"#%")
					End If
				Next i
			End If
			.GetRefState = 1
		Else
			GoTo ExitFunction
		End If
	End With
	GetNETVARefList = strData.lReferenceNum
	If ShowMsg > 0 Then
		SetTextBoxString ShowMsg,Msg & "100%"
	ElseIf ShowMsg < 0 Then
		PSL.OutputWnd(0).Clear
		PSL.Output Msg & "100%"
	End If
	Exit Function
	'˳
	ExitFunction:
	ReDim Preserve strData.Reference(0) 'As REFERENCE_PROPERTIE
	strData.lReferenceNum = 0
	strData.GetRefState = 0
	If ShowMsg > 0 Then
		SetTextBoxString ShowMsg,Msg & "100%"
	ElseIf ShowMsg < 0 Then
		PSL.OutputWnd(0).Clear
		PSL.Output Msg & "100%"
	End If
End Function


'ôб
'fType < 0 еõַбҷôбfType Ϊԭķ뿪ʼַ
'fType = 0 Դбô
'fType = 1 ҷбô룬 RefAdds Ϊգԭõַô
'fType = 2 ҷбô룬 RefAdds Ϊգʼб
'fType > 2 ʼշбô
'ַ(VA) = StartPos + ImageBase + VRK
Private Function GetVARefList(File As FILE_PROPERTIE,FN As Variant,strData As STRING_SUB_PROPERTIE,TypeList() As STRING_TYPE, _
				ByVal TagType As Integer,ByVal Moveable As Integer,ByVal RefAdds As String,ByVal fType As Long,ByVal Mode As Long, _
				ByVal HeaderID As Integer,Optional ByVal ShowMsg As Long) As Long
	Dim i As Long,j As Long,k As Long,m As Long,n As Long
	Dim RVA As Long,VRK As Long,MaxPos As Long,RSize As Long,SkipVal As Long
	Dim Msg As String,TempList() As String,Temp As String
	'On Error GoTo ExitFunction
	If fType > 2 Then GoTo ExitFunction
	'If Moveable = 2 Then
	'	GetVARefList = GetNETVARefList(File,FN,strData,strData.StrTypeLength,RefAdds,fType,Mode,ShowMsg)
	'	Exit Function
	'End If
	'If Moveable > 0 Then GoTo ExitFunction
	With strData
	If File.LangType = NET_FILE_SIGNATURE And File.Header(0).USStreamID > -1 Then
		i = File.Header(0).StreamList(File.Header(0).USStreamID).lPointerToRawData
		j = i + File.Header(0).StreamList(File.Header(0).USStreamID).lSizeOfRawData - 1
		If .lStartAddress >= i And .lStartAddress <= j Then
			i = .lStartAddress
			Do
				i = i - 1
				If i < 1 Then Exit Do
				j = GetByte(FN,i,Mode)
				n = n + 1
			Loop Until j = 0 Or j = 1
			i = i + 1
			k = CorSigUncompressData(FN,i,j,Mode)
			If j > 0 And k + 1 = n Then
				GetVARefList = GetNETVARefList(File,FN,strData,k,RefAdds,fType,Mode,ShowMsg)
			End If
			Exit Function
		End If
	ElseIf InStr(File.Header(0).Magic,"Android") Then
		i = File.Header(0).DataDirectory(0).lPointerToRawData
		j = i + File.Header(0).DataDirectory(0).lSizeOfRawData - 1
		If .lStartAddress >= i And .lStartAddress <= j Then
			i = .lStartAddress
			If GetByte(FN,i - 1,Mode) = 0 Then
				i = i - 1
				Do
					i = i - 1
					If i < 1 Then Exit Do
					n = n + 1
				Loop Until GetByte(FN,i,Mode) = 0
				i = i + 1
				k = CorSigUncompressData(FN,i,j,Mode,CP_UNICODELITTLE)
				If j > 0 And k = n Then
					GetVARefList = GetNETVARefList(File,FN,strData,k,RefAdds,fType,Mode,ShowMsg)
				End If
			Else
				Do
					i = i - 1
					If i < 1 Then Exit Do
					n = n + 1
				Loop Until GetByte(FN,i,Mode) = 0
				i = i + 1
				k = CorSigUncompressData(FN,i,j,Mode)
				If j > 0 Then
					k = k + CorSigUncompressData(FN,i + k,j,Mode)
					If j > 0 And k + 1 = n Then
						GetVARefList = GetNETVARefList(File,FN,strData,k,RefAdds,fType,Mode,ShowMsg)
					End If
				End If
			End If
			Exit Function
		End If
	End If
	If Moveable > 0 Then GoTo ExitFunction
	If fType > -1 Then
		If .inSectionID < 0 Then .inSectionID = SkipSection(File.Header(HeaderID),.lStartAddress,0,0)
		If .inSectionID < 0 Then GoTo ExitFunction
		If File.Header(HeaderID).SecList(.inSectionID).SubSecs > 0 Then
			If .inSubSecID < 0 Then .inSubSecID = SkipSubSection(File.Header(HeaderID),.inSectionID,.lStartAddress,0,0)
		End If
		If ShowMsg > 0 Then
			Msg = GetTextBoxString(ShowMsg) & " "
		ElseIf ShowMsg < 0 Then
			ReDim TempList(PSL.OutputWnd(0).LineCount - 1) As String
			For i = 1 To PSL.OutputWnd(0).LineCount
				TempList(i - 1) = PSL.OutputWnd(0).Text(i)
			Next i
			Msg = StrListJoin(TempList,vbCrLf) & " "
		End If
		If fType > 0 Then RefAdds = Trim$(RefAdds)
	End If
	Select Case File.Header(HeaderID).Magic
	Case "PE64","NET64","MAC64","NotPE64"
		'ԭ뿪ʼַôȡµַôб
		If fType < 0 Then
			'If RefAdds <> "" Then Call getRefList(strData,ReSplit(RefAdds,RefJoinStr),TempList,True)
			If .lReferenceNum = 0 Then GoTo ExitFunction
			i = .Reference(0).inSecID
			If InStr(File.Header(HeaderID).Magic,"NotPE") = 0 Then
				VRK = File.Header(HeaderID).SecList(i).lVirtualAddress - File.Header(HeaderID).SecList(i).lPointerToRawData
				RVA = Val("&H" & ReverseHexCode(.Reference(0).sCode,8)) + .Reference(0).lAddress + VRK + 4
				RVA = RVA + fType + .lStartAddress
				For i = 0 To .lReferenceNum - 1
					j = .Reference(i).inSecID
					VRK = File.Header(HeaderID).SecList(j).lVirtualAddress - File.Header(HeaderID).SecList(j).lPointerToRawData
					.Reference(i).sCode = ReverseHexCode(Hex$(RVA - (.Reference(i).lAddress + VRK + 4)),8)
					'.Reference(i).sCode = Byte2Hex(Val2Bytes(RVA - (.Reference(i).lAddress + VRK + 4),4),0,3)
				Next i
			Else
				If UseRefTypeList(0).ByteOrder = 0 Then
					RVA = Val("&H" & ReverseHexCode(.Reference(0).sCode,UseRefTypeList(0).ByteLength * 2)) + .Reference(0).lAddress
					RVA = RVA + fType + .lStartAddress
					For i = 0 To .lReferenceNum - 1
						.Reference(i).sCode = ReverseHexCode(Hex$(RVA - .Reference(i).lAddress),UseRefTypeList(0).ByteLength * 2)
					Next i
				Else
					RVA = Val("&H" & .Reference(0).sCode) + .Reference(0).lAddress
					RVA = RVA + fType + .lStartAddress
					For i = 0 To .lReferenceNum - 1
						.Reference(i).sCode = ValToStr(RVA - .Reference(i).lAddress,-UseRefTypeList(0).ByteLength * 2,True)
					Next i
				End If
			End If
			.GetRefState = 1
			Exit Function
		End If
		If .inSectionID > File.Header(HeaderID).MaxSecIndex - 1 Then GoTo ExitFunction
		'ȡִַ
		With File.Header(HeaderID).SecList(.inSectionID)
			If strData.lStartAddress >= .lPointerToRawData And strData.lStartAddress < .lPointerToRawData + .lSizeOfRawData Then
				RVA = strData.lStartAddress + .lVirtualAddress - .lPointerToRawData
			Else
				GoTo ExitFunction
			End If
		End With
		If fType = 0 Then
			'ȡõ˳
			If .GetRefState > 0 Then Exit Function
			If SkipHeader(File,strData.lStartAddress,0,0) > -1 Then GoTo ExitFunction
			.lReferenceNum = 0
			ReDim strData.Reference(0) 'As REFERENCE_PROPERTIE
			If InStr(File.Header(HeaderID).Magic,"NotPE") = 0 Then
				MaxPos = strData.lStartAddress - 4
				For j = 0 To IIf(.inSectionID = 0,0,.inSectionID - 1)
					With File.Header(HeaderID).SecList(j)
						i = .lPointerToRawData
						RSize = i + .lSizeOfRawData - 4
						VRK = RVA - (.lVirtualAddress - .lPointerToRawData) - 4
					End With
					If RSize > MaxPos Then RSize = MaxPos
					SkipVal = i - 1
					Do While i < RSize
						'ųĳЩĿ¼κ .NET ļ
						If i > SkipVal Then
							k = i: m = SkipHeader(File,k,SkipVal,1)
							If m = 2 Or m = 4 Or m = 5 Or m > 15 Then i = k
							If i > SkipVal Or SkipVal > RSize Then SkipVal = RSize + 1
							If i > RSize Then Exit Do
						End If
						i = i + GetVAListPE64(FN,strData,n,j,VRK,i,SkipVal,Mode,HeaderID) + 1
						If ShowMsg > 0 Then
							SetTextBoxString ShowMsg,Msg & Format$(i / MaxPos,"#%")
						ElseIf ShowMsg < 0 Then
							PSL.OutputWnd(0).Clear
							PSL.Output Msg & Format$(i / MaxPos,"#%")
						End If
					Loop
				Next j
			Else
				MaxPos = strData.lStartAddress
				With File.Header(HeaderID).SecList(0)
					i = .lPointerToRawData
					RSize = i + .lSizeOfRawData
					VRK = RVA - (.lVirtualAddress - .lPointerToRawData)
				End With
				If RSize > MaxPos Then RSize = MaxPos
				SkipVal = i - 1
				Do While i < RSize
					i = i + GetVAListNotPE64(FN,strData,n,0,VRK,i,SkipVal,Mode) + 1
					If ShowMsg > 0 Then
						SetTextBoxString ShowMsg,Msg & Format$(i / MaxPos,"#%")
					ElseIf ShowMsg < 0 Then
						PSL.OutputWnd(0).Clear
						PSL.Output Msg & Format$(i / MaxPos,"#%")
					End If
				Loop
			End If
			If .lReferenceNum > 0 Then
				ReDim Preserve strData.Reference(.lReferenceNum - 1) 'As REFERENCE_PROPERTIE
				'If TagType > 1 Then Call GetCustomStrTypeRegExp(FN,strData,TypeList,Mode,-1)
			End If
			.GetRefState = 1
		ElseIf RefAdds <> "" Or (.lReferenceNum > 0 And fType < 2) Then
			If RefAdds <> "" Then Call GetRefList(strData,ReSplit(RefAdds,RefJoinStr),TempList,True)
			If .lReferenceNum > 0 Then
				If InStr(File.Header(HeaderID).Magic,"NotPE") = 0 Then
					For i = 0 To .lReferenceNum - 1
						j = .Reference(i).inSecID
						VRK = File.Header(HeaderID).SecList(j).lVirtualAddress - File.Header(HeaderID).SecList(j).lPointerToRawData
						.Reference(i).sCode = ReverseHexCode(Hex$(RVA - (.Reference(i).lAddress + VRK + 4)),8)
						'.Reference(i).sCode = Byte2Hex(Val2Bytes(RVA - (.Reference(i).lAddress + VRK + 4),4),0,3)
						If ShowMsg > 0 Then
							SetTextBoxString ShowMsg,Msg & Format$(i / .lReferenceNum,"#%")
						ElseIf ShowMsg < 0 Then
							PSL.OutputWnd(0).Clear
							PSL.Output Msg & Format$(i / .lReferenceNum,"#%")
						End If
					Next i
				ElseIf UseRefTypeList(0).ByteOrder = 0 Then
					For i = 0 To .lReferenceNum - 1
						Temp = Replace(Replace(Replace(UseRefTypeList(0).Algorithm,"{strstartaddress}",CStr(RVA)), _
								"{refstartaddress}",CStr(.Reference(i).lAddress)),"{strtypelength}",CStr(.StrTypeLength))
						.Reference(i).sCode = ReverseHexCode(Hex$(Eval(Temp)),UseRefTypeList(0).ByteLength * 2)
						If ShowMsg > 0 Then
							SetTextBoxString ShowMsg,Msg & Format$(i / .lReferenceNum,"#%")
						ElseIf ShowMsg < 0 Then
							PSL.OutputWnd(0).Clear
							PSL.Output Msg & Format$(i / .lReferenceNum,"#%")
						End If
					Next i
				Else
					For i = 0 To .lReferenceNum - 1
						Temp = Replace(Replace(Replace(UseRefTypeList(0).Algorithm,"{strstartaddress}",CStr(RVA)), _
								"{refstartaddress}",CStr(.Reference(i).lAddress)),"{strtypelength}",CStr(.StrTypeLength))
						.Reference(i).sCode = ValToStr(Eval(Temp),-UseRefTypeList(0).ByteLength * 2,True)
						If ShowMsg > 0 Then
							SetTextBoxString ShowMsg,Msg & Format$(i / .lReferenceNum,"#%")
						ElseIf ShowMsg < 0 Then
							PSL.OutputWnd(0).Clear
							PSL.Output Msg & Format$(i / .lReferenceNum,"#%")
						End If
					Next i
				End If
				.GetRefState = 1
			End If
		Else
			GoTo ExitFunction
		End If
	Case Else
		'ԭ뿪ʼַôȡµַôб
		If fType < 0 Then
			'If RefAdds <> "" Then Call getRefList(strData,ReSplit(RefAdds,RefJoinStr),TempList,True)
			If .lReferenceNum = 0 Then GoTo ExitFunction
			If InStr(File.Header(HeaderID).Magic,"NotPE") = 0 Then
				VRK = Val("&H" & ReverseHexCode(.Reference(0).sCode,8)) + fType
				.Reference(0).sCode = ReverseHexCode(Hex$(.lStartAddress + VRK),8)
				'.Reference(0).sCode = Byte2Hex(Val2Bytes(.lStartAddress + VRK,4),0,3)
			Else
				Temp = Replace(Replace(UseRefTypeList(0).Algorithm,"{strstartaddress}",CStr(.lStartAddress)), _
						"{strtypelength}",CStr(.StrTypeLength))
				If UseRefTypeList(0).ByteOrder = 0 Then
					VRK = Val("&H" & ReverseHexCode(.Reference(0).sCode,UseRefTypeList(0).ByteLength * 2)) + fType
					.Reference(0).sCode = ReverseHexCode(Hex$(Eval(Temp) + VRK),UseRefTypeList(0).ByteLength * 2)
				Else
					VRK = Val("&H" & .Reference(0).sCode) + fType
					.Reference(0).sCode = ValToStr(Eval(Temp) + VRK,-UseRefTypeList(0).ByteLength * 2,True)
				End If
			End If
			For i = 0 To .lReferenceNum - 1
				.Reference(i).sCode = .Reference(0).sCode
			Next i
			.GetRefState = 1
			Exit Function
		End If
		If .inSectionID > File.Header(HeaderID).MaxSecIndex - 1 Then GoTo ExitFunction
		'ȡִַ
		If File.Header(HeaderID).SecList(.inSectionID).SubSecs > 0 Then
			If .inSubSecID > -1 Then
				With File.Header(HeaderID).SecList(.inSectionID).SubSecList(.inSubSecID)
					If strData.lStartAddress >= .lPointerToRawData And strData.lStartAddress < .lPointerToRawData + .lSizeOfRawData Then
						VRK = .lVirtualAddress - .lPointerToRawData + File.Header(HeaderID).ImageBase
					Else
						GoTo ExitFunction
					End If
				End With
			Else
				With File.Header(HeaderID).SecList(.inSectionID)
					If strData.lStartAddress >= .lPointerToRawData And strData.lStartAddress < .lPointerToRawData + .lSizeOfRawData Then
						VRK = .lVirtualAddress - .lPointerToRawData + File.Header(HeaderID).ImageBase
					Else
						GoTo ExitFunction
					End If
				End With
			End If
		Else
			With File.Header(HeaderID).SecList(.inSectionID)
				If strData.lStartAddress >= .lPointerToRawData And strData.lStartAddress < .lPointerToRawData + .lSizeOfRawData Then
					VRK = .lVirtualAddress - .lPointerToRawData + File.Header(HeaderID).ImageBase
				Else
					GoTo ExitFunction
				End If
			End With
		End If
		'ȡõַôб
		If fType = 0 Then
			'ȡõ˳
			If .GetRefState > 0 Then Exit Function
			If SkipHeader(File,strData.lStartAddress,0,0) > -1 Then GoTo ExitFunction
			With File.Header(HeaderID)
				If InStr(.Magic,"Android") Then
					SkipVal = .DataDirectory(0).lVirtualAddress
				Else
					SkipVal = .SecList(.MinSecID).lPointerToRawData
				End If
				If RefAdds = "" Then
					If InStr(.Magic,"Android") Then
						RSize = .DataDirectory(0).lVirtualAddress + .DataDirectory(0).lVirtualSize - 1
					ElseIf .DataDirs > 0 Then
						If .DataDirectory(2).lPointerToRawData > 0 Then
							RSize = .DataDirectory(2).lPointerToRawData - 1
						Else
							RSize = .SecList(.MaxSecID).lPointerToRawData + .SecList(.MaxSecID).lSizeOfRawData - 1
						End If
					ElseIf InStr(.Magic,"NotPE") = 0 Then
						RSize = .SecList(.MaxSecID).lPointerToRawData + .SecList(.MaxSecID).lSizeOfRawData - 1
					ElseIf UseRefTypeList(0).BaseAddress = 0 Then
						RSize = .SecList(.MaxSecID).lPointerToRawData + .SecList(.MaxSecID).lSizeOfRawData - 1
					Else
						RSize = UseRefTypeList(0).BaseAddress
					End If
					RefAdds = ByteToString(GetBytes(FN,RSize - SkipVal + 1,SkipVal,Mode),CP_ISOLATIN1)
				End If
			End With
			.lReferenceNum = 0
			ReDim strData.Reference(0) 'As REFERENCE_PROPERTIE
			If InStr(File.Header(HeaderID).Magic,"Android") Then
				.Reference(0).sCode = ReverseHexCode(Hex$(.lStartAddress + VRK - .StrTypeLength),8)
				TempList = GetVAListRegExp(RefAdds,HexStr2RegExpPattern(.Reference(0).sCode,1),SkipVal)
			ElseIf InStr(File.Header(HeaderID).Magic,"NotPE") = 0 Then
				.Reference(0).sCode = ReverseHexCode(Hex$(.lStartAddress + VRK),8)
				TempList = GetVAListRegExp(RefAdds,HexStr2RegExpPattern(.Reference(0).sCode,1),SkipVal)
			Else
				Temp = Replace(Replace(UseRefTypeList(0).Algorithm,"{strstartaddress}",CStr(.lStartAddress)), _
						"{strtypelength}",CStr(.StrTypeLength))
				If UseRefTypeList(0).ByteOrder = 0 Then
					.Reference(0).sCode = ReverseHexCode(Hex$(Eval(Temp)),UseRefTypeList(0).ByteLength * 2)
				Else
					.Reference(0).sCode = ValToStr(Eval(Temp),-UseRefTypeList(0).ByteLength * 2,True)
				End If
				TempList = GetVAListRegExp(RefAdds,UseRefTypeList(0).PrefixByte & HexStr2RegExpPattern(.Reference(0).sCode,1),SkipVal)
			End If
			If CheckArray(TempList) = True Then
				.lReferenceNum = UBound(TempList) + 1
				ReDim Preserve strData.Reference(.lReferenceNum - 1) 'As REFERENCE_PROPERTIE
				m = 0: n = 0
				For i = 0 To .lReferenceNum - 1
					.Reference(i).lAddress = CLng(TempList(i)) + UseRefTypeList(0).PrefixLength
					.Reference(i).sCode = .Reference(0).sCode
					If .Reference(i).lAddress < n Or .Reference(i).lAddress > m Then
						k = SkipSection(File.Header(HeaderID),.Reference(i).lAddress,n,m)
					End If
					.Reference(i).inHeadID = HeaderID
					.Reference(i).inSecID = k
					If ShowMsg > 0 Then
						SetTextBoxString ShowMsg,Msg & Format$(i / .lReferenceNum,"#%")
					ElseIf ShowMsg < 0 Then
						PSL.OutputWnd(0).Clear
						PSL.Output Msg & Format$(i / .lReferenceNum,"#%")
					End If
				Next i
				'If TagType > 1 Then Call GetCustomStrTypeRegExp(FN,strData,TypeList,Mode,-1)
			End If
			.GetRefState = 1
		ElseIf RefAdds <> "" Or (.lReferenceNum > 0 And fType < 2) Then
			If RefAdds <> "" Then Call GetRefList(strData,ReSplit(RefAdds,RefJoinStr),TempList,True)
			If .lReferenceNum > 0 Then
				If InStr(File.Header(HeaderID).Magic,"Android") Then
					.Reference(0).sCode = ReverseHexCode(Hex$(.lStartAddress + VRK - .StrTypeLength),8)
				ElseIf InStr(File.Header(HeaderID).Magic,"NotPE") = 0 Then
					.Reference(0).sCode = ReverseHexCode(Hex$(.lStartAddress + VRK),8)
					'.Reference(0).sCode = Byte2Hex(Val2Bytes(.lStartAddress + VRK,4),0,3)
				Else
					Temp = Replace(Replace(UseRefTypeList(0).Algorithm,"{strstartaddress}",CStr(.lStartAddress)), _
							"{strtypelength}",CStr(.StrTypeLength))
					If UseRefTypeList(0).ByteOrder = 0 Then
						.Reference(0).sCode = ReverseHexCode(Hex$(Eval(Temp)),UseRefTypeList(0).ByteLength * 2)
					Else
						.Reference(0).sCode = ValToStr(Eval(Temp),-UseRefTypeList(0).ByteLength * 2,True)
					End If
				End If
				For i = 0 To .lReferenceNum - 1
					.Reference(i).sCode = .Reference(0).sCode
					If ShowMsg > 0 Then
						SetTextBoxString ShowMsg,Msg & Format$(i / .lReferenceNum,"#%")
					ElseIf ShowMsg < 0 Then
						PSL.OutputWnd(0).Clear
						PSL.Output Msg & Format$(i / .lReferenceNum,"#%")
					End If
				Next i
				.GetRefState = 1
			End If
		Else
			GoTo ExitFunction
		End If
	End Select
	GetVARefList = .lReferenceNum
	End With
	If ShowMsg > 0 Then
		SetTextBoxString ShowMsg,Msg & "100%"
	ElseIf ShowMsg < 0 Then
		PSL.OutputWnd(0).Clear
		PSL.Output Msg & "100%"
	End If
	Exit Function
	'˳
	ExitFunction:
	ReDim strData.Reference(0) 'As REFERENCE_PROPERTIE
	strData.lReferenceNum = 0
	strData.GetRefState = 0
	If ShowMsg > 0 Then
		SetTextBoxString ShowMsg,Msg & "100%"
	ElseIf ShowMsg < 0 Then
		PSL.OutputWnd(0).Clear
		PSL.Output Msg & "100%"
	End If
End Function


'ȡ NotPE64 ԭʼִõַʹ
' GetVAListNotPE64 = 
Private Function GetVAListNotPE64(FN As Variant,strData As STRING_SUB_PROPERTIE,RefMaxNum As Long,ByVal SecID As Long, _
				ByVal VRK As Long,ByVal StartPos As Long,ByVal RSize As Long,ByVal Mode As Long) As Long
	Dim i As Long,Temp As String,Bytes() As Byte
	With strData
		'i = (VRK - StartPos) And &HFF	'3ֽڲңٶȽ
		'i = Val("&H" & Right$("0000" & Hex$(VRK - StartPos),4))	'2ֽڲңٶȽϿ
		i = (VRK - StartPos) And 65535	'2ֽڲңٶȽϿ죬 65535 滻 &HFFFFΪ &HFFFF Ϊ -1
		If i > RSize - StartPos Then i = RSize - StartPos
		If i > .lStartAddress - StartPos Then i = .lStartAddress - StartPos
		RSize = UseRefTypeList(0).PrefixLength
		If i > 0 Then
			GetVAListNotPE64 = i
			'ʽңٶȽϿ죬3ֽڲʱʼַΪ StartPos + 1Ϊ StartPos + 2
			ReDim TempList(0) As String
			If UseRefTypeList(0).ByteOrder = 0 Then
				Temp = HexStr2RegExpPattern(Right$(ReverseHexCode(Hex$(VRK - StartPos),UseRefTypeList(0).ByteLength * 2),UseRefTypeList(0).ByteLength),1)
				Temp = UseRefTypeList(0).PrefixByte & "[\x00-\xFF]{" & UseRefTypeList(0).ByteLength \ 2 & "}" & Temp
			Else
				Temp = HexStr2RegExpPattern(Left$(ValToStr(VRK - StartPos,-UseRefTypeList(0).ByteLength * 2,True),UseRefTypeList(0).ByteLength),1)
				Temp = UseRefTypeList(0).PrefixByte & Temp
			End If
			TempList = GetVAListRegExp(ByteToString(GetBytes(FN,i + 4,StartPos - RSize,Mode),CP_ISOLATIN1),Temp,StartPos - RSize)
			'ֽңٶȽ3ֽڲʱʼַΪ StartPos + 1Ϊ StartPos + 2
			'TempList = GetVAList(FN.ImageByte,Val2BytesRev(VRK - StartPos,4,2),StartPos + 2,StartPos + 2 + GetVAListPE64)
			If CheckArray(TempList) = False Then Exit Function
			For i = 0 To UBound(TempList)
				StartPos = CLng(TempList(i)) + RSize
				If VRK > StartPos Then
					'ȡַ(ôֵ)жǷȷ
					Temp = Replace(Replace(Replace(UseRefTypeList(0).Algorithm,"{strstartaddress}",CStr(VRK)), _
							"{refstartaddress}",CStr(StartPos)),"{strtypelength}",CStr(.StrTypeLength))
					Bytes = Val2Bytes(Eval(Temp),UseRefTypeList(0).ByteLength,-UseRefTypeList(0).ByteOrder)
					If Bytes = GetBytes(FN,UseRefTypeList(0).ByteLength,StartPos,Mode) Then
						If .lReferenceNum > RefMaxNum Then
							RefMaxNum = .lReferenceNum + 20
							ReDim Preserve strData.Reference(RefMaxNum) 'As REFERENCE_PROPERTIE
						End If
						'ҵõַô
						.Reference(.lReferenceNum).lAddress = StartPos
						.Reference(.lReferenceNum).sCode = Byte2Hex(GetBytes(FN,UseRefTypeList(0).ByteLength,StartPos,Mode),0,UseRefTypeList(0).ByteLength - 1)
						.Reference(.lReferenceNum).inHeadID = 0
						.Reference(.lReferenceNum).inSecID = SecID
						.lReferenceNum = .lReferenceNum + 1
					End If
				End If
			Next i
		ElseIf VRK > StartPos Then
			'ȡַ(ôֵ)жǷȷ
			If UseRefTypeList(0).PrefixByte <> "" Then
				TempList = GetVAListRegExp(ByteToString(GetBytes(FN,5,StartPos - RSize,Mode),CP_ISOLATIN1),UseRefTypeList(0).PrefixByte,StartPos - RSize)
				If CheckArray(TempList) = False Then Exit Function
			End If
			Temp = Replace(Replace(Replace(UseRefTypeList(0).Algorithm,"{strstartaddress}",CStr(VRK)), _
					"{refstartaddress}",CStr(StartPos)),"{strtypelength}",CStr(.StrTypeLength))
			Bytes = Val2Bytes(Eval(Temp),UseRefTypeList(0).ByteLength,-UseRefTypeList(0).ByteOrder)
			If Bytes = GetBytes(FN,UseRefTypeList(0).ByteLength,StartPos,Mode) Then
				GetVAListNotPE64 = 3
				If .lReferenceNum > RefMaxNum Then
					RefMaxNum = .lReferenceNum + 20
					ReDim Preserve strData.Reference(RefMaxNum) 'As REFERENCE_PROPERTIE
				End If
				'ҵõַô
				.Reference(.lReferenceNum).lAddress = StartPos
				.Reference(.lReferenceNum).sCode = Byte2Hex(GetBytes(FN,UseRefTypeList(0).ByteLength,StartPos,Mode),0,UseRefTypeList(0).ByteLength - 1)
				.Reference(.lReferenceNum).inHeadID = 0
				.Reference(.lReferenceNum).inSecID = SecID
				.lReferenceNum = .lReferenceNum + 1
			End If
		End If
	End With
End Function


'ȡ PE64 ԭʼִõַʹ
' GetVAListPE64 = 
Private Function GetVAListPE64(FN As Variant,strData As STRING_SUB_PROPERTIE,RefMaxNum As Long,ByVal SecID As Long, _
				ByVal VRK As Long,ByVal StartPos As Long,ByVal RSize As Long,ByVal Mode As Long,ByVal HeaderID As Integer) As Long
	Dim i As Long,Temp As String
	With strData
		'i = (VRK - StartPos) And &HFF	'3ֽڲңٶȽ
		'i = Val("&H" & Right$("0000" & Hex$(VRK - StartPos),4))	'2ֽڲңٶȽϿ
		i = (VRK - StartPos) And 65535	'2ֽڲңٶȽϿ죬 65535 滻 &HFFFFΪ &HFFFF Ϊ -1
		If i > RSize - StartPos Then i = RSize - StartPos
		If i > .lStartAddress - StartPos - 4 Then i = .lStartAddress - StartPos - 4
		If i > 0 Then
			GetVAListPE64 = i
			'ʽңٶȽϿ죬3ֽڲʱʼַΪ StartPos + 1Ϊ StartPos + 2
			ReDim TempList(0) As String
			Temp = RefFrontChar64 & HexStr2RegExpPattern(Right$(ReverseHexCode(Hex$(VRK - StartPos),8),4),1)
			TempList = GetVAListRegExp(ByteToString(GetBytes(FN,i + 4,StartPos - 3,Mode),CP_ISOLATIN1),Temp,StartPos - 3)
			'ֽңٶȽ3ֽڲʱʼַΪ StartPos + 1Ϊ StartPos + 2
			'TempList = GetVAList(FN.ImageByte,Val2BytesRev(VRK - StartPos,4,2),StartPos + 2,StartPos + 2 + GetVAListPE64)
			If CheckArray(TempList) = False Then Exit Function
			For i = 0 To UBound(TempList)
				StartPos = CLng(TempList(i)) + 3	'ǰ3Ϊõ룬3ֽ
				If VRK > StartPos Then
					'ȡַ(ôֵ)жǷȷ
					RSize = GetLong(FN,StartPos,Mode)
					If RSize > 0 And RSize = VRK - StartPos Then
						If .lReferenceNum > RefMaxNum Then
							RefMaxNum = .lReferenceNum + 20
							ReDim Preserve strData.Reference(RefMaxNum) 'As REFERENCE_PROPERTIE
						End If
						'ҵõַô
						.Reference(.lReferenceNum).lAddress = StartPos
						.Reference(.lReferenceNum).sCode = Byte2Hex(GetBytes(FN,4,StartPos,Mode),0,3)
						.Reference(.lReferenceNum).inHeadID = HeaderID
						.Reference(.lReferenceNum).inSecID = SecID
						.lReferenceNum = .lReferenceNum + 1
					End If
				End If
			Next i
		ElseIf VRK > StartPos Then
			'ȡַ(ôֵ)жǷȷ
			TempList = GetVAListRegExp(ByteToString(GetBytes(FN,5,StartPos - 3,Mode),CP_ISOLATIN1),RefFrontChar64,StartPos - 3)
			If CheckArray(TempList) = False Then Exit Function
			RSize = GetLong(FN,StartPos,Mode)
			If RSize > 0 And RSize = VRK - StartPos Then
				GetVAListPE64 = 3
				If .lReferenceNum > RefMaxNum Then
					RefMaxNum = .lReferenceNum + 20
					ReDim Preserve strData.Reference(RefMaxNum) 'As REFERENCE_PROPERTIE
				End If
				'ҵõַô
				.Reference(.lReferenceNum).lAddress = StartPos
				.Reference(.lReferenceNum).sCode = Byte2Hex(GetBytes(FN,4,StartPos,Mode),0,3)
				.Reference(.lReferenceNum).inHeadID = HeaderID
				.Reference(.lReferenceNum).inSecID = SecID
				.lReferenceNum = .lReferenceNum + 1
			End If
		End If
	End With
End Function


'ȡֽҵƥб(VBʽ)
'ע⣺StartPosEndPos Ϊ 0 ʼĵַ
Private Function GetVAList(Bytes() As Byte,Find() As Byte,Optional ByVal StartPos As Long,Optional ByVal EndPos As Long) As String()
	Dim i As Long,j As Long,k As Long,m As Long,n As Long,Length As Long,TempByte() As Byte
	Length = UBound(Find) + 1
	TempByte = Find
	k = -1
	For i = 0 To Length - 1
		If Find(i) <> 0 Then
			If i <> 0 Then
				ReDim TempByte(Length - i - 1) As Byte
				CopyMemory TempByte(0), Find(i), Length - i
			End If
			k = i
			Exit For
		End If
	Next i
	If k = -1 Then
		If EndPos <= StartPos Then Exit Function
		ReDim TempByte(EndPos - StartPos) As Byte
		CopyMemory TempByte(0), Bytes(StartPos), EndPos - StartPos + 1
		GetVAList = GetVAListRegExp(ByteToString(TempByte,CP_ISOLATIN1),"\x00{" & CStr$(Length) & ",}",StartPos)
		Exit Function
	End If
	m = 50
	ReDim TempList(m) As String
	i = InStrB(StartPos + k + 1,Bytes,TempByte)
	Do While i > 0
		If k > 0 Then
			For j = i - k - 1 To i - 2
				If Bytes(j) <> 0 Then GoTo NextNum
			Next j
			i = i - k
		End If
		If EndPos > 0 Then
			If i + Length - 2 > EndPos Then Exit Do
		End If
		If n > m Then
			m = m * 2
			ReDim Preserve TempList(m) As String
		End If
		TempList(n) = CStr(i - 1)    'ע InStrB ҵһͷ"1"
		n = n + 1
		NextNum:
		i = InStrB(i + Length,Bytes,TempByte)
	Loop
	If n > 0 Then n = n - 1
	ReDim Preserve TempList(n) As String
	GetVAList = TempList
End Function


'ȡֽҵƥб(ʽʽ)
'ע⣺StartPosEndPos Ϊ 0 ʼĵַ
Private Function GetVAListRegExp(ByVal StrText As String,ByVal Patrn As String,ByVal StartPos As Long) As String()
	Dim i As Long,Matches As Object
	On Error GoTo ExitFunction
	RegExp.Global = True
	RegExp.IgnoreCase = False
	RegExp.Pattern = Patrn
	Set Matches = RegExp.Execute(StrText)
	If Matches.Count = 0 Then Exit Function
	ReDim TempList(Matches.Count - 1) As String
	For i = 0 To Matches.Count - 1
		TempList(i) = CStr$(StartPos + Matches(i).FirstIndex)
	Next i
	GetVAListRegExp = TempList
	ExitFunction:
End Function


'ת Hex 
Private Function ReverseHexCode(ByVal HexStr As String,ByVal Num As Long) As String
	Dim i As Long
	i = Len(HexStr)
	If i < Num Then HexStr = String$(Num - i,"0") & HexStr
	ReverseHexCode = HexStr
	For i = 1 To Num - 1 Step 2
		Mid$(ReverseHexCode,i,2) = Mid$(HexStr,Num - i,2)
	Next i
End Function


'ֽת Hex 
'StartPos <= EndPos ȡλλ Hex 룬ȡλλ Hex 
Private Function Byte2Hex(Bytes As Variant,ByVal StartPos As Long,ByVal EndPos As Long) As String
	Dim i As Long,n As Long
	If StartPos < 0 Then StartPos = LBound(Bytes)
	If EndPos < 0 Then EndPos = UBound(Bytes)
	Byte2Hex = Space$((Abs(EndPos - StartPos) + 1) * 2)
	n = 1
	For i = StartPos To EndPos Step IIf(StartPos <= EndPos,1,-1)
		Mid$(Byte2Hex,n,2) = Right$("0" & Hex$(Bytes(i)),2)
		n = n + 2
	Next i
End Function


'תֽΪֵ
'ByteOrder = False λںת򰴸λǰת
Private Function Bytes2Val(Bytes() As Byte,ByVal Length As Integer,Optional ByVal ByteOrder As Boolean) As Long
	On Error GoTo errHandle
	If UBound(Bytes) + 1 < Length Then Exit Function
	If ByteOrder = False Then
		CopyMemory Bytes2Val, Bytes(0), Length
	Else
		CopyMemory Bytes2Val, ReverseValByte(Bytes,0,-1)(0), Length
	End If
	errHandle:
End Function


'תֵΪֽ(ڳȵĸλض)
Private Function Val2Bytes(ByVal Value As Long,ByVal Length As Integer,Optional ByVal ByteOrder As Boolean) As Byte()
	On Error GoTo errHandle
	ReDim Bytes(Length - 1) As Byte
	CopyMemory Bytes(0), Value, Length
	If ByteOrder = False Then
		Val2Bytes = Bytes
	Else
		Val2Bytes = ReverseValByte(Bytes,0,-1)
	End If
	Exit Function
	errHandle:
	ReDim Bytes(0) As Byte
	Val2Bytes = Bytes
End Function


'תֵΪֽ(ڳȵĵλض)
Private Function Val2BytesRev(ByVal Value As Long,ByVal MaxLength As Integer,ByVal Length As Integer,Optional ByVal ByteOrder As Boolean) As Byte()
	On Error GoTo errHandle
	If GetEvenPos(Len(Hex$(Value))) \ 2 > MaxLength Then GoTo errHandle
	ReDim Bytes(MaxLength - 1) As Byte
	CopyMemory Bytes(0), Value, MaxLength
	If MaxLength > Length Then
		CopyMemory Bytes(0), Bytes(MaxLength - Length), Length
		ReDim Preserve Bytes(Length - 1) As Byte
	End If
	If ByteOrder = False Then
		Val2BytesRev = Bytes
	Else
		Val2BytesRev = ReverseValByte(Bytes,0,-1)
	End If
	Exit Function
	errHandle:
	ReDim Bytes(0) As Byte
	Val2BytesRev = Bytes
End Function


'ִǷΪգǿշ True
Private Function CheckArray(DataList() As String) As Boolean
	Dim i As Long
	On Error GoTo errHandle
	For i = LBound(DataList) To UBound(DataList)
		If DataList(i) <> "" Then
			CheckArray = True
			Exit For
		End If
	Next i
	errHandle:
End Function


'Hex ַתʽʹõ Hex תģ
'Mode = 0 תΪ [] ʽΪ [] ʽ
Private Function HexStr2RegExpPattern(ByVal HexStr As String,Optional ByVal Mode As Long) As String
	Dim i As Long,j As Long,n As Long
	j = Len(HexStr)
	If j = 0 Then Exit Function
	If Mode = 0 Then
		HexStr2RegExpPattern = "[" & Space$(j * 2) & "]"
		n = 2
	Else
		HexStr2RegExpPattern = Space$(j * 2)
		n = 1
	End If
	For i = 1 To j Step 2
		Mid$(HexStr2RegExpPattern,n,4) = "\x" & Mid$(HexStr,i,2)
		n = n + 4
	Next i
End Function


'ʽ HEX ִ
Private Function FormatHexStr(ByVal textStr As String,ByVal Length As Integer) As String
	If textStr = "" Then Exit Function
	If (Len(textStr) Mod Length) = 0 Then
		FormatHexStr = textStr
	Else
		FormatHexStr = "0" & textStr
	End If
End Function


'תִ
Private Function Reference2Str(File As FILE_PROPERTIE,strData As STRING_SUB_PROPERTIE) As String
	Dim i As Long,j As Long,k As Long,n As Long,Temp As String
	Dim TempArray() As String,SecList() As String
	On Error Resume Next
	If strData.lReferenceNum = 0 Then
		Reference2Str = MsgList(30)
		Exit Function
	End If
	Temp = String$(Len(CStr$(File.FileSize)),"0")
	n = Len(FormatHexStr(Hex$(File.FileSize),2))
	'IDתεҪĸʽ
	k = IIf(File.MaxHeaderID = 0,3,4)
	SecList = getSectionList(File,IIf(File.MaxHeaderID = 0,1,19))
	TempArray = SecIDListToNameList(RefList2StrList(strData,k),SecList)
	With strData
		ReDim TempList(.lReferenceNum + 4) As String
		TempList(0) = MsgList(37)
		TempList(1) = MsgList(38)
		TempList(2) = MsgList(37)
		For i = 0 To .lReferenceNum - 1
			TempList(i + 3) = Replace$(MsgList(39),"%no",CStr$(i + 1))
			TempList(i + 3) = Replace$(TempList(i + 3),"%da",Format$(.Reference(i).lAddress,Temp))
			TempList(i + 3) = Replace$(TempList(i + 3),"%ha",Right$(Temp & Hex$(.Reference(i).lAddress),n))
			TempList(i + 3) = Replace$(TempList(i + 3),"%sc",TempArray(i))
			j = SkipHeader(File,.Reference(i).lAddress)
			If j < 16 Then
				TempList(i + 3) = Replace$(TempList(i + 3),"%dc",MsgList(42 + j + 1))
			Else
				TempList(i + 3) = Replace$(TempList(i + 3),"%dc",MsgList(140 + j - 22))
			End If
			TempList(i + 3) = Replace$(TempList(i + 3),"%rc",strData.Reference(i).sCode)
		Next i
	End With
	TempList(i + 3) = MsgList(37)
	Reference2Str = StrListJoin(TempList,TextJoinStr)
End Function


'ִΪִΪ Join Ч̫
'Mode = False  Join ʽӣ治ӷӷ
Private Function StrListJoin(StrArray() As String,Optional ByVal Sep As String = " ",Optional ByVal Mode As Boolean) As String
	Dim i As Long,j As Long,sb As Object
	On Error GoTo ExitFunction
	Set sb = CreateObject("System.Text.StringBuilder")
	j = UBound(StrArray)
	If Mode = False Then
		For i = 0 To j
			If i < j Then
				sb.AppendFormat("{0}",StrArray(i) & Sep)
			Else
				sb.AppendFormat("{0}",StrArray(i))
			End If
		Next i
	Else
		For i = 0 To j
			sb.AppendFormat("{0}",StrArray(i) & Sep)
		Next i
	End If
	StrListJoin = sb.ToString()
	Set sb = Nothing
	Exit Function
	ExitFunction:
	Set sb = Nothing
	On Error GoTo errHandle
	StrListJoin = Join$(StrArray,Sep)
	errHandle:
End Function


' PE ļ
Private Function Alignment(ByVal orgValue As Long,ByVal AlignVal As Long,ByVal RoundVal As Long) As Long
	If AlignVal < 1 Then
		Alignment = orgValue
	Else
		Alignment = IIf(orgValue Mod AlignVal = 0,orgValue,AlignVal * ((orgValue \ AlignVal) + RoundVal))
	End If
End Function


'Ϣ
Private Sub sysErrorMassage(sysError As ErrObject,ByVal fType As Long)
	Dim TempArray() As String
	Dim ErrorNumber As Long,ErrorSource As String,ErrorDescription As String
	Dim TitleMsg As String,ContinueMsg As String,Msg As String

	ErrorNumber = sysError.Number
	ErrorSource = sysError.Source
	ErrorDescription = sysError.Description

	TitleMsg = "Error"
	Select Case fType
	Case 0
		ContinueMsg = vbCrLf & vbCrLf & "The program cannot continue and will exit."
	Case 1
		ContinueMsg = vbCrLf & vbCrLf & "Do you want to continue?"
	Case 2
		ContinueMsg = vbCrLf & vbCrLf & "The program will continue to run."
	End Select

	If CheckArray(MsgList) = True Then
		TitleMsg = MsgList(0)
		Select Case fType
		Case 0
			ContinueMsg = MsgList(1)
		Case 1
			ContinueMsg = MsgList(2)
		Case 2
			ContinueMsg = MsgList(3)
		End Select

		Select Case ErrorSource
		Case ""
			If ErrorNumber = 10051 And PSL.Version >= 1500 Then
				Msg = Replace$(MsgList(4),"%s",ErrorSource)
			Else
				Msg = Replace$(Replace$(MsgList(5),"%d",CStr(ErrorNumber)),"%v",ErrorDescription)
			End If
		Case "NotSection"
			TempArray = ReSplit(ErrorDescription,TextJoinStr,-1)
			Msg = Replace$(Replace$(MsgList(6),"%s",TempArray(1)),"%d",TempArray(0))
		Case "NotValue"
			TempArray = ReSplit(ErrorDescription,TextJoinStr,-1)
			Msg = Replace$(Replace$(MsgList(7),"%s",TempArray(1)),"%d",TempArray(0))
		Case "NotReadFile"
			Msg = Replace$(ErrorDescription,TextJoinStr,vbCrLf)
		Case "NotWriteFile"
			Msg = Replace$(ErrorDescription,TextJoinStr,vbCrLf)
		Case "NotUnWriteFile"
			Msg = Replace$(ErrorDescription,TextJoinStr,vbCrLf)
		Case "NotOpenFile"
			Msg = Replace$(ErrorDescription,TextJoinStr,vbCrLf)
		Case "NotINIFile"
			Msg = Replace$(MsgList(8),"%s",ErrorDescription)
		Case "NotExitFile"
			Msg = Replace$(MsgList(9),"%s",ErrorDescription)
		Case "NotVersion"
			TempArray = ReSplit(ErrorDescription,TextJoinStr,-1)
			Msg = Replace$(MsgList(10),"%s",TempArray(0))
			Msg = Replace$(Replace$(Msg,"%d",TempArray(1)),"%v",TempArray(2))
		Case Else
			Msg = Replace$(MsgList(11),"%s",ErrorSource)
			Msg = Replace$(Replace$(Msg,"%d",CStr(ErrorNumber)),"%v",ErrorDescription)
		End Select
	Else
		Select Case ErrorSource
		Case ""
			If ErrorNumber = 10051 And PSL.Version >= 1500 Then
				Msg = "Unable to open the file. Please verify the file path and file name" & _
						"contains characters in Asian languages. " & vbCrLf & _
						"Note: Passolo 2015 Version of the macro engine does not recognize" & _
						"the file path and file name contains Asian language characters."
			Else
				Msg = "An Error occurred in the program design." & vbCrLf & "Error Code: %d, Content: %v" & _
						vbCrLf & "Please restart the Passolo try and please report to the software developer."
				Msg = Replace$(Replace$(Msg,"%d",CStr(ErrorNumber)),"%v",ErrorDescription)
			End If
		Case "NotSection"
			TempArray = ReSplit(ErrorDescription,TextJoinStr,-1)
			Msg = "The following file is missing [%s] section." & vbCrLf & "%d"
			Msg = Replace$(Replace$(Msg,"%s",TempArray(1)),"%d",TempArray(0))
		Case "NotValue"
			TempArray = ReSplit(ErrorDescription,TextJoinStr,-1)
			Msg = "The following file is missing [%s] Value." & vbCrLf & "%d"
			Msg = Replace$(Replace$(Msg,"%s",TempArray(1)),"%d",TempArray(0))
		Case "NotReadFile"
			Msg = Replace$(ErrorDescription,TextJoinStr,vbCrLf)
		Case "NotWriteFile"
			Msg = Replace$(ErrorDescription,TextJoinStr,vbCrLf)
		Case "NotUnWriteFile"
			Msg = Replace$(ErrorDescription,TextJoinStr,vbCrLf)
		Case "NotOpenFile"
			Msg = Replace$(ErrorDescription,TextJoinStr,vbCrLf)
		Case "NotINIFile"
			Msg = "The following contents of the file is not correct." & vbCrLf & "%s"
			Msg = Replace$(Msg,"%s",ErrorDescription)
		Case "NotExitFile"
			Msg = "The following file does not exist! Please check and try again." & vbCrLf & "%s"
			Msg = Replace$(Msg,"%s",ErrorDescription)
		Case "NotVersion"
			TempArray = ReSplit(ErrorDescription,TextJoinStr,-1)
			Msg = "The following file version is %d, requires version at least %v." & vbCrLf & "%s"
			Msg = Replace$(Msg,"%s",TempArray(0))
			Msg = Replace$(Replace$(Msg,"%d",TempArray(1)),"%v",TempArray(2))
		Case Else
			Msg = "Your system is missing %s server." & vbCrLf & "Error Code: %d, Content: %v"
			Msg = Replace$(Msg,"%s",ErrorSource)
			Msg = Replace$(Replace$(Msg,"%d",CStr(ErrorNumber)),"%v",ErrorDescription)
		End Select
	End If

	If Msg = "" Then Exit Sub
	Select Case fType
	Case 0
		MsgBox(Msg & ContinueMsg,vbOkOnly+vbInformation,TitleMsg)
		Exit All
	Case 1
		If MsgBox(Msg & ContinueMsg,vbYesNo+vbInformation,TitleMsg) = vbNo Then
			Exit All
		End If
	Case Else
		MsgBox(Msg & ContinueMsg,vbOkOnly+vbInformation,TitleMsg)
	End Select
End Sub


'ֽתַ
Private Function ByteToString(Bytes() As Byte,ByVal CodePage As Long) As String
	Dim i As Long,n As Long
	On Error Resume Next
	Select Case CodePage
	Case CP_UNICODELITTLE
		ByteToString = Bytes
	Case CP_UNICODEBIG
		ByteToString = LowByte2HighByte(Bytes,2)
	Case CP_UTF32LE, CP_UTF_32LE
		ByteToString = Space$((UBound(Bytes) + 1) \ 4)
		For i = 0 To UBound(Bytes) Step 4
			n = n + 1
			'Ƿ CP_UTF32LE, CP_UTF_32LE ׼
			If Bytes(i + 3) = 0 Then
				CopyMemory CodePage, Bytes(i), 4
				'ת&H7FFFֵΪֵ
				'ChrWֵΧΪ Integer ȡֵΧ-32768  32767 32767 ʱҪȥ 65536
				If CodePage > &H7FFF Then CodePage = CodePage - 65536
				Mid$(ByteToString,n,1) = ChrW(CodePage)
			Else
				Mid$(ByteToString,n,1) = vbNullChar
			End If
		Next i
	Case CP_UTF32BE, CP_UTF_32BE
		ReDim tmpBytes(0) As Byte
		tmpBytes = LowByte2HighByte(Bytes,4)
		ByteToString = Space$((UBound(Bytes) + 1) \ 4)
		For i = 0 To UBound(Bytes) Step 4
			n = n + 1
			'Ƿ CP_UTF32BE, CP_UTF_32BE ׼
			If Bytes(i) = 0 Then
				CopyMemory CodePage, tmpBytes(i), 4
				'ת&H7FFFֵΪֵ
				'ChrWֵΧΪ Integer ȡֵΧ-32768  32767 32767 ʱҪȥ 65536
				If CodePage > &H7FFF Then CodePage = CodePage - 65536
				Mid$(ByteToString,n,1) = ChrW(CodePage)
			Else
				Mid$(ByteToString,n,1) = vbNullChar
			End If
		Next i
	Case Else
		ByteToString = MultiByteToUTF16(Bytes,CodePage)
	End Select
End Function


'ַֽĸֽں͵ֽڻ
' UNICODE LITTLE  UNICODE BIG ֽ໥ת
Private Function LowByte2HighByte(Bytes() As Byte,ByVal Setp As Integer) As Byte()
	Dim i As Long,Temp() As Byte
	Temp = Bytes
	If Setp = 2 Then
		For i = LBound(Temp) To UBound(Temp) - 1 Step Setp
			Temp(i) = Bytes(i + 1)
			Temp(i + 1) = Bytes(i)
		Next i
	ElseIf Setp = 4 Then
		For i = LBound(Temp) To UBound(Temp) - 1 Step Setp
			Temp(i) = Bytes(i + 3)
			Temp(i + 1) = Bytes(i + 2)
			Temp(i + 2) = Bytes(i + 1)
			Temp(i + 3) = Bytes(i)
		Next i
	End If
	LowByte2HighByte = Temp
End Function


'תֽ飬ֵֽĸֽں͵ֽڻ
Private Function ReverseValByte(Bytes() As Byte,ByVal StartPos As Long,ByVal endPos As Long) As Byte()
	Dim i As Long,Temp() As Byte
	If StartPos < 0 Then StartPos = LBound(Bytes)
	If endPos < 0 Then endPos = UBound(Bytes)
	Temp = Bytes
	For i = StartPos To endPos
		Temp(i) = Bytes(endPos - i)
	Next i
	ReverseValByte = Temp
End Function


'õĴҳUTF-8:65001GB2312:936GB1803054936UTF-765000
Private Function MultiByteToUTF16(UTF8() As Byte, ByVal CodePage As Long) As String
	On Error GoTo errHandle
	Dim bufSize As Long,lRet As Long
	'bufSize = MultiByteToWideChar(CodePage, 0&, VarPtr(UTF8(0)), UBound(UTF8) + 1, 0, 0)
	bufSize = MultiByteToWideChar(CodePage, 0&, UTF8(0), UBound(UTF8) + 1, 0, 0)
	'If CodePage = CP_UTF8 Then bufSize = (UBound(UTF8) + 1) * 2 Else bufSize = UBound(UTF8) + 1
	MultiByteToUTF16 = Space(bufSize)
	'lRet = MultiByteToWideChar(CodePage, 0&, VarPtr(UTF8(0)), UBound(UTF8) + 1, StrPtr(MultiByteToUTF16), bufSize)
	lRet = MultiByteToWideChar(CodePage, 0&, UTF8(0), UBound(UTF8) + 1, StrPtr(MultiByteToUTF16), bufSize)
	If lRet > 0 Then
		MultiByteToUTF16 = Left$(MultiByteToUTF16, lRet)
	End If
	Exit Function
	errHandle:
	MultiByteToUTF16 = ""
End Function


'ȡżλ
'Mode = 0  1 ֽڣMode = 1  1 ֽ
Private Function GetEvenPos(ByVal Pos As Long,Optional ByVal Mode As Long) As Long
	If Pos And 1 Then
		If Mode = 0 Then
			GetEvenPos = Pos + 1
		Else
			GetEvenPos = Pos - 1
		End If
	Else
		GetEvenPos = Pos
	End If
End Function


'в
'' Command Line Format: Command <FilePath> <-add:Address> <-lng:Hex Language Code>
'' Command: Name of this Macros file
'' FilePath: Full path of PE file
'' Address: Offset of Dec or Hex, if Hex, use like "0xFFFF" format
'' Hex Language Code: Display UI Language. Supports EngLish, Chinese Simplified and Chinese Traditional only. For sample: 0804,1004,0404,0C04,1404.
'' Return: No
'' For example: modRefernceSearch,"d:\my folder\my file.exe" -add:35148 -lng:0804

Private Function SplitArgument(ByVal Argument As String,ByVal MaxNum As Long) As String()
	Dim i As Long,j As Long,k As Long,TempList() As String
	ReDim ArgArray(MaxNum - 1) As String
	If Argument = "" Then
		SplitArgument = ArgArray
		Exit Function
	End If
	'ӺǰֵС
	TempList = ReSplit(Argument," ")
	k = UBound(TempList)
	MaxNum = IIf(k - MaxNum > 0,k - MaxNum,1)
	For i = k To MaxNum Step -1
		Argument = Trim$(TempList(i))
		If CheckStrRegExp(Argument,"-add:[0-9]+",0,5,True) = True Then
			Argument = "-add:"
		ElseIf CheckStrRegExp(Argument,"-lng:[0-9a-f;]+",0,5,True) = True Then
			Argument = "-lng:"
		End If
		Select Case Argument
		Case "-add:"
			If ArgArray(1) = "" Then
				ArgArray(1) = Mid$(Trim$(TempList(i)),6)
				j = j + 1
			End If
		Case "-lng:"
			If ArgArray(2) = "" Then
				ArgArray(2) = Mid$(Trim$(TempList(i)),6)
				j = j + 1
			End If
		End Select
	Next i
	ReDim Preserve TempList(k - j) As String
	ArgArray(0) = Join$(TempList," ")
	SplitArgument = ArgArray
End Function


'ȥִǰָ PreStr  AppStr
'fType = -1 ȥִǰĿոָ PreStr  AppStrȥִǰո
'fType = 0 ȥִǰĿոָ PreStr  AppStrȥִǰո
'fType = 1 ȥִǰĿոָ PreStr  AppStrȥִǰո
'fType = 2 ȥִǰĿոָ PreStr  AppStr 1 Σȥִǰո
'fType > 2 ȥִǰĿոָ PreStr  AppStr 1 Σȥִǰո
Private Function RemoveBackslash(ByVal Path As String,ByVal PreStr As String,ByVal AppStr As String,ByVal fType As Long) As String
	Dim i As Long,a As Long,p As Long,Stemp As Boolean
	RemoveBackslash = Path
	If Path = "" Then Exit Function
	a = Len(AppStr)
	p = Len(PreStr)
	If fType > -1 Then RemoveBackslash = Trim(RemoveBackslash)
	Do
		Stemp = False
		If p <> 0 Then
			If Left$(RemoveBackslash,p) = PreStr Then
				RemoveBackslash = Mid$(RemoveBackslash,p + 1)
				Stemp = True
			End If
		End If
		If a <> 0 Then
			If Right$(RemoveBackslash,a) = AppStr Then
				RemoveBackslash = Left$(RemoveBackslash,Len(RemoveBackslash) - a)
				Stemp = True
			End If
		End If
		If fType = 1 Or fType > 2 Then RemoveBackslash = Trim$(RemoveBackslash)
		If Stemp = True Then
			If fType < 2 Then i = 0 Else i = 1
		Else
			i = 1
		End If
	Loop Until i = 1
End Function


'ضԻĳؼеִ
Private Function GetTextBoxString(ByVal hwnd As Long) As String
	Dim i As Long
	On Error GoTo errHandle
	'ԷĴںͿؼ
	'i = SendMessageLNG(hwnd,WM_GETTEXTLENGTH,0&,0&)
	'ֻܷĴںͿؼ
	i = GetWindowTextLength(hwnd)
	If i > 0 Then
		GetTextBoxString = String$(i + 1,0)
		'ԷĴںͿؼٶȺ
		'SendMessageLNG hwnd, WM_GETTEXT, i + 1, StrPtr(GetTextBoxString)
		'GetTextBoxString = Replace$(StrConv$(GetTextBoxString,vbUnicode),vbNullChar,"")
		'ֻܷĴںͿؼٶȿü
		GetWindowText hwnd, GetTextBoxString, i + 1
		GetTextBoxString = Replace$(GetTextBoxString,vbNullChar,"")
	End If
	Exit Function
	errHandle:
	GetTextBoxString = ""
End Function


'öԻĳؼеִ
'Mode = False 滻ʾ׷ʾ
Private Function SetTextBoxString(ByVal hwnd As Long,ByVal StrText As String,Optional ByVal Mode As Boolean) As Boolean
	On Error GoTo errHandle
	If Mode = False Then
		'ԷĴںͿؼ
		'SetTextBoxString = SendMessageLNG(hwnd,WM_SETTEXT,0&,StrPtr(StrConv$(StrText,vbFromUnicode)))
		'ֻܷĴںͿؼᱣȷʾǰһַ
		SetTextBoxString = SetWindowText(hwnd,StrText)
	Else
		StrText = GetTextBoxString(hwnd) & vbCrLf & StrText
		'ı
		SetTextBoxLength hwnd, Len(StrText), True
		'ԷĴںͿؼᶪʧǰһַ
		'SetTextBoxString = SendMessageLNG(hwnd,WM_SETTEXT,0&,StrPtr(StrConv$(StrText,vbFromUnicode)))
		'ֻܷĴںͿؼᱣȷʾǰһַ
		SetTextBoxString = SetWindowText(hwnd,StrText)
		'ùıײ
		SendMessageLNG hwnd, WM_VSCROLL, SB_BOTTOM, 0&
	End If
	errHandle:
End Function


'ñ༭ؼеıȣԭ󳤶Ϊ30000ַ˫ַֽ1
Private Function SetTextBoxLength(ByVal hwnd As Long,ByVal NewLength As Long,ByVal Mode As Boolean) As Long
	SetTextBoxLength = SendMessageLNG(hwnd,EM_GETLIMITTEXT,0&,0&)
	If NewLength < SetTextBoxLength Then
		If Mode = False Then Exit Function
		If NewLength < 30001 Then Exit Function
		If NewLength > (SetTextBoxLength \ 3) Then Exit Function
	End If
	SetTextBoxLength = NewLength * 2
	SendMessageLNG hwnd,EM_LIMITTEXT,SetTextBoxLength,0&
End Function


' PSL 2015 ϰ汾 Split ַֿʱδʼĴ
Private Function ReSplit(ByVal TextStr As String,Optional ByVal Sep As String = " ",Optional ByVal Max As Integer = -1) As String()
	If TextStr = "" Then
		ReDim TempList(0) As String
		ReSplit = TempList
	Else
		ReSplit = Split(TextStr,Sep,Max)
	End If
End Function


'ȡļͣPE  MAC Ƿ PE ļ
Private Function GetFileFormat(ByVal FilePath As String,ByVal Mode As Long,FileType As Integer) As String
	Dim i As Long,n As Long,FN As FILE_IMAGE
	On Error GoTo ExitFunction
	FileType = 0
	'ļ
	n = FileLen(FilePath)
	If n = 0 Then Exit Function
	If n > 4096 + 16 Then n = 4096 + 16
	Mode = LoadFile(FilePath,FN,0,0,i,Mode)
	If Mode < -1 Then Exit Function
	'Do While i < n - 16
	Do While i < 1
		Select Case GetLong(FN,i,Mode)
		Case MH_MAGIC_32,MH_MAGIC_64,MH_MAGIC_FAT,MH_MAGIC_FAT_CIGAM
			GetFileFormat = "MAC"
			FileType = i
			Exit Do
		Case Else
			Select Case GetInteger(FN,i,Mode)
			Case IMAGE_DOS_SIGNATURE,IMAGE_OS2_SIGNATURE,IMAGE_OS2_SIGNATURE_LE,IMAGE_VXD_SIGNATURE
				GetFileFormat = "PE"
				FileType = i
				Exit Do
			Case RES_STRING_POOL_TYPE,RES_TABLE_TYPE,RES_XML_TYPE
				GetFileFormat = "Android"
				FileType = i
				Exit Do
			End Select
		End Select
		i = getNotNullByteRegExp(FN,i + 1,4096,Mode)
	Loop
	ExitFunction:
	UnLoadFile(FN,0,Mode)
End Function


'ȡļļݽṹϢ
Private Function GetHeaders(ByVal strFilePath As String,File As FILE_PROPERTIE,ByVal Mode As Long,Optional HeaderID As Integer = -1) As Boolean
	Select Case GetFileFormat(File.FilePath,Mode,File.FileType)
	Case "PE","NET",""
		GetHeaders = GetPEHeaders(File.FilePath,File,Mode,-1,HeaderID)
	Case "MAC"
		GetHeaders = GetMacHeaders(File.FilePath,File,Mode,-1,HeaderID)
	Case "Android"
		GetHeaders = GetAndroidHeaders(File.FilePath,File,Mode,-1,HeaderID)
	End Select
End Function


'ʾļϢ
Private Sub ShowInfo(ByVal FilePath As String,ByVal Info As String)
	Begin Dialog UserDialog 890,448,Replace$(MsgList(89),"%s",FilePath) ' %GRID:10,7,1,1
		TextBox 0,7,890,406,.InTextBox,1
		OKButton 390,420,100,21,.OKButton
	End Dialog
	Dim dlg As UserDialog
	dlg.InTextBox = Info
	Dialog dlg
End Sub


'ȡļ汾Ϣ
Private Function GetFileInfo(ByVal strFilePath As String,File As FILE_PROPERTIE) As Boolean
	Dim i As Integer,lngBufferlen As Long,lngRc As Long,lngVerPointer As Long
	Dim bytBuffer() As Byte,strTemp As String
	Dim strBuffer As String,strLangCharset As String,strVersionInfo(7) As String
	'ļѴʱ˳
	If IsOpen(strFilePath) = True Then Exit Function
	' get file size
	lngBufferlen = GetFileVersionInfoSize(strFilePath, 0&)
	If lngBufferlen > 0 Then
		ReDim bytBuffer(lngBufferlen) As Byte
		lngRc = GetFileVersionInfo(strFilePath, 0&, lngBufferlen, bytBuffer(0))
		If lngRc <> 0 Then
			lngRc = VerQueryValue(bytBuffer(0), "\VarFileInfo\Translation", lngVerPointer, lngBufferlen)
			If lngRc <> 0 Then
				'lngVerPointer is a pointer to four 4 bytes of Hex number,
				'first two bytes are language id, and last two bytes are code
				'page. However, strLangCharset needs a  string of
				'4 hex digits, the first two characters correspond to the
				'language id and last two the last two character correspond
				'to the code page id.
				ReDim bytBuff(lngBufferlen - 1) As Byte
				MoveMemory bytBuff(0), lngVerPointer, lngBufferlen
				'strLangCharset = Hex(bytBuff(2) + bytBuff(3) * &H100 + bytBuff(0) * &H10000 + bytBuff(1) * &H1000000)
				strLangCharset = Byte2Hex(LowByte2HighByte(bytBuff,2),0,-1)
				'now we change the order of the language id and code page
				'and convert it into a string representation.
				'For example, it may look like 040904E4
				'Or to pull it all apart:
				'04------        = SUBLANG_ENGLISH_USA
				'--09----        = LANG_ENGLISH
				' ----04E4 = 1252 = Codepage for Windows:Multilingual

				'If Len(strLangCharset) - 2 >= 2 Then
				'    If Mid$(strLangCharset, 2, 2) = LANG_ENGLISH Then
				'    	strLangCharset2 = "English (US)"
				'    End If
				'End If

				Do While Len(strLangCharset) < 8
					strLangCharset = "0" & strLangCharset
				Loop

				' assign propertienames
				strVersionInfo(0) = "CompanyName"
				strVersionInfo(1) = "FileDescription"
				strVersionInfo(2) = "FileVersion"
				strVersionInfo(3) = "InternalName"
				strVersionInfo(4) = "LegalCopyright"
				strVersionInfo(5) = "OriginalFileName"
				strVersionInfo(6) = "ProductName"
				strVersionInfo(7) = "ProductVersion"
				' loop and get FILE_PROPERTIEs
				For i = 0 To 7
					strBuffer = String$(255, 0)
					strTemp = "\StringFileInfo\" & strLangCharset & "\" & strVersionInfo(i)
					lngRc = VerQueryValue(bytBuffer(0), strTemp, lngVerPointer, lngBufferlen)
					If lngRc <> 0 Then
						' get and format data
						lstrcpy strBuffer, lngVerPointer
						strVersionInfo(i) = Replace$(strBuffer,vbNullChar,"")
					Else
						' property not found
						strVersionInfo(i) = ""
					End If
				Next i
			End If
		End If
	End If
	' assign array to user-defined-type
	File.CompanyName = strVersionInfo(0)
	File.FileDescription = strVersionInfo(1)
	File.FileVersion = Trim$(strVersionInfo(2))
	File.InternalName = strVersionInfo(3)
	File.LegalCopyright = strVersionInfo(4)
	File.OrigionalFileName = strVersionInfo(5)
	File.ProductName = strVersionInfo(6)
	File.ProductVersion = strVersionInfo(7)
	File.LanguageID = Left$(strLangCharset,4)
	File.FileName = Mid$(File.FilePath,InStrRev(File.FilePath,"\") + 1)
	File.FileSize = FileLen(strFilePath)
	File.DateLastModified = FileDateTime(strFilePath)
	File.DateCreated = GetFileDate(strFilePath,0)
	GetFileInfo = True
End Function


'ȡļĴʡ޸
'Mode = 0 
'Mode = 1 
'Mode = 2 ޸
Private Function GetFileDate(ByVal strFilePath As String,ByVal Mode As Long) As Date
	Dim fso As Object,Obj As Object
	Set fso = CreateObject("Scripting.FileSystemObject")
	Set Obj = fso.GetFile(strFilePath)
	If Mode = 0 Then
		GetFileDate = Obj.DateCreated
	ElseIf Mode = 1 Then
		GetFileDate = Obj.DateLastAccessed
	Else
		GetFileDate = Obj.DateLastModified
	End If
	Set fso = Nothing: Set Obj = Nothing
End Function


'鿴ػļϢ
'DisPlayFormat = False ʮʾֵʮʾֵ
Private Sub FileInfoView(File As FILE_PROPERTIE,ByVal DisPlayFormat As Boolean)
	Dim i As Long,j As Long,k As Long,n As Long,Stemp As Boolean
	On Error GoTo ErrHandle
	If InStr(File.Header(0).Magic,"MAC") Then Stemp = True
	'MAC64£޷ 64 λ(8 ֽ)ֵֻ16ʾ
	If File.Header(0).Magic = "MAC64" Then DisPlayFormat = True
	'дļϢ
	n = 17
	ReDim List(n) As String
	With File
		List(0) = MsgList(91)
		List(1) = Replace$(MsgList(92),"%s",.FileName)
		List(2) = Replace$(MsgList(93),"%s",.FilePath)
		List(3) = Replace$(MsgList(94),"%s",.FileDescription)
		List(4) = Replace$(MsgList(95),"%s",.FileVersion)
		List(5) = Replace$(MsgList(96),"%s",.ProductName)
		List(6) = Replace$(MsgList(97),"%s",.ProductVersion)
		List(7) = Replace$(MsgList(98),"%s",.LegalCopyright)
		List(8) = Replace$(MsgList(99),"%s",CStr$(.FileSize))
		List(9) = Replace$(MsgList(100),"%s",CStr$(.DateCreated))
		List(10) = Replace$(MsgList(101),"%s",CStr$(.DateLastModified))
		List(11) = Replace$(MsgList(102),"%s",PSL.GetLangCode(Val("&H" & .LanguageID),pslCodeText))
		List(12) = Replace$(MsgList(103),"%s",.CompanyName)
		List(13) = Replace$(MsgList(104),"%s",.OrigionalFileName)
		List(14) = Replace$(MsgList(105),"%s",.InternalName)
		List(15) = Replace$(MsgList(90),"%s",CStr$(.MaxHeaderID + 1))
		Select Case .Header(0).Magic
		Case "PE32","NET32"
			If .LangType = DELPHI_FILE_SIGNATURE Then
				List(16) = Replace$(MsgList(106),"%s","Delphi32")
				List(17) = Replace$(MsgList(107),"%s","0x" & ValToStr(.Header(0).ImageBase,-8,True))
			ElseIf .LangType = NET_FILE_SIGNATURE Then
				List(16) = Replace$(MsgList(106),"%s",".NET32")
				List(17) = Replace$(MsgList(107),"%s","0x" & ValToStr(.Header(0).ImageBase,-8,True))
			Else
				List(16) = Replace$(MsgList(106),"%s","PE32")
				List(17) = Replace$(MsgList(107),"%s","0x" & ValToStr(.Header(0).ImageBase,-8,True))
			End If
		Case "PE64","NET64"
			If .LangType = DELPHI_FILE_SIGNATURE Then
				List(16) = Replace$(MsgList(106),"%s","Delphi64")
				List(17) = Replace$(MsgList(107),"%s","0x" & ReverseHexCode(Byte2Hex(.Header(0).ImageBase,0,-1),16))
			ElseIf .LangType = NET_FILE_SIGNATURE Then
				List(16) = Replace$(MsgList(106),"%s",".NET64")
				List(17) = Replace$(MsgList(107),"%s","0x" & ReverseHexCode(Byte2Hex(.Header(0).ImageBase,0,-1),16))
			Else
				List(16) = Replace$(MsgList(106),"%s","PE64")
				List(17) = Replace$(MsgList(107),"%s","0x" & ReverseHexCode(Byte2Hex(.Header(0).ImageBase,0,-1),16))
			End If
		Case "MAC32","MAC64"
			For i = 0 To .MaxHeaderID
				If i = 0 Then
					List(16) = .Header(i).Magic
					List(17) = "0x" & ValToStr(-.Header(i).ImageBase,-8,True)
				Else
					List(16) = List(16) & ", " & .Header(i).Magic
					List(17) = List(17) & ", " & "0x" & ValToStr(-.Header(i).ImageBase,-8,True)
				End If
			Next i
			List(16) = Replace$(MsgList(106),"%s",List(16))
			List(17) = Replace$(MsgList(107),"%s",List(17))
		Case "Android_RES_STRING_POOL_TYPE","Android_RES_TABLE_TYPE","Android_RES_XML_TYPE"
			List(16) = Replace$(MsgList(106),"%s",.Header(0).Magic)
			List(17) = Replace$(MsgList(107),"%s","0x" & ValToStr(-.Header(0).ImageBase,-8,True))
		Case Else
			List(16) = Replace$(MsgList(106),"%s",MsgList(149))
		End Select
	End With
	If List(17) = "" Then n = n - 1
	'ÿļڵƫƵַ
	For k = 0 To File.MaxHeaderID
		ReDim Preserve List(n + 6 + File.Header(k).MaxSecIndex) As String
		If File.MaxHeaderID = 0 Or File.Header(k).Magic = "" Then
			List(n + 2) = Replace$(MsgList(108),"(%s)","")
		Else
			List(n + 2) = Replace$(MsgList(108),"%s",File.Header(k).Magic)
		End If
		List(n + 3) = MsgList(111) & MsgList(111)
		List(n + 4) = IIf(Stemp = False,MsgList(109),MsgList(151))
		List(n + 5) = MsgList(111) & MsgList(111)
		n = n + 6
		For i = 0 To File.Header(k).MaxSecIndex - 1
			With File.Header(k).SecList(i)
				List(n) = Replace$(IIf(Stemp = False,MsgList(110),MsgList(152)),"%s!1!",MsgList(112))
				List(n) = Replace$(List(n),"%s!2!",IIf(File.Header(k).Magic = "",MsgList(149),.sName))
				List(n) = Replace$(List(n),"%s!3!","")
				List(n) = Replace$(List(n),"%s!4!",ValToStr(.lPointerToRawData,File.FileSize,DisPlayFormat))
				List(n) = Replace$(List(n),"%s!5!",ValToStr(.lPointerToRawData + _
								IIf(.lSizeOfRawData = 0,0,.lSizeOfRawData - 1),File.FileSize,DisPlayFormat))
				List(n) = Replace$(List(n),"%s!6!",ValToStr(.lSizeOfRawData,File.FileSize,DisPlayFormat))
				If .SubSecs > 0 Then
					n = n + 1
					ReDim Preserve List(n + .SubSecs + File.Header(k).MaxSecIndex - i) As String
					For j = 0 To .SubSecs - 1
						List(n) = Replace$(MsgList(152),"%s!1!",MsgList(112))
						List(n) = Replace$(List(n),"%s!2!","")
						List(n) = Replace$(List(n),"%s!3!",.SubSecList(j).sName)
						List(n) = Replace$(List(n),"%s!4!",ValToStr(.SubSecList(j).lPointerToRawData,File.FileSize,DisPlayFormat))
						List(n) = Replace$(List(n),"%s!5!",ValToStr(.SubSecList(j).lPointerToRawData + _
										IIf(.SubSecList(j).lSizeOfRawData = 0,0,.SubSecList(j).lSizeOfRawData - 1),File.FileSize,DisPlayFormat))
						List(n) = Replace$(List(n),"%s!6!",ValToStr(.SubSecList(j).lSizeOfRawData,File.FileSize,DisPlayFormat))
						n = n + 1
					Next j
				Else
					n = n + 1
				End If
			End With
		Next i
		'ؽڵƫƵַ PE ַ
		With File.Header(k).SecList(File.Header(k).MaxSecIndex)
			If .lSizeOfRawData > 0 Then
				ReDim Preserve List(n) As String
				List(n) = Replace$(IIf(Stemp = False,MsgList(110),MsgList(152)),"%s!1!",MsgList(112))
				List(n) = Replace$(List(n),"%s!2!",MsgList(115))
				List(n) = Replace$(List(n),"%s!3!","")
				List(n) = Replace$(List(n),"%s!4!",ValToStr(.lPointerToRawData,File.FileSize,DisPlayFormat))
				List(n) = Replace$(List(n),"%s!5!",ValToStr(.lPointerToRawData + _
							IIf(.lSizeOfRawData = 0,0,.lSizeOfRawData - 1),File.FileSize,DisPlayFormat))
				List(n) = Replace$(List(n),"%s!6!",ValToStr(.lSizeOfRawData,File.FileSize,DisPlayFormat))
				n = n + 1
			End If
			If File.Header(k).NumberOfSub > 0 Then
				ReDim Preserve List(n) As String
				List(n) = Replace$(IIf(Stemp = False,MsgList(110),MsgList(152)),"%s!1!",MsgList(112))
				List(n) = Replace$(List(n),"%s!2!",Replace$(MsgList(150),"%s",CStr$(File.Header(k).NumberOfSub)))
				List(n) = Replace$(List(n),"%s!3!","")
				List(n) = Replace$(List(n),"%s!4!",ValToStr(.lPointerToRawData + .lSizeOfRawData,File.FileSize,DisPlayFormat))
				List(n) = Replace$(List(n),"%s!5!",ValToStr(File.FileSize - 1,File.FileSize,DisPlayFormat))
				List(n) = Replace$(List(n),"%s!6!",ValToStr(File.FileSize - .lPointerToRawData - .lSizeOfRawData,File.FileSize,DisPlayFormat))
				n = n + 1
			End If
		End With
		'ÿļڵַ
		n = n + 1
		ReDim Preserve List(n + File.Header(k).MaxSecIndex) As String
		For i = 0 To File.Header(k).MaxSecIndex - 1
			With File.Header(k).SecList(i)
				List(n) = Replace$(IIf(Stemp = False,MsgList(110),MsgList(152)),"%s!1!",MsgList(113))
				List(n) = Replace$(List(n),"%s!2!",IIf(File.Header(k).Magic = "",MsgList(149),.sName))
				List(n) = Replace$(List(n),"%s!3!","")
				If File.Header(k).Magic <> "MAC64" Then
					List(n) = Replace$(List(n),"%s!4!",ValToStr(.lVirtualAddress,File.FileSize,DisPlayFormat))
					List(n) = Replace$(List(n),"%s!5!",ValToStr(.lVirtualAddress + _
								IIf(.lVirtualSize = 0,0,.lVirtualSize - 1),File.FileSize,DisPlayFormat))
				Else
					List(n) = Replace$(List(n),"%s!4!",ValToStr(.lVirtualAddress1,0,DisPlayFormat) & _
								ValToStr(.lVirtualAddress,-8,DisPlayFormat))
					List(n) = Replace$(List(n),"%s!5!",ValToStr(.lVirtualAddress1,0,DisPlayFormat) & _
								ValToStr(.lVirtualAddress + IIf(.lVirtualSize = 0,0,.lVirtualSize - 1),-8,DisPlayFormat))
				End If
				List(n) = Replace$(List(n),"%s!6!",ValToStr(.lVirtualSize,File.FileSize,DisPlayFormat))
				If .SubSecs > 0 Then
					n = n + 1
					ReDim Preserve List(n + .SubSecs + File.Header(k).MaxSecIndex - i) As String
					For j = 0 To .SubSecs - 1
						List(n) = Replace$(MsgList(152),"%s!1!",MsgList(113))
						List(n) = Replace$(List(n),"%s!2!","")
						List(n) = Replace$(List(n),"%s!3!",.SubSecList(j).sName)
						If File.Header(k).Magic <> "MAC64" Then
							List(n) = Replace$(List(n),"%s!4!",ValToStr(.SubSecList(j).lVirtualAddress,File.FileSize,DisPlayFormat))
							List(n) = Replace$(List(n),"%s!5!",ValToStr(.SubSecList(j).lVirtualAddress + _
										IIf(.SubSecList(j).lVirtualSize = 0,0,.lVirtualSize - 1),File.FileSize,DisPlayFormat))
						Else
							List(n) = Replace$(List(n),"%s!4!",ValToStr(.SubSecList(j).lVirtualAddress1,0,DisPlayFormat) & _
										ValToStr(.SubSecList(j).lVirtualAddress,-8,DisPlayFormat))
							List(n) = Replace$(List(n),"%s!5!",ValToStr(.SubSecList(j).lVirtualAddress1,0,DisPlayFormat) & _
										ValToStr(.SubSecList(j).lVirtualAddress + IIf(.SubSecList(j).lVirtualSize = 0,0,.lVirtualSize - 1),-8,DisPlayFormat))
						End If
						List(n) = Replace$(List(n),"%s!6!",ValToStr(.SubSecList(j).lVirtualSize,File.FileSize,DisPlayFormat))
						List(n) = Replace$(List(n),"%s!7!","")
						n = n + 1
					Next j
				Else
					n = n + 1
				End If
			End With
		Next i
		'ؽڵַ PE ַ
		With File.Header(k).SecList(File.Header(k).MaxSecIndex)
			If .lVirtualSize > 0 Then
				ReDim Preserve List(n) As String
				List(n) = Replace$(IIf(Stemp = False,MsgList(110),MsgList(152)),"%s!1!",MsgList(113))
				List(n) = Replace$(List(n),"%s!2!",MsgList(115))
				List(n) = Replace$(List(n),"%s!3!","")
				List(n) = Replace$(List(n),"%s!4!",MsgList(116))
				List(n) = Replace$(List(n),"%s!5!",MsgList(116))
				List(n) = Replace$(List(n),"%s!6!",MsgList(116))
				n = n + 1
			End If
			If File.Header(k).NumberOfSub > 0 Then
				ReDim Preserve List(n) As String
				List(n) = Replace$(IIf(Stemp = False,MsgList(110),MsgList(152)),"%s!1!",MsgList(113))
				List(n) = Replace$(List(n),"%s!2!",Replace$(MsgList(150),"%s",CStr$(File.Header(k).NumberOfSub)))
				List(n) = Replace$(List(n),"%s!3!","")
				List(n) = Replace$(List(n),"%s!4!",MsgList(116))
				List(n) = Replace$(List(n),"%s!5!",MsgList(116))
				List(n) = Replace$(List(n),"%s!6!",MsgList(116))
				n = n + 1
			End If
		End With
		ReDim Preserve List(n) As String
		List(n) = MsgList(111) & MsgList(111)
		'Ŀ¼ַļ
		If File.Header(k).DataDirs > 0 Then
			ReDim Preserve List(n + 6 + File.Header(k).DataDirs) As String
			List(n + 2) = MsgList(118)
			List(n + 3) = MsgList(111) & MsgList(111)
			List(n + 4) = MsgList(119)
			List(n + 5) = MsgList(111) & MsgList(111)
			n = n + 6
			For i = 0 To File.Header(k).DataDirs - 1
				With File.Header(k).DataDirectory(i)
					List(n) = Replace$(MsgList(110),"%s!1!",MsgList(i + 120))
					If .lPointerToRawData > 0 Then
						j = SkipSection(File.Header(k),.lPointerToRawData,0,0,1)
						If j > -1 Then
							List(n) = Replace$(List(n),"%s!2!",File.Header(k).SecList(j).sName)
						Else
							List(n) = Replace$(List(n),"%s!2!",MsgList(136))
						End If
					ElseIf .lSizeOfRawData > 0 Then
						List(n) = Replace$(List(n),"%s!2!",MsgList(136))
					Else
						List(n) = Replace$(List(n),"%s!2!",MsgList(137))
					End If
					List(n) = Replace$(List(n),"%s!3!","")
					List(n) = Replace$(List(n),"%s!4!",ValToStr(.lPointerToRawData,File.FileSize,DisPlayFormat))
					List(n) = Replace$(List(n),"%s!5!",ValToStr(.lPointerToRawData + _
									IIf(.lSizeOfRawData = 0,0,.lSizeOfRawData - 1),File.FileSize,DisPlayFormat))
					List(n) = Replace$(List(n),"%s!6!",ValToStr(.lSizeOfRawData,File.FileSize,DisPlayFormat))
					n = n + 1
				End With
			Next i
			List(n) = MsgList(111) & MsgList(111)
		End If
		'.NET CLR Ŀ¼ַļ
		If File.LangType = NET_FILE_SIGNATURE Then
			ReDim Preserve List(n + 6 + 7) As String
			List(n + 2) = MsgList(138)
			List(n + 3) = MsgList(111) & MsgList(111)
			List(n + 4) = MsgList(139)
			List(n + 5) = MsgList(111) & MsgList(111)
			n = n + 6
			For i = 0 To 6
				With File.Header(k).CLRList(i)
					List(n) = Replace$(MsgList(110),"%s!1!",MsgList(i + 140))
					If .lPointerToRawData > 0 Then
						j = SkipSection(File.Header(k),.lPointerToRawData,0,0,1)
						If j > -1 Then
							List(n) = Replace$(List(n),"%s!2!",File.Header(k).SecList(j).sName)
						Else
							List(n) = Replace$(List(n),"%s!2!",MsgList(136))
						End If
					ElseIf .lSizeOfRawData > 0 Then
						List(n) = Replace$(List(n),"%s!2!",MsgList(136))
					Else
						List(n) = Replace$(List(n),"%s!2!",MsgList(137))
					End If
					List(n) = Replace$(List(n),"%s!3!","")
					List(n) = Replace$(List(n),"%s!4!",ValToStr(.lPointerToRawData,File.FileSize,DisPlayFormat))
					List(n) = Replace$(List(n),"%s!5!",ValToStr(.lPointerToRawData + _
								IIf(.lSizeOfRawData = 0,0,.lSizeOfRawData - 1),File.FileSize,DisPlayFormat))
					List(n) = Replace$(List(n),"%s!6!",ValToStr(.lSizeOfRawData,File.FileSize,DisPlayFormat))
					n = n + 1
				End	With
			Next i
			List(n) = MsgList(111) & MsgList(111)
		End If
		'.NET ַļ
		If File.Header(k).NetStreams > 0 Then
			ReDim Preserve List(n + 6 + File.Header(k).NetStreams) As String
			List(n + 2) = MsgList(147)
			List(n + 3) = MsgList(111) & MsgList(111)
			List(n + 4) = MsgList(148)
			List(n + 5) = MsgList(111) & MsgList(111)
			n = n + 6
			For i = 0 To File.Header(k).NetStreams - 1
				With File.Header(k).StreamList(i)
					List(n) = Replace$(MsgList(110),"%s!1!",.sName)
					If .lPointerToRawData > 0 Then
						j = SkipSection(File.Header(k),.lPointerToRawData,0,0,1)
						If j > -1 Then
							List(n) = Replace$(List(n),"%s!2!",File.Header(k).SecList(j).sName)
						Else
							List(n) = Replace$(List(n),"%s!2!",MsgList(136))
						End If
					ElseIf .lSizeOfRawData > 0 Then
						List(n) = Replace$(List(n),"%s!2!",MsgList(136))
					Else
						List(n) = Replace$(List(n),"%s!2!",MsgList(137))
					End If
					List(n) = Replace$(List(n),"%s!3!","")
					List(n) = Replace$(List(n),"%s!4!",ValToStr(.lPointerToRawData,File.FileSize,DisPlayFormat))
					List(n) = Replace$(List(n),"%s!5!",ValToStr(.lPointerToRawData + _
								IIf(.lSizeOfRawData = 0,0,.lSizeOfRawData - 1),File.FileSize,DisPlayFormat))
					List(n) = Replace$(List(n),"%s!6!",ValToStr(.lSizeOfRawData,File.FileSize,DisPlayFormat))
					n = n + 1
				End With
			Next i
			List(n) = MsgList(111) & MsgList(111)
		End If
	Next k
	File.Info = StrListJoin(List,vbCrLf,True)
	Erase List
	Exit Sub
	'
	ErrHandle:
	On Error Resume Next
	Err.Source = "NotReadFile"
	Err.Description = Err.Description & JoinStr & File.FilePath & ".xls"
	Call sysErrorMassage(Err,1)
End Sub


'תʮƺʮֵΪַ
'MaxVal = 0 ֵӦеĳȣ> 0 ļСλ< 0 ָλ
Private Function ValToStr(ByVal DecVal As Long,Optional ByVal MaxVal As Long,Optional ByVal DisPlayFormat As Boolean) As String
	On Error GoTo ExitFunction
	If DisPlayFormat = False Then
		ValToStr = CStr$(DecVal)
	Else
		ValToStr = Hex$(DecVal)
		Select Case MaxVal
		Case 0
			MaxVal = Len(ValToStr)
		Case Is > 0
			MaxVal = Len(CStr$(MaxVal))
		Case Else
			MaxVal = Abs(MaxVal)
		End Select
		If MaxVal And 1 Then MaxVal = MaxVal + 1
		ValToStr = String$(MaxVal - Len(ValToStr),"0") & ValToStr
	End If
	ExitFunction:
End Function


'λ
Private Function SHL(nSource As Long, n As Byte) As Double
	On Error GoTo ExitFunction:
	SHL = nSource * 2 ^ n
	ExitFunction:
End Function


'Blob Ƚѹ
' CorSigUncompressData = ѹȣLength = ȱʶֽڳȣǷ > &H7F ַʶ
'ÿݿͷ1ݿ飬ͨλ㣬ݿʵʳ
'һֽλΪ0ݿ鳤Ϊ1ֽ
'һֽλΪ10ݿ鳤Ϊ2ֽ
'һֽλΪ110ݿ鳤Ϊ4ֽ
Private Function CorSigUncompressData(FN As Variant,ByVal Index As Long,Length As Long,ByVal Mode As Long,Optional CodePage As Long) As Integer
	Length = 0
	ReDim Bytes(0) As Byte
	Bytes = GetBytes(FN,4,Index,Mode)
	If (Bytes(0) And &H80) = 0 Then
		CorSigUncompressData = 1
		Length = Bytes(0)
	ElseIf (Bytes(0) And &HC0) = &H80 Then
		CorSigUncompressData = 2
		Length = SHL((Bytes(0) And &H3F),8) Or Bytes(1)
	ElseIf (Bytes(0) And &HE0) = &HC0 Then
		CorSigUncompressData = 4
		Length = SHL((Bytes(0) And &H1F),24) Or SHL(CLng(Bytes(1)),16) Or SHL(CLng(Bytes(2)),8) Or Bytes(3)
	End If
	Select Case CodePage
	Case CP_UNICODELITTLE,CP_UNICODEBIG,CP_UTF32LE,CP_UTF32BE
		CorSigUncompressData = CorSigUncompressData * 2
		Length = Length * 2
	End Select
	Exit Function

    If Bytes(0) = 0 Then
		CorSigUncompressData = 1
		Length = 0
	ElseIf ((Bytes(0) And &HC0) = &HC0) And ((Bytes(0) And &H20) = 0) Then
		CorSigUncompressData = 4
		Length = SHL((Bytes(0) And &H1F),24) Or SHL(CLng(Bytes(1)),16) Or SHL(CLng(Bytes(2)),8) Or Bytes(3)
	ElseIf ((Bytes(0) And &H80) = &H80) And ((Bytes(0) And &H40) = 0) Then
		CorSigUncompressData = 2
		Length = SHL((Bytes(0) And &H3F),8) Or Bytes(1)
	Else
		CorSigUncompressData = 1
		Length = Bytes(0) And &H7F
	End If
End Function


'õַбתַ(ִ)
'Mode = 0 'õַбתַ
'Mode = 1 'ôбתַ
'Mode = 2 'õִַбתַ
'Mode = 3 ' ID תַ飬ڵļͷļ
'Mode > 3 'ͷ ID תַ飬ڵļͷͶļͷļ
Private Function RefList2StrList(strData As STRING_SUB_PROPERTIE,ByVal Mode As Integer,Optional ByVal MoveVal As Integer) As String()
	Dim i As Long
	With strData
		If .lReferenceNum = 0 Then
			ReDim TempList(0) As String
		Else
			ReDim TempList(.lReferenceNum - 1) As String
			Select Case Mode
			Case 0
				For i = 0 To .lReferenceNum - 1
					TempList(i) = CStr$(.Reference(i).lAddress + MoveVal)
				Next i
			Case 1
				For i = 0 To .lReferenceNum - 1
					TempList(i) = .Reference(i).sCode
				Next i
			Case 2
				For i = 0 To .lReferenceNum - 1
					TempList(i) = CStr$(.Reference(i).StrType)
				Next i
			Case 3
				For i = 0 To .lReferenceNum - 1
					TempList(i) = CStr$(.Reference(i).inSecID)
				Next i
			Case Else
				For i = 0 To .lReferenceNum - 1
					TempList(i) = CStr$(.Reference(i).inHeadID) & "+" & CStr$(.Reference(i).inSecID)
				Next i
			End Select
		End If
		RefList2StrList = TempList
	End With
End Function


'ļ ID бתб
Private Function SecIDListToNameList(SecIDList() As String,AllSecNameList() As String) As String()
	Dim i As Integer,j As Long,k As Integer,Dic As Object
	ReDim TempList(UBound(SecIDList)) As String
	If StrToLong(SecIDList(0),-1) > -1 Then
		For i = 0 To UBound(SecIDList)
			j = StrToLong(SecIDList(i),-1)
			If j > -1 Then
				TempList(k) = AllSecNameList(j)
				k = k + 1
			End If
		Next i
	Else
		ReDim TempArray(UBound(AllSecNameList)) As String
		Set Dic = CreateObject("Scripting.Dictionary")
		For i = 0 To UBound(AllSecNameList)
			If InStr(AllSecNameList(i),"-") Then
				TempArray(i) = ReSplit(AllSecNameList(i),"-",2)(0)
				If Not Dic.Exists(TempArray(i)) Then
					Dic.Add(TempArray(i),i)
				End If
				TempArray(i) = ReSplit(AllSecNameList(i),"-",2)(1)
			End If
		Next i
		If Dic.Count > 0 Then
			For i = 0 To UBound(SecIDList)
				If Dic.Exists(SecIDList(i)) Then
					TempList(k) = TempArray(Dic.Item(SecIDList(i)))
					k = k + 1
				End If
			Next i
		End If
	End If
	Set Dic = Nothing
	If k > 0 Then k = k - 1
	ReDim Preserve TempList(k) As String
	SecIDListToNameList = TempList
End Function


'λʾ
Private Function IndentDisplay(ByVal StrText As String,ByVal MaxDigit As Long,Optional ByVal MarkChar As String) As String
	IndentDisplay = StrText
	If Len(StrText) < MaxDigit Then Exit Function
	If MarkChar <> "" Then
		Dim i As Integer
		i = InStr(StrText,MarkChar)
		If i < 1 Or i > MaxDigit Then Exit Function
		IndentDisplay = Left$(StrText,i) & "..." & Right$(StrText,MaxDigit - Len(Left$(StrText,i)))
	Else
		If MaxDigit < 2 Then Exit Function
		IndentDisplay = Left$(StrText,MaxDigit \ 2) & "..." & Mid$(StrText,Len(StrText) - MaxDigit \ 2 - 3)
	End If
End Function


'Ϣַ
Private Function GetMsgList(MsgList() As String,ByVal Language As String) As Boolean
	Dim i As Integer
	ReDim MsgList(152) As String
	On Error GoTo errHandle
	Language = LCase$(Language)
	Select Case Language
	Case "chs","0804","1004"
		MsgList(0) = ""
		MsgList(1) = "\r\n\r\n޷У˳"
		MsgList(2) = "\r\n\r\nҪг"
		MsgList(3) = "\r\n\r\n򽫼С"
		MsgList(4) = "޷ļȷļ·ļǷԵַ\r\n" & _
					"ע⣺Passolo 2015 汾ĺ޷ʶַļ·ļ"
		MsgList(5) = "ϵĴ\r\n: %d: %v\r\n" & _
					" Passolo ԣ򱨸ߡ"
		MsgList(6) = "ļȱ [%s] ڡ\r\n%d"
		MsgList(7) = "ļȱ [%s] ֵ\r\n%d"
		MsgList(8) = "ļݲȷ\r\n%s"
		MsgList(9) = "ļڣԡ\r\n%s"
		MsgList(10) = "ļ汾Ϊ %dҪİ汾Ϊ %v\r\n%s"
		MsgList(11) = "ϵͳȱ ""%s"" \r\n: %d: %v"

		MsgList(12) = " - 汾 %v ( %b)"
		MsgList(13) = "..."
		MsgList(14) = "Dec"
		MsgList(15) = "Hex"
		MsgList(16) = ""
		MsgList(17) = ""
		MsgList(18) = "RVA"
		MsgList(19) = "ʵַ"
		MsgList(20) = ""
		MsgList(21) = ""
		MsgList(22) = " (%s):"
		MsgList(23) = ""

		MsgList(24) = "δ֪;Not PE;PE32;PE64;MAC32;MAC64;Android"
		MsgList(25) = ""
		MsgList(26) = ""
		MsgList(27) = "ļ"
		MsgList(28) = "ļͷ"
		MsgList(29) = " PE ļ"
		MsgList(30) = ""
		MsgList(31) = "汾 %v ( %b)\r\n" & _
					"OS 汾: Windows XP/2000 \r\n" & _
					"Passolo 汾: Passolo 5.0 \r\n" & _
					"Ȩ: \r\n" & _
					"ַ: http://www.hanzify.org\r\n" & _
					": wanfu (2015 - 2019)\r\n" & _
					"E-mail: z_shangyi@163.com"
		MsgList(32) = ""
		MsgList(33) = "ִļ (*.exe;*.dll;*.ocx)|*.exe;*.dll;*.ocx|ļ (*.*)|*.*||"
		MsgList(34) = "ѡļ"
		MsgList(35) = ", Ժ..."
		MsgList(36) = "ļ: %p\r\nOffset: %o, RVA: %r\r\n%s"

		MsgList(37) = "================================================"
		MsgList(38) = "\tDec ַ\tHex ַ\t\tĿ¼\tô"
		MsgList(39) = "#%no\t%da\t%ha\t%sc\t%dc\t%rc"
		MsgList(40) = "ĵַǷ"
		MsgList(41) = "ĵַļĳȡ"
		MsgList(42) = "Χ"
		MsgList(43) = "Ŀ¼"
		MsgList(44) = "Ŀ¼"
		MsgList(45) = "Դ"
		MsgList(46) = "쳣"
		MsgList(47) = "ȫ"
		MsgList(48) = "ضλ"
		MsgList(49) = ""
		MsgList(50) = "Ȩ"
		MsgList(51) = "ֵ"
		MsgList(52) = "̱߳ش洢"
		MsgList(53) = "Ŀ¼"
		MsgList(54) = ""
		MsgList(55) = "ַ"
		MsgList(56) = "ӳٵ"
		MsgList(57) = "COM "
		MsgList(58) = ""
		MsgList(59) = "Ϣ"
		MsgList(60) = "밴ִԭʼַãȻµַԼµô롣"
		MsgList(61) = "õִ޷µַô롣"
		MsgList(62) = "ȡ"
		MsgList(63) = ""
		MsgList(64) = "Ӣ;;"
		MsgList(65) = "enu;chs;cht"
		MsgList(66) = "ļϢ"
		MsgList(89) = "Ϣ - %s"

		MsgList(90) = "ļͷ\t%s"
		MsgList(91) = "============ ļϢ ============\r\n"
		MsgList(92) = "ļƣ\t%s"
		MsgList(93) = "ļ·\t%s"
		MsgList(94) = "ļ˵\t%s"
		MsgList(95) = "ļ汾\t%s"
		MsgList(96) = "Ʒƣ\t%s"
		MsgList(97) = "Ʒ汾\t%s"
		MsgList(98) = "ȨУ\t%s"
		MsgList(99) = "ļС\t%s ֽ"
		MsgList(100) = "ڣ\t%s"
		MsgList(101) = "޸ڣ\t%s"
		MsgList(102) = "ԣ\t%s"
		MsgList(103) = "  ̣\t%s"
		MsgList(104) = "ԭʼļ\t%s"
		MsgList(105) = "ڲļ\t%s"
		MsgList(106) = "ļͣ\t%s"
		MsgList(107) = "ӳַ\t%s"
		MsgList(108) = "Ϣ (%s)"
		MsgList(109) = "ַ\t\tʼַ\tַ\tֽڴС"
		MsgList(110) = "%s!1!\t%s!2!\t%s!4!\t%s!5!\t%s!6!"
		MsgList(111) = "================================="
		MsgList(112) = "ļƫƵַ"
		MsgList(113) = "ַ"
		MsgList(114) = ""
		MsgList(115) = ""
		MsgList(116) = "δ֪"
		MsgList(117) = ""
		MsgList(118) = "Ŀ¼Ϣ (ļƫƵַ)"
		MsgList(119) = "Ŀ¼\t\tʼַ\tַ\tֽڴС"
		MsgList(120) = "Ŀ¼"
		MsgList(121) = "Ŀ¼"
		MsgList(122) = "ԴĿ¼"
		MsgList(123) = "쳣Ŀ¼"
		MsgList(124) = "ȫĿ¼"
		MsgList(125) = "ַضλ"
		MsgList(126) = "Ŀ¼"
		MsgList(127) = "ȨĿ¼"
		MsgList(128) = "ֵ(GP RVA)"
		MsgList(129) = "̱߳ش洢"
		MsgList(130) = "Ŀ¼"
		MsgList(131) = "󶨵Ŀ¼"
		MsgList(132) = "ַ"
		MsgList(133) = "ӳټص"
		MsgList(134) = "COM п־"
		MsgList(135) = "Ŀ¼"
		MsgList(136) = "쳣"
		MsgList(137) = ""
		MsgList(138) = ".NET CLR Ŀ¼Ϣ (ļƫƵַ)"
		MsgList(139) = "Ŀ¼\t\tʼַ\tַ\tֽڴС"
		MsgList(140) = "Ԫ(MetaData)"
		MsgList(141) = "йԴ"
		MsgList(142) = "ǿǩ"
		MsgList(143) = ""
		MsgList(144) = "(V-)"
		MsgList(145) = "תַ"
		MsgList(146) = "йܱӳͷ"
		MsgList(147) = ".NET MetaData Ϣ (ļƫƵַ)"
		MsgList(148) = "\t\tʼַ\tַ\tֽڴС"
		MsgList(149) = " PE ļ"
		MsgList(150) = "PE(%s)"
		MsgList(151) = "ַ\t\t\t\tʼַ\tַ\tֽڴС"
		MsgList(152) = "%s!1!\t%s!2!\t%s!3!\t\t%s!4!\t%s!5!\t%s!6!"
	Case "cht","0404","0c04","1404"
		MsgList(0) = "~"
		MsgList(1) = "\r\n\r\n{Lk~ANC"
		MsgList(2) = "\r\n\r\nn~{ܡH"
		MsgList(3) = "\r\n\r\n{N~C"
		MsgList(4) = "Lk}ɮסAнT{ɮ׸|MɮצWO_]tȬwyrC\r\n" & _
					"`NGPassolo 2015 Lkѥ]tȬwyrɮ׸|MɮצWC"
		MsgList(5) = "o͵{]pW~C\r\n~NX: %dA~yz: %v\r\n" & _
					"ЭsҰ Passolo AաAγin}o̡C"
		MsgList(6) = "UCɮפʤ [%s] `C\r\n%d"
		MsgList(7) = "UCɮפʤ [%s] ȡC\r\n%d"
		MsgList(8) = "UCɮתeTC\r\n%s"
		MsgList(9) = "UCɮפsbIˬdAաC\r\n%s"
		MsgList(10) = "UCɮת %dAݭnܤ֬ %vC\r\n%s"
		MsgList(11) = "ztίʤ ""%s"" AȡC\r\n~NX: %dA~yz: %v"

		MsgList(12) = "ѷӷj -  %v (c %b)"
		MsgList(13) = "..."
		MsgList(14) = "Dec"
		MsgList(15) = "Hex"
		MsgList(16) = ""
		MsgList(17) = ""
		MsgList(18) = "RVA"
		MsgList(19) = "}"
		MsgList(20) = "NXp"
		MsgList(21) = "j"
		MsgList(22) = "ѷ (%s):"
		MsgList(23) = "ƻs"

		MsgList(24) = ";Not PE;PE32;PE64;MAC32;MAC64;Android"
		MsgList(25) = "LϬq"
		MsgList(26) = "ðϬq"
		MsgList(27) = "WXɮ"
		MsgList(28) = "ɮY"
		MsgList(29) = "l PE ɮ"
		MsgList(30) = "Lѷ"
		MsgList(31) = " %v (c %b)\r\n" & _
					"OS : Windows XP/2000 ΥHW\r\n" & _
					"Passolo : Passolo 5.0 ΥHW\r\n" & _
					"v: KOn\r\n" & _
					"}: http://www.hanzify.org\r\n" & _
					"@: wanfu (2015 - 2019)\r\n" & _
					"E-mail: z_shangyi@163.com"
		MsgList(32) = "ѷӷj"
		MsgList(33) = "iɮ (*.exe;*.dll;*.ocx)|*.exe;*.dll;*.ocx|Ҧɮ (*.*)|*.*||"
		MsgList(34) = "ɮ"
		MsgList(35) = "bjѷ, еy..."
		MsgList(36) = "ɮ: %p\r\nOffset: %o, RVA: %r\r\n%s"

		MsgList(37) = "================================================"
		MsgList(38) = "Ǹ\tDec }\tHex }\tϬq\tؿ\tѷӥNX"
		MsgList(39) = "#%no\t%da\t%ha\t%sc\t%dc\t%rc"
		MsgList(40) = "J}DkC"
		MsgList(41) = "J}WLɮתסC"
		MsgList(42) = "d~"
		MsgList(43) = "ץXؿ"
		MsgList(44) = "פJؿ"
		MsgList(45) = "귽"
		MsgList(46) = "`"
		MsgList(47) = "w"
		MsgList(48) = "w򥻪"
		MsgList(49) = "E_"
		MsgList(50) = "v"
		MsgList(51) = ""
		MsgList(52) = "sx"
		MsgList(53) = "J]wؿ"
		MsgList(54) = "jwJ"
		MsgList(55) = "פJ}"
		MsgList(56) = "פJ"
		MsgList(57) = "COM yz"
		MsgList(58) = "Od"
		MsgList(59) = "T"
		MsgList(60) = "Ыrꪺl}jѷ, MJs}HpsѷӥNXC"
		MsgList(61) = "LѷӪr, Lkps}ѷӥNXC"
		MsgList(62) = ""
		MsgList(63) = "y"
		MsgList(64) = "^y;²餤;餤"
		MsgList(65) = "enu;chs;cht"
		MsgList(66) = "ɮװT"
		MsgList(89) = "T - %s"

		MsgList(90) = "ɮYơG\t%s"
		MsgList(91) = "============ ɮװT ============\r\n"
		MsgList(92) = "ɮצW١G\t%s"
		MsgList(93) = "ɮ׸|G\t%s"
		MsgList(94) = "ɮ׻G\t%s"
		MsgList(95) = "ɮתG\t%s"
		MsgList(96) = "~W١G\t%s"
		MsgList(97) = "~G\t%s"
		MsgList(98) = "vҦG\t%s"
		MsgList(99) = "ɮפjpG\t%s 줸"
		MsgList(100) = "إߤG\t%s"
		MsgList(101) = "קG\t%s"
		MsgList(102) = "y@@G\t%s"
		MsgList(103) = "} o ӡG\t%s"
		MsgList(104) = "lɮצWG\t%s"
		MsgList(105) = "ɮצWG\t%s"
		MsgList(106) = "ɮG\t%s"
		MsgList(107) = "M}G\t%s"
		MsgList(108) = "ϬqT (%s)G"
		MsgList(109) = "}O\tϬqW\t}l}\t}\t줸դjp"
		MsgList(110) = "%s!1!\t%s!2!\t%s!4!\t%s!5!\t%s!6!"
		MsgList(111) = "================================="
		MsgList(112) = "ɮװ}"
		MsgList(113) = "۹}"
		MsgList(114) = "N"
		MsgList(115) = ""
		MsgList(116) = ""
		MsgList(117) = "i"
		MsgList(118) = "ƥؿT (ɮװ})G"
		MsgList(119) = "ؿW\tҦbϬq\t}l}\t}\t줸դjp"
		MsgList(120) = "ץXؿ"
		MsgList(121) = "פJؿ"
		MsgList(122) = "귽ؿ"
		MsgList(123) = "`ؿ"
		MsgList(124) = "wؿ"
		MsgList(125) = "}w"
		MsgList(126) = "E_ؿ"
		MsgList(127) = "vؿ"
		MsgList(128) = "(GP RVA)"
		MsgList(129) = "sx"
		MsgList(130) = "J]wؿ"
		MsgList(131) = "jwפJؿ"
		MsgList(132) = "פJ}"
		MsgList(133) = "JפJ"
		MsgList(134) = "COM wX"
		MsgList(135) = "Odؿ"
		MsgList(136) = "`"
		MsgList(137) = "sb"
		MsgList(138) = ".NET CLR ƥؿT (ɮװ})G"
		MsgList(139) = "ؿW\tҦbϬq\t}l}\t}\t줸դjp"
		MsgList(140) = "~(MetaData)"
		MsgList(141) = "޸귽"
		MsgList(142) = "jWñW"
		MsgList(143) = "NX޲z"
		MsgList(144) = "(V-)"
		MsgList(145) = "DץX}"
		MsgList(146) = "ޥMY"
		MsgList(147) = ".NET MetaData ƬyT (ɮװ})G"
		MsgList(148) = "ƬyW\tҦbϬq\t}l}\t}\t줸դjp"
		MsgList(149) = "D PE ɮ"
		MsgList(150) = "lPE(%s)"
		MsgList(151) = "}O\tqW\t`W\t\t}l}\t}\t줸դjp"
		MsgList(152) = "%s!1!\t%s!2!\t%s!3!\t\t%s!4!\t%s!5!\t%s!6!"
	Case Else
		MsgList(0) = "Error"
		MsgList(1) = "\r\n\r\nThe program cannot continue and will exit."
		MsgList(2) = "\r\n\r\nDo you want to continue?"
		MsgList(3) = "\r\n\r\nThe program will continue to run."
		MsgList(4) = "Unable to open the file. Please verify the file path and file name" & _
					"contains characters in Asian languages.\r\n" & _
					"Note: Passolo 2015 Version of the macro engine does not recognize" & _
					"the file path and file name contains Asian language characters."
		MsgList(5) = "An Error occurred in the program design.\r\nError Code: %d, Content: %v\r\n" & _
					"Please restart the Passolo try and please report to the software developer."
		MsgList(6) = "The following file is missing [%s] section.\r\n%d"
		MsgList(7) = "The following file is missing [%s] Value.\r\n%d"
		MsgList(8) = "The following contents of the file is not correct.\r\n%s"
		MsgList(9) = "The following file does not exist! Please check and try again.\r\n%s"
		MsgList(10) = "The following file version is %d, requires version at least %v.\r\n%s"
		MsgList(11) = "Your system is missing %s server.\r\nError Code: %d, Content: %v"

		MsgList(12) = "Reference Search - Version %v (Build %b)"
		MsgList(13) = "..."
		MsgList(14) = "Dec"
		MsgList(15) = "Hex"
		MsgList(16) = "Type"
		MsgList(17) = "About"
		MsgList(18) = "RVA"
		MsgList(19) = "Offset"
		MsgList(20) = "Code Calculate"
		MsgList(21) = "Search"
		MsgList(22) = "References (%s):"
		MsgList(23) = "Copy"

		MsgList(24) = "Unknown;Not PE;PE32;PE64;MAC32;MAC64;Android"
		MsgList(25) = "No Section"
		MsgList(26) = "Hide Section"
		MsgList(27) = "Outside File"
		MsgList(28) = "File Header"
		MsgList(29) = "Sub PE File"
		MsgList(30) = "No References"
		MsgList(31) = "Version: %v (Build %b)\r\n" & _
					"OS Version: Windows XP/2000 or higher\r\n" & _
					"Passolo Version: Passolo 5.0 or higher\r\n" & _
					"License: Freeware\r\n" & _
					"HomePage: http://www.hanzify.org\r\n" & _
					"Author: wanfu (2015 - 2019)\r\n" & _
					"E-mail: z_shangyi@163.com"
		MsgList(32) = "About Reference Search"
		MsgList(33) = "Executable file (*.exe;*.dll;*.ocx)|*.exe;*.dll;*.ocx|All file (*.*)|*.*||"
		MsgList(34) = "Select file"
		MsgList(35) = "Searching references, please wait..."
		MsgList(36) = "File: %p\r\nOffset: %o, RVA: %r\r\n%s"

		MsgList(37) = "================================================"
		MsgList(38) = "No.\tDec Offset\tHex Offset\tSection\tDirectory\tRef Code"
		MsgList(39) = "#%no\t%da\t%ha\t%sc\t%dc\t%rc"
		MsgList(40) = "Address entered is illegal."
		MsgList(41) = "Address entered exceeds the length of this file."
		MsgList(42) = "Outside"
		MsgList(43) = "Export"			'Ŀ¼
		MsgList(44) = "Import"			'Ŀ¼
		MsgList(45) = "Resource"		'ԴĿ¼
		MsgList(46) = "Exception"		'쳣Ŀ¼
		MsgList(47) = "Security"		'ȫĿ¼
		MsgList(48) = "Basereloc"		'ضλ
		MsgList(49) = "Debug"			'Ŀ¼
		MsgList(50) = "Copyright"		'X86ʹ-
		MsgList(51) = "Globalptr"		'ֵ(Mips GP), RVA Of Globalptr
		MsgList(52) = "TLS"				'̱߳ش洢(Thread Local Storage,Tls)Ŀ¼
		MsgList(53) = "Load Config"		'Ŀ¼
		MsgList(54) = "Bound Import"	'(Bound Import Directory in Headers)
		MsgList(55) = "IAT"				'ַ
		MsgList(56) = "Delay Import"	'Delay Load Import Descriptors
		MsgList(57) = "COM Descriptor"	'COM б־
		MsgList(58) = "Reserved"		'
		MsgList(59) = "Message"
		MsgList(60) = "Please search for reference by the original address of the string, and then enter a new address to calculate the new reference code."
		MsgList(61) = "String is not referenced, reference code for the new address cannot be calculated."
		MsgList(62) = "Cancel"
		MsgList(63) = "Language"
		MsgList(64) = "EngLish;Chinese Simplified;Chinese Traditional"
		MsgList(65) = "enu;chs;cht"
		MsgList(66) = "File Info"
		MsgList(89) = "Information - %s"

		MsgList(90) = "File Header Number\t%s"
		MsgList(91) = "============ File Information ============\r\n"
		MsgList(92) = "File Name:\t%s"
		MsgList(93) = "File Path:\t\t%s"
		MsgList(94) = "Description:\t%s"
		MsgList(95) = "Version:\t\t%s"
		MsgList(96) = "Product Name:\t%s"
		MsgList(97) = "Product Version:\t%s"
		MsgList(98) = "Legal Copyright:\t%s"
		MsgList(99) = "File Size:\t\t%s bytes"
		MsgList(100) = "Date Created:\t%s"
		MsgList(101) = "Date Modified:\t%s"
		MsgList(102) = "Language:\t%s"
		MsgList(103) = "Company Name:\t%s"
		MsgList(104) = "Original File Name:\t%s"
		MsgList(105) = "Internal File Name:\t%s"
		MsgList(106) = "File Type:\t\t%s"
		MsgList(107) = "Image Base:\t%s"
		MsgList(108) = "Section Information (%s):"
		MsgList(109) = "Address Category\tSection Name\tStart Address\tEnd Address\tByte Size"
		MsgList(110) = "%s!1!\t\t%s!2!\t%s!4!\t%s!5!\t%s!6!"
		MsgList(111) = "====================================="
		MsgList(112) = "Offset"
		MsgList(113) = "RVA"
		MsgList(114) = "Any"
		MsgList(115) = "Hide"
		MsgList(116) = "Unknown"
		MsgList(117) = "Not Available"
		MsgList(118) = "Data Directory Information (offset):"
		MsgList(119) = "Directory Name\t\t\tIn Section\tStart Address\tEnd Address\tByte Size"
		MsgList(120) = "Export Directory\t"
		MsgList(121) = "Import Directory\t"
		MsgList(122) = "Resource Directory\t"
		MsgList(123) = "Exception Directory\t"
		MsgList(124) = "Security Directory\t"
		MsgList(125) = "Base Relocation Table"
		MsgList(126) = "Debug Directory\t"
		MsgList(127) = "Copyright\t\t"
		MsgList(128) = "RVA of GP\t"
		MsgList(129) = "TLS Directory\t"
		MsgList(130) = "Load Configuration Directory"
		MsgList(131) = "Bound Import Directory"
		MsgList(132) = "Import Address Table"
		MsgList(133) = "Delay Load Import Descriptor"
		MsgList(134) = "COM Runtime Descriptor"
		MsgList(135) = "Reserved Directory\t"
		MsgList(136) = "Exception"
		MsgList(137) = "Not Exist"
		MsgList(138) = ".NET CLR Data Directory Information (offset):"
		MsgList(139) = "Directory Name\t\t\tIn Section\tStart Address\tEnd Address\tByte Size"
		MsgList(140) = "Meta Data\t"
		MsgList(141) = "Managed Resource\t"
		MsgList(142) = "Strong Name Signature"
		MsgList(143) = "Code Manager Table"
		MsgList(144) = "V-Table Fixups\t"
		MsgList(145) = "Export Address Table Jumps"
		MsgList(146) = "Managed Native Heade"
		MsgList(147) = ".NET MetaData iStreams Information (offset):"
		MsgList(148) = "Stream Name\tIn Section\tStart Address\tEnd Address\tByte Size"
		MsgList(149) = "Not PE File"
		MsgList(150) = "Sub PE(%s)"
		MsgList(151) = "Address Category\tSegment Name\tSection Name\tStart Address\tEnd Address\tByte Size"
		MsgList(152) = "%s!1!\t\t%s!2!\t\t%s!3!\t\t%s!4!\t%s!5!\t%s!6!"
	End Select
	For i = 0 To UBound(MsgList)
		Select Case Language
		Case "chs","0804","1004"
			MsgList(i) = PSL.ConvertASCII2Unicode(MsgList(i),CP_CHINA)
		Case "cht","0404","0C04","1404"
			MsgList(i) = PSL.ConvertASCII2Unicode(MsgList(i),CP_TAIWAN)
		End Select
		If InStr(MsgList(i),"\\") Then MsgList(i) = Replace$(MsgList(i),"\\","*a!N!d*")
		If InStr(MsgList(i),"\r\n") Then MsgList(i) = Replace$(MsgList(i),"\r\n",vbCrLf)
		If InStr(MsgList(i),"\t") Then MsgList(i) = Replace$(MsgList(i),"\t",vbTab)
		If InStr(MsgList(i),"*a!N!d*") Then MsgList(i) = Replace$(MsgList(i),"*a!N!d*","\")
	Next i
	GetMsgList = True
	Exit Function
	errHandle:
	ReDim MsgList(0) As String
End Function
